function [expr_ok] = verify_logic(expr)
% controling that the logical expression expr is logicaly correct

% input: expr built in run_distinct_combi
% output: expr_ok = 1 if expr is logicaly OK,  <= 0 otherwised

% BEWARE Matlab logic evaluation is wrong as 
% T | T & F is F instaed of T. The order for and before or is NOT ok
% fortunately for program Calculator handles it correctly 
% and the verification with eval concludes OK as all we care is the possible evaluation

% for debugging purpose, you can trail the value of expr_ok to the erroneous step
% but unused by Calculator that only worries about ok not_ok

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

expr_ok = 1;
expr = strrep(expr,'and',' & ');
expr = strrep(expr,'or','| ');
expr = strrep(expr,'not',' ~ ');

% replacing variables lables by a true logical value
beg_bp    = findstr(expr,'<');
end_bp    = findstr(expr,'>');

% verifivation bp and $ are well paired
if length(beg_bp) == 0 | length(beg_bp) ~= length(end_bp)
	expr_ok = -1;
else		
	if min(end_bp - beg_bp) <= 0
		expr_ok = -2;
		if length(beg_bp) > 1
			if min(beg_bp(2:length(beg_bp)) - end_bp(1:length(beg_bp)-1)) <= 0
				expr_ok = -3;
			end
		end
	end
	if expr_ok 
		% so the varibales are OK
		% we replace them by a simple value x where x = 1;
		for i = 1:length(beg_bp)
			expr(beg_bp(i):end_bp(i)) = ' ';
			expr(beg_bp(i)) = 'x';
		end
		% we just try to eval it . If ok, no problem, 
		% if not OK, excecute second instruction
		x = 1;
		eval( strcat(expr,' ;'),'expr_ok = -4;');
	end
end


	
