function [expr,list_bbf_unique,list_bbf_labels,expr_ok] = translating_request(expr)
% translating the expression fed in into an expr that eval understand
% it means using bitand, bitor and bitcmp.

% expr is made of the list of logical operaotrs and bp's 
% bp is represented by <n.x.y.z> where n is its number, 
% x the belief index, y the bp index, z the form index.

% expr1 = <a> and (<b> or <c>) is the same as expr2 = <a> and <b> or <a> and <c>
% allowed: diff bp in same bel number. ( <12.12.1.1> or <12.12.2.1> or <12.12.3.1> ) and <24.27.2.1>

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%
global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global length_one_focal % space needed for one B(:,:,jj)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% finding the involved bp's
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% % % these are so that we get back to initial program
% % % they were added to simplify the control of the logical expression

temp_expr = strcat('[',expr,']');
temp_expr = strrep(temp_expr,'>',' ');
temp_expr = strrep(temp_expr,'<',' ');
temp_expr = strrep(temp_expr,'and','   ');
temp_expr = strrep(temp_expr,'or','  ');
temp_expr = strrep(temp_expr,'not','   ');
temp_expr = strrep(temp_expr,'(',' ');
temp_expr = strrep(temp_expr,')',' ');
temp_expr = strrep(temp_expr,'.',' ');

% only left over the   n x y z   which are belief_number, belief_index, bp_index , form_index
list_bbf = eval(temp_expr); % we just get a list of numbers
list_bbf = reshape(  list_bbf,4,length(list_bbf)/4)'; % the matrix with the quadruples n x y z
% bp are listed as [n1 x1 y1 z1; n2 x2 y2 z2 ; ...]

% eliminating duplicates
list_bbf_unique = unique(list_bbf,'rows') ;

[nbr_bp useless] = size(list_bbf_unique);  % there are at least 9 char for one <n.x.y.z>
for i = 1:nbr_bp
	
	% max nbr bel = 99 !!!!
	
	% Building an expression for eval bit B explicit	
	% I may not use () here as they mean something for the logic al expression
	% so I put [ and ], to be replaced later
	
	ln = num2str(i);
	if length(ln) == 1   
		ln = [ln,' '];
	end
	list_bbf_labels(i,:) = ['B[:,:,',ln,']']; 
	list_bbf_unique(i,5) = 100000000*list_bbf_unique(i,2) + ...
	10000*list_bbf_unique(i,3) + list_bbf_unique(i,4); % Ni = easier to locate later	
end

% list_bbf_unique are the bp's really involved without repetitions
% listed as [n1 x1 y1 z1 N1; n2 x2 y2 z2 N2; ...]
% where 	belief(x1).number = x1
%			belief(x1).bp(y1).form(z1) is used
%			N1 is a  number with x1,y1,z1

% list_bbf_labels are the labels B(:,:,ii), 9 characters 
% We create this B.... matrix for the eval programs.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% verifying expr is logically correct (no typing error, sequence correct)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[expr_ok] = verify_logic(expr);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% If expr is logically correct, we build its evaluable form
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if expr_ok == 1  
	% expr is OK from a logical point of view
	xbeg_n = find(expr == '<');
	xend_n = find(expr == '>');
	expr(xbeg_n) = ' ';
	expr(xend_n) = ' ';	
	% <> were added to simplify the control of the logical expression
	% not needed anymore
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% replacing bp names by B[:,:,ii]
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% normalizing (same length) bp names, and more ' '
	i = 1;
	expr(length(expr)+1) = ' ';	% so we are protected against a potential crash
	for ii = 1:length(xbeg_n)
		i = xbeg_n(ii);
		j = xend_n(ii);
		% i+1 is a digit and j-1 is a space , i was <, j was >
		in = strrep(expr(i:j),'.',' ') ;
		index = eval(strcat('[',in,']')) ;
		nind = find( [list_bbf_unique(:,5)] == 100000000*index(2)+10000*index(3)+index(4));
		expr(i:j) =' '; % blank replace var name
		expr(i:i+length_one_focal-1) = list_bbf_labels(nind,:); % var name replaced by B[:,:,jj]
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% handling the not
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% either not is followed by a parenthesis , or it is not followed by a parenthesis
	% in case 1, we put bitcmp( (...) ,nbr_bit_per_word)  
	% in case 2, we put bitcmp(  ...  ,nbr_bit_per_word)  
	
	expr = replace_not(expr);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% handling the and or
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% we consider the 4 cases
	% ...) and          B[...] and
	% and B[...]        and (....
	
	expr = replace_andor(expr,'and');
	expr = replace_andor(expr,'or');
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% correcting the XX with or and the {} with () AND into and and OR into OR
	% and rebuilding nbr_bit as b needed for detecting bitxxx
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	
	expr = strrep(expr,'{','(');
	expr = strrep(expr,'}',')');
	expr = strrep(expr,'[','(');
	expr = strrep(expr,']',')');
	expr = strrep(expr,'AND','and');
	expr = strrep(expr,'OR','or');
	expr = strrep(expr,'YYY_YYY_YYY_YYYY','nbr_bit_per_word'); % used in replace_not
	% expr is ready for being evaluated with eval
end
