function [X,L,V] = aftd(D)

% classical scaling of a distance matrix

% D = distance matrix
% X = (n,d) matrix of coordinates

%
%   Version : Apr 12,03
%   Copyright (c) 2002 by T. Denoeux
% 	Author: T. Denoeux
%

n = size(D,1);
Q=eye(n)-ones(n,n);

W=-0.5*Q*D.^2*Q;
[V,L]=eig(W);
L = diag(L);

ii=find(L>1e-6);
V=V(:,ii);
L=L(ii);
X=V.*sqrt(ones(n,1)*L');

