function para_evclus
% similarity = pl 2 objects sbelong to the same class

%
%   Version : Apr 12,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

% % % global nbr_bit_per_word
% % % nbr_bit_per_word = 50;
% to be eliminated once integrated in TBMLAB

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global flag_str gui_position  screen_size pathname2TBMLABvers
global memory_file_name

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% EvClus requires no objects so I clear all object global
% to see if there is already some objects, I check frame
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if length(frame)
	textnow = 'EvClus clears all TBMLAB objects. Can I clear them? Maybe you should save them first.';
	choice = text_with_n_buttons(gcf, textnow, {'OK','Cancel'}, [0 0 0 0])	
	if choice == 2
		return
	end
	clear_objects
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% show window with options parameters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% nbr_classes = 5; 
% lambda = .001;
% version = 1;
% load catcortex

k=0;
k=k+1;queries_in{k} = 'number of classes #';default_answer{k} = num2str(5);
k=k+1;queries_in{k} = 'lambda parameter #'; default_answer{k} = num2str(.001);
k=k+1;queries_in{k} = 'version #'; default_answer{k} = num2str(1);
k=k+1;queries_in{k} = 'list bba for every individual'; default_answer{k} = 'No';
[answer,choice] = dialog_queries(gcf,'EvClus options',queries_in,...
default_answer,[],[],2,[], [], [],[]);

if choice == 2
	return
else
	nbr_classes = str2num(answer{1});
	lambda = str2num(answer{2});
	version = str2num(answer{3});
	pr_option = 0;
	if ~strcmp(answer{4},'No')
		pr_option = 1;
	end

	% 	save_path1 = fullfile(pathname2TBMLABvers,'User_Data','Other_Data','');
	% 	cd(save_path1)
	% 	% open file
	% 	[fn,pathfn] = uigetfile('*.mat','Select file with dissimilarity data (binary file)');
	% 	if fn == 0 % I cancel
	% 		return
	% 	end
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	out = handling_files('open');
	fid = out{1};
	fn = memory_file_name.name;
	pathfn = memory_file_name.path;
	fn = strrep(fn,'.mat','')
	load([pathfn,fn])
	% a load refuse to work if I leave the .mat ad it adds it itself
	% if pathfn not present it gets losted
	name_mat = whos('-file',[pathfn,fn]);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	ind_mat(1) = 1;
	ind_sel = 1;
	
	% % % limited to ONE matrix by file so what is behind deleted
	% ind_mat = [];
	% 	if size(name_mat,2) == 1
	% 		ind_mat(1) = 1;
	% 	else
	% 		for i = 1:length(name_mat)
	% 			if length(name_mat(i).size) == 2
	% 				if name_mat(i).size(1) == name_mat(i).size(2)
	% 					ind_mat = [ind_mat i];
	% 				end
	% 			end
	% 		end
	% 		if length(ind_mat) == 0
	% 			% problem data wrong
	% 			hdw = warndlg('Your file does not contain any square matrix. Dissimilarity matrices MUST be square. I skip.');
	% 			uiwait(hdw)
	% 			return
	% 		elseif length(ind_mat) >= 2
	% 			for i = 1:length(ind_mat)
	% 				param{i} = name_mat(ind_mat(i)).name;
	% 			end		
	% 			figure('position',gui_position(:,5));
	% 			handle_list = listing_existing('general',gui_position(:,6),gcf,param);
	% 			set(handle_list(2),'min',0,'max',1,'value',[1],'enable','on');
	% 			textq = 'Your file contains several square matrices. Select the dissimilarity matrix';
	% 			choice = text_with_n_buttons(gcf, textq, {'Done','Cancel'}, [1]);
	% 			ind_sel = ind_mat(get(handle_list(2),'value'));
	% 			delete(gcf)
	% 			if choice == 2				
	% 				return
	% 			end		
	% 		end
	% 	end		
	
	eval(['D = ',name_mat(ind_sel).name,';']);
	
	if size(D,1) ~= size(D,2)
		hdw = warndlg('The dissimilarity matrix MUST be square. It is not the case. I skip');
		uiwait(hdw)
		return
	end
	nbr_indiv = size(D,1);
	if nbr_indiv < nbr_classes
		hdw = warndlg(['There are ',num2str( nbr_indiv),' individuals for ',num2str(nbr_classes),...
		' classes. There must be more individuals than classes. I skip']);
		uiwait(hdw)
		return		
	end

	% disimilarity matrix is in D
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% the variables
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% creating the frames	
	ind = make_empty('frame');	
	frame(ind).short_name='Cl';	
	frame(ind).full_name='classes';
	frame(ind).type = 'Classes_Un_ordered';
	frame(ind).cardinality = nbr_classes;
	for i = 1:nbr_classes
		elem{i} = ['C',num2str(i)];
	end
	frame(ind).elements = strvcat(elem);
	elem=[];	
	num_fr1 = frame(ind).number;
	useless = pin_manipulation('frame','all',[]);
	
	ind = make_empty('frame');	
	frame(ind).short_name='Indiv';	
	frame(ind).full_name='Individuals';
	frame(ind).type = 'Classes_Un_ordered';
	frame(ind).cardinality = nbr_indiv;
	for i = 1:nbr_indiv
		elem{i} = ['Ind'  num2str(i)];
	end
	frame(ind).elements = strvcat(elem);
	elem=[];	
	num_fr2 = frame(ind).number;	
	useless = pin_manipulation('frame','all',[]);
	
	% creating the structures
	ind = make_empty('structure');	
	structure(ind).full_name = 'SCl';
	structure(ind).short_name = 'SCl';
	structure(ind).most_refined = num_fr1;      
	num_str1 = structure(ind).number;
	useless = pin_manipulation('structure','all',[]);
	
	% creating the attributes
	ind = make_empty('attribute');	 					
	attribute(ind).full_name = 'ACl';   			
	attribute(ind).short_name = 'ACl';				
	attribute(ind).structure = num_str1;                   
	attribute(ind).index(1).name = 'Ind';
	attribute(ind).index(1).frame = num_fr2;
	num_att1 = attribute(ind).number;
	useless = pin_manipulation('attribute','all',[]);
	
	% creating the variables	
	for ii = 1:nbr_indiv
		i = make_empty('variable');	  
		variable(i).full_name = ['Class(',frame(num_fr2).elements(ii,:),')'];
		variable(i).short_name = ['Cl(',frame(num_fr2).elements(ii,:),')'];				
		variable(i).attribute = num_att1;
		variable(i).index_value = [ii];	 
		variable(i).frame = num_fr1;	
		num_var(ii) = variable(i).number;
		useless = pin_manipulation('variable','all',[]);
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% finding the bba
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	command_window('show')
	[mass foset] = evclus(D,nbr_classes,lambda,version);
	%	mass: mass assignment to each focal element, size (n,f), f = nb of focal elements
	%   foset: matrix (f,c) of focal elements (c = nbr classes)
	%      foset(i,j) = 1 if omega_j belongs to focal element i
	%                   0 otherwise
	command_window('hide')
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% storing results in belief object, m and BetP
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	nbr_foset = size(mass,2);
	for i = 1:size(foset,1)
		foc_vect(i,:) = long_bit2num(foset(i,:),nbr_classes);
	end

	for ii = 1:nbr_indiv	
		i = make_empty('belief');
		if ii == 1
			indiv1_mem = i;
		end
		m = mass(i,:)';	
		belief(i).full_name = ['BCl(Ind',num2str(ii),')'];
		belief(i).short_name = ['BCl(Ind',num2str(ii),')'];
		belief(i).computed = 'EvClus';		
		belief(i).domain_variable = [num_var(ii)] ;		% the domain can be a variable or a prodcutct of variables
		belief(i).domain_cardinality = [nbr_classes]; % list of cardinalities of the variables, same order
		% saving m
		useless = make_empty('bp',i);
		belief(i).bp(1).form(1).focal_sets = foc_vect;
		belief(i).bp(1).form(1).values = m;
		for jk = 1:length(m)
			belief(i).bp(1).form(1).log_expr{jk} = [];
		end
		% saving BetP		
		ind_for_P = make_empty('form',i,1);
		belief(i).bp(1).form(ind_for_P).type = 'BetP'; 
		belief(i).bp(1).form(ind_for_P).representation = 'ordered'; 
		belief(i).bp(1).form(ind_for_P).focal_sets = [];
		belief(i).bp(1).form(ind_for_P).values = get_BetP(i,1,1);
		for jk = 1:length(belief(i).bp(1).form(ind_for_P).values)
			belief(i).bp(1).form(ind_for_P).log_expr{jk} = [];
		end	
		% rebuild pin table for belief
		useless = pin_manipulation('belief','all',[]);
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% plot by multi dimensional scaling
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	[x,uselss1,useless2] = aftd(D); 
	% aftd 	= analyse factorielle sur tableaux de distances
	% 		= classical scaling
	
	% x are coordaonates of each individual in a 2 dim plot x(n,k) and I only use k = 1,2 (other useless)
	% plot them and put a color that represents the most BetP classe
	% one day, click on a individual and get its BetP on classes
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% preparing figure, menu
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	x1 = max(x);
	x2 = min(x);
	to = max([x1(1:2)]);
	from = min([x2(1:2)]);
	wt = to-from;
	from = from - .05*wt;
	to = to + .05*wt;
	
	% I use a figure outside TBMLAB figures as it MUST be square
	scr_size = screen_size;
	leng = scr_size(4) - 200;
	
	hd_fig = figure;
	set(hd_fig, 'position',[100 100 leng leng])
	k = 0;ind=1; % use only here
	k=k+1;hd_help_menu(ind,k) = uimenu('Label','File'); 
	k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,1),'Label','Quit','Callback','uiresume;');
	
	% adding a help
	switch computer
	case 'MAC2'
		hname = 'TBM Help';
	otherwise
		hname = 'Help';
	end
	flag_str = [];
	flag_str{1} = [];
	clb1 = 'callback_help_menu_bp(46,1);'; 
	k = 0;ind=2; % use only here
	k=k+1;hd_help_menu(ind,k) = uimenu('Label',hname); 
	k=k+1;hd_help_menu(ind,k) = uimenu(hd_help_menu(ind,1),'Label','Help','Callback',clb1);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% plotting data
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	pos_gr = [.05 .05 .9 .9];	
	
	hd_plot(1) = axes('parent',gcf,...
	'position',pos_gr,...
	'Xlim',[from to],...
	'Ylim',[from to],...
	'Box','on');
	title('Multidimensional scaling of the elements.');	
	
	% colors : nice up to 7 classes, above dubious colors??
	for i = 1:min(nbr_classes,7) 
		col(i,1:3) = num2bit(i-1,3);
	end
	if nbr_classes > 7
		for i = 8:nbr_classes
			w = rand(1);
			col(i,:) = w*col(fix(7*rand(1)+1),:) + (1-w)*col(fix(7*rand(1)+1),:);
		end
	end

	% plotting each individual as a number and a color (the class with largest BetP)
	indiv = indiv1_mem -1;
	if pr_option 
		fprintf(1,'\nDetails on individual data: individual_nbr, most_probale_class, bba\n',[]);
		if version == 0
			nbr_col = nbr_classes;
			fprintf(1,'Focal sets are the %3i singletons\n',[nbr_classes]);
		elseif version == 1
			nbr_col = nbr_classes + 2;
			fprintf(1,'Focal sets are the %3i singletons, then empty set, then universe\n',[nbr_classes]);
		else
			nbr_col = length(belief(indiv+1).bp(1).form(2).values);
			fprintf(1,'Focal sets are given by the next bit representations\n',[]);
			for i = 1:nbr_col
				fprintf(1,'%2i',[belief(indiv+1).bp(1).form(2).focal_sets(i,:)]);
				fprintf(1,'\n',[]);
			end
		end
		pr_format = '%3i %3i ';			
		for i = 1:nbr_col
			pr_format =[pr_format '%6.3f '];
		end
		pr_format = [pr_format '\n']; 					
	end
	for i = 1:nbr_indiv
		indiv = indiv + 1;
		[maxP i_max] = max([belief(indiv).bp(1).form(2).values]);
		text(x(i,1),x(i,2),num2str(i),'color',col(i_max,:));			
		if pr_option
			fprintf(1,pr_format,[i,i_max,belief(indiv).bp(1).form(1).values']);
		end
	end	

	drawnow			
	uiwait(gcf)
end
delete(hd_fig)


