function BetP = get_BetP(ind_bel,ind_pot,ind_for)
% building BetP frolm what is input

%
%   Version : Apr 12,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

% input is a form
% output is BetP
% ready only for input = m  XXXXXXXXXXXXX

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 

cardinal = prod([belief(ind_bel).domain_cardinality]);

switch belief(ind_bel).bp(ind_pot).form(ind_for).representation

case 'selected'
	
	switch belief(ind_bel).bp(ind_pot).form(ind_for).type
	case 'm'
		if cardinal < 12
			% building full vector m
			m_in = belief(ind_bel).bp(ind_pot).form(ind_for).values;
			foset = belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets;
			m = zeros(pow2(cardinal),1);
			for i = 1:length(m_in)
				m(foset(i,1)+1) = m_in(i);
			end		
			BetP = fmt(m,'m','betp','n');			
		else
			% allocate masses one by one 
			m_in = belief(ind_bel).bp(ind_pot).form(ind_for).values;
			foset = belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets;
			BetP = zeros(cardinal,1);
			for i = 1:length(m_in)
				onbits = lond_num2onbit(foset(i,:),cardinal);
				if length(onbits)
					incr = m_in(i)/length(onbits);
					BetP(onbits) = BetP(onbits) +  m_in(i)/length(onbits);
				end
				BetP = BetP/sum(BetP);
			end
		end
	case 'b'
		% NA
	case 'bel'
		% NA
	case 'pl'
		% NA
	case 'BetP'
		% we must put the values at the right palces in BetP vector
		% in fact this option shold never be used, ans BetP should not be stored as 'selected, but who knows?
		BetP = belief(ind_bel).bp(ind_pot).form(ind_for).values;
	case 'wc'
		% NA
	case 'wd'
		% NA
	end	
case 'ordered'
	switch belief(ind_bel).bp(ind_pot).form(ind_for).type
	case 'm'
		% when  ordered, cardinal is always small
		m_in = belief(ind_bel).bp(ind_pot).form(ind_for).values;
		foset = belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets;
		m = zeros(pow2(cardinal),1);
		for i = 1:length(m_in)
			m(foset(i,1)+1) = m_in(i);
		end		
		BetP = fmt(m,'m','betp','n');		
	case 'b'
		% NA
	case 'bel'
		% NA
	case 'pl'
		% NA
	case 'BetP'
		BetP = belief(ind_bel).bp(ind_pot).form(ind_for).values;
		return		
	case 'wc'
		% NA
	case 'wd'
		% NA
	end					
end			
