function new_set = simplifying_formulas(set, cardinal)
% getting simpler set representations

% input 
% set is some lines of element_numbers out of creating_elements`
% a nl x nv matrix. nv = nbr Var and each line is a set of numbers indicating the rank or the element 
% from 1 to cardinal

% cardinal the cardinality of each variable

% set = nk x nv matrix with a list of element (one per line) in the set we want to pack

% % % % % % % % cardinal = [2 2 3];
% % % % % % % % set = [...
% % % % % % % % 1 1 1 ; ...
% % % % % % % % 1 1 2 ; ...
% % % % % % % % 1 1 3 ; ...
% % % % % % % % 1 2 1 ; ...
% % % % % % % % 1 2 2 ; ...
% % % % % % % % 1 2 3 ; ...
% % % % % % % % 2 1 1 ; ...
% % % % % % % % 2 2 2 ; ...
% % % % % % % % 2 2 3 ];


%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


new_set = set; % to be sure to have an output, happens if one line
n_var = length(cardinal);
if n_var == 1
	% when = 1, no need to pack sets
	return
end	

% In both cases I fail for 11 12 21 that produces 10 21 and not 10 01

elem = set;
nz = zeros(1,n_var-1);

go_on = 1;
while go_on & size(elem,1) > 1
	
	
	i_res = 0;
	mem_res = [];
	for i_var = 1:n_var
		ind_set = setdiff([1:n_var],[i_var]);
		[sort_elem indx] = sortrows(elem,ind_set);
		ind_eq = find(max(abs(diff(sort_elem(:,ind_set))),[],2) == 0);
		% diff([1 ; 2; 3]) is [2-1 ; 3-2]
		% ind_eq = k if line k = line k+1.
		fr = []; to = [];
		if  ~isempty(ind_eq)
			fr(1) = ind_eq(1);
			to(1) = fr(1) + 1;
			ik = 1;		
			for i = 2:length(ind_eq)
				if ind_eq(i) == ind_eq(i-1) + 1
					to(ik) = to(ik) + 1;		
				else
					ik = ik + 1;
					fr(ik) = ind_eq(i) ;
					to(ik) = fr(ik) + 1;
				end
			end	
		end

		for i = length(fr):-1:1
			if to(i) - fr(i) + 1 == cardinal(i_var) | min(sort_elem(fr(i):to(i),i_var)) == 0
				i_res = i_res + 1;
				mem_res{i_res,1} = indx(fr(i):to(i));
				mem_res{i_res,2} = i_var;			
				% mem_res{i_res,1} = the index that are for equal line upp to 1
				% mem_res{i_res,2} = the i_var corresponding				
			end
		end
	end
	
	ik = 0; 
	if ~isempty(mem_res)
		list_out = [];
		for i = 1:size(mem_res,1);
			ik = ik + 1;
			new_set(ik,:) = elem(mem_res{i,1}(1),:);
			
			new_set(ik,mem_res{i,2}) = 0;
			list_out = [list_out mem_res{i,1}'];		
		end
	
		elem([list_out],:) = []; % left over elem lines
		if ~isempty(elem)
			new_set = [new_set ; elem];
		end
	
		% clean lines equal for the non zeros
		i = 0;
		proceed = 1;
		indx_set = [1:size(new_set,1)];		
		while proceed 
			still_to_do = find(indx_set > 0);
			if length(still_to_do)>1				
				i = still_to_do(1);
				indx_set(i) = 0;
				ind_nz = find(new_set(i,:) ~= 0);
				if isempty(ind_nz)
					% all var = 0, hence universe, everything can stop
					new_set = zeros(1,n_var);
					proceed = 0;
					go_on = 0;
				else	
					line_out = [];
					for j = 1:size(new_set,1)
						if j~= i & new_set(i,ind_nz) == new_set(j,ind_nz) 
							line_out = [line_out j];
						end
					end
					if ~isempty(line_out)							
						new_set(line_out,:) = [];
						indx_set(line_out) = [];
					end				
				end
			else 
				proceed = 0; % stop searching equal lines
			end
		end
		elem = new_set	;			
	else
		go_on = 0;
	end	

end
