function object = default_labels_elements(type,card)
% constructing default labels for every element according to the type
% for the frame object
% at output, object has 4 fields: cardinality , min, max, elements

%
%   Version : Nov 2,03.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global  infinity infinity_str

switch type
case 'Logical'
	object.elements = strvcat('F','T');
	object.cardinality = 2;
	object.min = [];
	object.max = [];	
case 'Binary'
	object.elements = strvcat('0','1');
	object.cardinality = 2;	
	object.min = [];
	object.max = [];	
case 'Classes_Un_ordered'
	if card <= 52  
		% ABC...Zabc...xyz
		for i = 1:card
			if i <= 26
				elem{i} = char(64+i); % ABC...Z
			else
				elem{i} = char(70+i); % abc....z
			end			
		end
	else 
		% too many H1,H2, ... H234
		for i = 1:card
			elem{i} = ['H',num2str(i)];
		end
	end
	object.elements = strvcat(elem);
	object.cardinality = card;
	object.min = [];
	object.max = [];	
case 'Classes_Ordered'
	for i = 1:card 
		% C1, C2....
		elem{i} = ['C',num2str(i)];
	end	
	object.elements = strvcat(elem);
	object.cardinality = card;
	object.min = [];
	object.max = [];	
case {'Integers','Continuous'}
	object.elements = '';
	if strcmp(object.type,'Integers')
		object.cardinality = card;
		object.elements = strvcat(num2str([1:card]')); 
		object.min = '1';
		object.max = num2str(card);
	else
		object.cardinality = infinity;
		object.min = '0';
		object.max = '100';
		object.elements = [];
	end

end				
