function list_index_my_parents = parents(which,index)
% list the index for the parents of an objects
% input index is the index of the object which 
% where which = 'structure','attribute', 'variable'

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


switch which
	case 'structure'
	% for a structure, you get the index of all its frames, most refined ahead
		list_index_my_parents = [structure(index).most_refined structure(index).sub_frames];
	case 'attribute'
	% for an attribute, you get the index of its structure
		list_index_my_parents = pin_manipulation('structure','num2ind',...
			attribute(index).structure);		
	case 'variable' 
	% for a variable, you get the index of 
	% its attribute  its structure its frame
		list_index_my_parents = pin_manipulation('attribute','num2ind',...
			variable(index).attribute);
		list_index_my_parents = [list_index_my_parents ...
			pin_manipulation('structure','num2ind',...
			attribute(list_index_my_parents(1)).structure);
		list_index_my_parents = [list_index_my_parents ...
			pin_manipulation('frame','num2ind',...
			variable(index).frame);
end
