function run_object_help(obj_type)
% display a help for the object obj_type (1 to 7 for frame, ...belief)

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%


% the help is displayed on a window above the Root Window

global button_size gui_position
mem_fig = gcf;

[index_fig, hd_fig] = handling_all_figures('put_in_front',{'Alternate Root Window'});

k = 0;
switch obj_type

case 1 % frame
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'FRAME';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'A frame is a set of posible values that a variable can take.';
	k=k+1;text{k} = 'Example: the age in decades.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Frame objects are frame(i).field where i = 1, 2... is the index of the object (not its number).';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The fields.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.number : a unique number allocated by default by TBM. You cannot change it.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.full_name : any string. Avoid names with more then 30 characters.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.short_name : any string. Be short. If full_name is left empty, it becomes equal to short_name.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.type : a string, one of : ';
	k=k+1;text{k} = '-- Logical : for variables that represent logical propositions. Elements = (F,T).';
	k=k+1;text{k} = '-- Binary : for variables that take only two values. Several natural choices are proposed in Short Cuts, Get natural frames.';
	k=k+1;text{k} = '-- Classes_Un_ordered : for un ordered categorical variables.';
	k=k+1;text{k} = '-- Classes_Ordered : for ordered categorical variables.';
	k=k+1;text{k} = '-- Integers : a numerical variable. You will be asked for its minimum and maximum values.';
	k=k+1;text{k} = '-- Intervals : intervals defined on a numerical variable. Input will be the boundaries of each intervals. They may NOT overlap as both boundaries are closed. Use decimals to cheat the system.';
	k=k+1;text{k} = '-- Continuous : a numerical variable. You will be asked for its minimum and maximum values.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.cardinality : an integer, the number of elements of the frame.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.elements : the labels of the elements of the frame.';
	
	
case 2 % structure
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'STRUCTURE';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'A strucure is a set of frames that concern one attribute.';
	k=k+1;text{k} = 'Example: for attribute age, its strucutre can be made of:';
	k=k+1;text{k} = 'the age_in_years which is the most refined frame,'; 
	k=k+1;text{k} = 'the age_in_decades, which is a mapping of the age_in_years frame,'; 
	k=k+1;text{k} = 'the young_middle_old frame , which is a mapping of the age_in_years frame,'; 
	k=k+1;text{k} = 'the age_in_year_below_20_years, which is a mapping of the age_in_years frame.';
	k=k+1;text{k} = 'The age_in_years frame number is stored in field .most_refined.';
	k=k+1;text{k} = 'The 3 other frame numbers are stored in field .sub_frames.';
	k=k+1;text{k} = 'The relation between the most refined frame and its mappings are stored in mapping objects which numbers are refered in the .mapping field.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Structure objects are structure(i).field where i = 1, 2... is the index of the object (not its number).';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The fields.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.number : a unique number allocated by TBM. You cannot change it.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.full_name : any string. Avoid names with more then 30 characters.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.short_name : any string. Be short. If full_name is left empty, it becomes equal to short_name.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.most_refined : the number of the most refined frame from which all other frames of this structure are mappings.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.sub_frames : the numbers of the other frames which are mappings of the most refined frame.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.mapping : a nxn matrix where n is the total number of frames refered by this structure.';
	k=k+1;text{k} = 'Lines and columns are the various frames, ordered: most refined and then as listed in sub_frame field.';
	k=k+1;text{k} = 'The element R(i,j) of the matrix is the number of the mapping object which explains the relation between frame i and frame j where frame i is a mapping of frame j.';
	
case 3 % Mapping 

	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'MAPPING';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Not yet available';
	
	
case 4 % attribute
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'ATTRIBUTE';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'An attribute is a properety that can take values on the frames contained in one strucutre object and which may be indexed.';
	k=k+1;text{k} = 'Each indexes has a name and takes values on a frame.';
	k=k+1;text{k} = 'Example: income(individual,year) represent the individualy yearly income expressed on the money structure object.';
	k=k+1;text{k} = 'An attribute is a squeleton for building a variable.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Attribute objects are attribute(i).field where i = 1, 2... is the index of the object (not its number).';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The fields.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.number : a unique number allocated by TBM. You cannot change it.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.full_name : any string. Avoid names with more then 30 characters.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.short_name : any string. Be short. If full_name is left empty, it becomes equal to short_name.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.structure : the number of the structure object on which the attribute takes its values.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.index(k) : an indexed field that has subfields. k goes from 1 to the number of index of the attribute. If not index, field index is empty.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.index(k).name : the name of index k.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.index(k).frame : the number of the frame on which index k is defined.';
	
case 5 % variable
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'VARIABLE';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'A variable is an index instanciated attribute that can take values on a frame. It is the domain on which a belief is defined.';
	k=k+1;text{k} = 'When the attribute has indexes, each one takes a value in its domain, and a variable is defioned for these valeus of the indexes.';
	k=k+1;text{k} = 'Example: income(John,1995) in KEuro where KEuro is a frame among those in money structure object.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Variable objects are variable(i).field where i = 1, 2... is the index of the object (not its number).';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The fields.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.number : a unique number allocated by TBM. You cannot change it.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.full_name : any string. Avoid names with more then 30 characters.';
	k=k+1;text{k} = 'Default name is AttributeLongName(Index1Name=value1,Index2Name=value2,...)_in_FrameLongName';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.short_name : any string. Be short. If full_name is left empty, it becomes equal to short_name.';
	k=k+1;text{k} = 'Default name is AttributeShortName(value1,value2,...)_in_FrameShortName';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.frame : the number of the frame object on which the variable takes its values.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.attribute : the number of the attribute concerned by the variable.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.index_value : a set of integers that indicate the index of the element in the frame object of the indexes. Ordered as the indexes of the attribute.';
	k=k+1;text{k} = ' ';
	
case 6 % belief

	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'BELIEF';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = ['A belief potential denoted any of the m,bel,pl,q,wc,wd (the coefficients of the conjunctive or disjunctive canonical decomposition)'];
	k=k+1;text{k} = ['It is dented by domain_W, agent_Y, time_t [evidential corpus]'];
	k=k+1;text{k} = 'where agent_Y held at time_t a belief over domain_W given agent_Y accepts as true at time_t all the propositions listed in evidential corpus.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The belief object stores one belief potential if there are no conditioning variables like in the undirected VBS, and as many as there are elements in the conditioning variable space like in the directed VBS.';
	k=k+1;text{k} = 'The frame of discernment domain_W of the belief object is the cartesian product of the frames of the varaibles listed in the domain_variable field.';
	k=k+1;text{k} = 'Belief potential k in stored in object .bp(k) which itself can store several forms like bba, bel, pl, q, wc, wd, BetP, etc... ';
	k=k+1;text{k} = 'Each of these forms is in one to one correspondance with the others (except for BetP) and are stored in order to avaoid having to recompute them later on.'; 
	k=k+1;text{k} = 'bba can be stored as a set of focal sets with a mass, or for every subset of the power set of the frame of discernment domain_W.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Frale objects are frame(i).field where i = 1, 2... is the index of the object (not its number).';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The fields.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.number : a unique number allocated by TBM. You cannot change it.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.full_name : any string. Avoid names with more then 30 characters.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.short_name : any string. Be short. If full_name is left empty, it becomes equal to short_name.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.disposable : technical parameters, it means the belief object can be disposed off when you select the pull-down menu Control:Clear unused beliefs';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.agent : name of the belief holder. Default is You';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.time : tilme at which belief is held. Blank if not used';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.ec : the evidential corpus, a plain text.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.domain_variable : the numbers of the variables used to build the frame of discernment domain_W which is their cartesian product.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.domain_cardinality : the cardinalities of the frames of each variable of the domain.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.conditioning_variable : the numbers of the variables used to build the conditioning domain which is their cartesian product. One bp is provided for each element of this space.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.conditioning_cardinality : the cardinalities of the frames of each conditioning variable of the conditioning domain.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.origin : a set of pairs listing those bp used to compute the present bp. Each pair is (belief_number bp_index)';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.computed : a text explaining how the bp listed in origin have been used (conjunctively, disjunctively, discounted, marginalization, projection...)';	
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'THE bp SUB_OBJECT.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.bp(k) is the k-th belief potential (k = 1 if no conditioning variable, 1.... product(conditioning_cardinality) otherwise.';
	k=k+1;text{k} = '.bp(k).form(j) : the j-th form the k-th bp';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = '.bp(k).form(j).type : the type of bp stored, can be m, b, bel, pl, q (unnomlized forms), M, Bel, Pl, Q, BetP (normalized forms), wc, wd.';
	k=k+1;text{k} = '.bp(k).form(j).representation : oredered if given for every elements of the power set of the frame of discernment domain_W, selected if given for a subsets of it (those where mass is positive).';
	k=k+1;text{k} = '.bp(k).form(j).focal_sets : a matrix where each line is a long_number storing the subset of doamin_W as a bit string (long_number because a string may need more than one word to be stored).';
	k=k+1;text{k} = '.bp(k).form(j).values : the values of bp for each element (line) of focal_sets (selected case) or every subset of domain_W (ordered case).';
	k=k+1;text{k} = '.bp(k).form(j).foset_meaning : an string with the underlying meaning of the corresponding focal set. Used when focal sets are created through the logical expression procedure.';
	
case 7 % definition of the objects

	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'THE NATURE OF THE OBJECTS USED BY TBM.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'TBM stores its data under the from of 7 objects.';
	k=k+1;text{k} = 'The 7 objects are frame, structure, mapping, attribute, variable and belief.';	
	k=k+1;text{k} = 'They are savec in a folder which has the name you propose, and in that folder there are up to 7 files which names are the folder name followed by _frame, _structure, ..._belief.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'A belief is allocated to the fact that the actual value of a ''variable'' is in that or that subset of possible values.';
	k=k+1;text{k} = 'The domain of the variable is called here a ''frame''.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The variable is an attribute which possible indexes are instanciated.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'An attribute is a property that can be indexed and define on a set of related frames.';
	k=k+1;text{k} = 'Each index of an attribute can take values that are stored in a frame.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'The set of related frames are defined as a ''structure''.';
	k=k+1;text{k} = 'A structure is defined by its most refined frame, a set of othe frames which are either mapping or subsets (inlcusion) of the most refined one.';
	k=k+1;text{k} = 'A structure stores alos the link to the mapping that exist between its frames.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'A mapping is a relation between two frames, a most refined and a least refined, where each element of the most refined is mapped into an element of the least refined frame.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'A frame is a set of possible values that an attribute_index or a variable can take.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Example:';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Variable = income(person = John,year = 2002, month = 8) in Euro is the income of a person called John in august 2002 expressed in Euro.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Attribute = income(person, year, month) with 3 indexes.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Frame person is an ''Classes_Un_ordered'' type that stores the name of the possible persons: John, All, Caroll, Henty, ...';
	k=k+1;text{k} = 'Frame year is ''integer'' with a range from 1980 to 2100.';
	k=k+1;text{k} = 'Frame month is ''integer'' with a range from 1 to 12.';
	k=k+1;text{k} = 'Frame Euro is ''integer'' with a range from 0 to 100.000.000.';
	k=k+1;text{k} = 'Frame Level_Income is ''interval'' with 3 classes low, medium high.';	
	k=k+1;text{k} = 'Frame Norm_Salary is ''integer'' with a range from 0 to 5000. ';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Mapping Euro_LevInc defines the relation between Euro and Level_Income, with low = [0, 500], medium = [501 1500], high = [1501 100000000].';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Mapping Euro_Norm_Salary defines a subset of Euro with a range from 0 to 5000.';
	k=k+1;text{k} = ' ';
	k=k+1;text{k} = 'Structure Income_Struct stores Euro as the most refined frame,frames Level_Income and Norm_Salary as other frames, and pointers to the mapping relations just defined. ';
	
end

hd_text = display_scrolling_text(hd_fig(1),[.005 .045 .99 .95],text);

% putting a button for going back

posFig = get(hd_fig(1),'Position');
height_but= min(button_size(2)/posFig(4),.99)  ; % .05; 
width_but = min(button_size(1)/posFig(3),.99)  ; %(position(3)-4*left_margin)/3;

posit = gui_position(:,3);
posit(1) = gui_position(1,3) + gui_position(3,3)/2 - width_but/2;
posit(2) = gui_position(2,4);
posit(3) = width_but;
posit(4) = height_but;

help_text_handles = uicontrol(hd_fig(1),...
'Style','pushbutton',...
'Position', posit,...
'String','OK',...
'BackgroundColor',[1 0 0],...
'Callback','uiresume');

figure(hd_fig(1));
uiwait(hd_fig(1)); % you MUST hit    OK    to go on 

delete(help_text_handles);
delete(hd_text)
delete(hd_fig(1));

[index_fig, hd_fig] = handling_all_figures('put_in_front',{'Root Window'});
figure(gcf);
