function [list_discr,list_continuous, list_integers] = type_variable(num_var_list)
% among variable with num in num_var_list
% list_discr		.num, .ind .pos = num, indices, position of those which frame = discrete
% list_continuous	.num, .ind .pos = num, indices, position of those which frame = continuous
% list_integers		.num, .ind .pos = num, indices, position of those which frame = integers


% .pos is position in domain_variable list
% num and ind are number and index of that variable

%
%   Version : June 1, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global variable frame

nd = []; nc = []; ni = []; 
id = []; ic = []; ii = []; 
pd = []; pc = []; pn = [];

for i = 1:length(num_var_list)
	ind_var = pin_manipulation('variable','num2ind',num_var_list(i));
	ind_fra = pin_manipulation('frame','num2ind',[variable(ind_var).frame]);
	if strcmp('Continuous',frame(ind_fra).type)  
		nc = [nc num_var_list(i)];
		ic = [ic ind_var];		
		pc = [pc i];
	elseif strcmp('Integers',frame(ind_fra).type) 
		ni = [ni num_var_list(i)];
		ii = [ii ind_var];	
		pn = [pn i];
	else
		nd = [nd num_var_list(i)];
		id = [id ind_var];	
		pd = [pd i];
	end
end

list_discr.num		= nd;
list_continuous.num	= nc;
list_integers.num	= ni;
list_discr.ind		= id;
list_continuous.ind	= ic;
list_integers.ind	= ii;
list_discr.pos 		= pd;
list_continuous.pos	= pc;
list_integers.pos	= pn;
