function is_vac = is_vacuous(ind_bel,ind_pot)
% testing if a bp is vacuous or not

% if no Cont, no Int, it builds m is not available

% is_vac = 	0 , not vacuous m
%			1 , it is a vacuous m
%		   -1, 	it is absurd, I am lost	
%
%   Version : June 3, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief

[univd,univci] = get_universe_dci(ind_bel,'domain');
ci_present = 0;
if size(belief(ind_bel).dci_var.pin_c,2) | size(belief(ind_bel).dci_var.pin_i,2)
	ci_present = 1;
end

is_vac = 0;
if length(belief(ind_bel).bp) == 0
	is_vac = 1;
elseif length(belief(ind_bel).bp(ind_pot).form) == 0
	is_vac = 1;
end

if is_vac == 0
	% there are forms, get form m
	ind_m = find(strcmp({belief(ind_bel).bp(ind_pot).form(:).type},'m'));	
	if length(ind_m) == 0 & ci_present
		% no m and CI ? absurd
		hdw = warndlg('There is no m function and still there are continuous or integers variables. I am lost. I quit');
		uiwait(hdw)
		is_vac = -1;
	elseif length(ind_m) == 0 & ci_present == 0
		% no m, no CI, I transform to build the missing m
		[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_bel,ind_pot,{'m'});
		%is it vacuous now that it exists
		is_vac = is_vacuous(ind_bel,ind_pot);
	elseif length(ind_m) == 1
		if  belief(ind_bel).bp(ind_pot).form(ind_m).values(1)       == 1     & ...
			isempty(belief(ind_bel).bp(ind_pot).form(ind_m).contint)			
			if isempty(univd)
				if ismepty(belief(ind_bel).bp(ind_pot).form(ind_m).focal_sets)
					is_vac = 1;
				end
			else
				if univd == belief(ind_bel).bp(ind_pot).form(ind_m).focal_sets(1,:)
					is_vac = 1;
				end
			end
		end
	
	elseif length(ind_m) > 1
		% too many m, absurd
		hdw = warndlg('There is several m functions. I am lost. I quit');
		uiwait(hdw)
		is_vac = -1;
	end	
end	
