function out = rd_str_num_shn(str)
% read a string mixing object numbers and object short name

% rule name begin with a letter a...z,A...Z,
% numbers begin with 0,...,9
% only accepted symbols are letters, numbers and _ . , - ()  
% space forbidden

% separators can be anything except a . and - as might be used for numbers
% out{i} = i_th value, isnumeric tells if it is a number

% ascii codes for letters digits . and _, for digits - and .
% 46 ., digit = 48:57,  A...Z = 65:90,  a...z = 97:122  - = 45, _ = 95
% ()- 40:41  , = 44
% for indexed var short name = inc(J,95)
% parenthesis are OK, problem is , as someone will use , as separator one day
% like in SSFR = fr1,fr2
% how to recognise it? , is always between ( and ) for short_name


dig = [48:57 45 46];
sym = [65:90 97:122 95 dig];

pos_nbr = [];
if isnumeric(str)
	pos_nbr = str2num(str);
	for i = 1:length(pos_nbr)
		out{i} = pos_nbr(i);
	end
else
	str = ddblank(str);
	inpar = 0; % =1 if between ( and )
	k = 0;
	nbr_in = 0;
	str = [str ' ']; % used to get last data in
	to = 0; fr = 0;
	for i = 1:length(str)
		if ismember(str(i),sym)
			to = to + 1; nbr_in = 1;
		elseif str(i) == 40
			inpar = 1; to = to + 1; nbr_in = 1;
		elseif str(i) == 41
			inpar = 0; to = to + 1;
		elseif str(i) == 44 & inpar == 1
			to = to + 1; % case ( , )
		else % non symbol
			if nbr_in % end symb area				
				k = k + 1;
				fr = fr + 1;
				to = i - 1;
				term{k} = str(fr:to);
				nbr_in = 0;
				fr = to+1;
			else
				fr = i;
			end
		end
	end
	for i = 1:length(term)
		out{i} = str2num(term{i});
		if isempty(out{i})
			out{i} = term{i};
		end
	end
end


