function ok = check_belief_nci(list_bels_index)
% check that every variables in that list of belief are NOT continuous or integers

%
%   Version : Aug 21,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global belief variable frame

% list of involved variables
list_var_number = unique([belief(list_bels_index).domain_variable]);
list_var_index = pin_manipulation('variable','num2ind',list_var_number);

ok = 1;
for i = 1:length(list_var_index)
	ind_fra = pin_manipulation('frame','num2ind',variable(i).frame);
	if max(strcmp(frame(ind_fra).type,{'Integers','Continuous'}))
		ok = 0; % there is at least one CI frame
		return
	end
end	
