function foset_out = foset_interface(foset_in,cardinal)
% transforming the foset representation of VBS and TBMLAB into each other

% same algo from 'VBS' to 'TBMLAB' and vice versa
% foset_in, foset_out = n*m matrices, with one line = 1 focal set, 
% and m = the nbr of word needed to stroe a faocal set 

%
%   Version : Feb 8,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

% VBS produces 10000000....0   01100 when cardi = 55 and element 1 52 53 on.
% with word1 = 10000000....0 = 5.6295e+14 = 2^49,    word2 = 12
% I need word1 = 00...0001 = 1, word2 = 00110 = 6
%
% the idea behind is 
% for GUI order is word(2) word(1) = 00110  0000...0001, we always go from right to left
% for VBS, bits are oredred as  10000000....0   01100, the 50 first go in word(1), the next 5 in word 2
% GUI respect lexicographic order.

global nbr_bit_per_word

[nw, remain] =  words_for_set(prod(cardinal));

for j = 1:nw
	foset_out(:,j) = bin2dec(fliplr(dec2bin(foset_in(:,j),nbr_bit_per_word)));
end	
if remain
	foset_out(:,nw+1) = bin2dec(fliplr(dec2bin(foset_in(:,nw+1),remain)));
end	
