function lg_nbr_new = long_number_conv(lg_nbr_old, from, to, cardinal,parameter)
% convertisseur of a long number for a set of cardinal elements
% input  = lg_nbr_old = style from
% output = lg_nbr_new = style to
% lg_nbr_new 

% lg_nbr_old/new are:
% case O,X:  	string of symbols, spaces are removed, hence  4 107   or A3 4 3C
% case B:		a vector made of numerical 0 and 1    1011101
% case D:		numerical 456 34217  983  (depends on nbr of elements, one number for up to 50 elements)
% case L:		string with the logical expression

% styles are :
% d : deccimal, just several numbers in nbr_bit_per_word (50) bits group
% b : binary, a vector of numeral 0-1
% o : octal, a string of symbols 0-7
% X : hexadecimal, a stgring of symbols 0-F
% l = logical expression to be converted 

% vector as we must list all the bits, so with 62 elements
% d 	length = 2 
% o		length = 21   	(as 3*21 = 63)
% x 	length = 16		(as 4*16 = 64)
% b		length = 62		(as 1*62 = 62)

% the rightmost bit is for world 1, ...
% world 1 = the one with first value for every variable
% first variable is bottom, turn faster
% to be verified XXXX

%
%   Version : Feb 01,03.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global nbr_bit_per_word belief
[nw, remain] =  words_for_set(cardinal);

% when asking it for empty list, get bits = empty
lg_nbr_new = [];

switch lower(from)
case 'd'  
	switch lower(to)
	case 'd'
		lg_nbr_new = lg_nbr_old;
	case 'b'
		bits = long_num2bit(lg_nbr_old, cardinal);
		lg_nbr_new = fliplr(bits);		
	case 'o'
		bits = long_num2bit(lg_nbr_old, cardinal);
		bits(length(bits)+1:length(bits)+3) = 0;
		n = [];
		for i = 1:3:cardinal
			n = [num2str(bits(i) + 2*bits(i+1) + 4*bits(i+2))    n];
		end	
		lg_nbr_new = n;
	case 'x'
		bits = long_num2bit(lg_nbr_old, cardinal);
		bits(length(bits)+1:length(bits)+4) = 0;
		n = [];
		for i = 1:4:cardinal
			n = [dec2hex(bits(i) + 2*bits(i+1) + 4*bits(i+2) + 8*bits(i+3)) n];
		end	
		lg_nbr_new = n;
	case 'l'
		% Not possible
		disp('You ask me to build a logical expression from a focal set. Not available. I skip.')
	end

case 'b'
	switch lower(to)
	case 'd'
		lg_nbr_new = long_bit2num(fliplr(lg_nbr_old),cardinal);
	case 'b'
		lg_nbr_new = lg_nbr_old;
	case 'o'
		n = [];
		lg_nbr_old = [0 0 0 lg_nbr_old ];
		for i = cardinal+3:-3:4
			n = [num2str(lg_nbr_old(i) + 2*lg_nbr_old(i-1) + 4*lg_nbr_old(i-2)) n];
		end	
		lg_nbr_new = n;
	case 'x'
		n = [];
		lg_nbr_old = [0 0 0 0 lg_nbr_old ];
		for i = cardinal+4:-4:5
			n = [dec2hex(lg_nbr_old(i) + 2*lg_nbr_old(i-1) + 4*lg_nbr_old(i-2) + 8*lg_nbr_old(i-3)) n];
		end	
		lg_nbr_new = n;	
	case 'l'
		% Not possible
		disp('You ask me to build a logical expression from a focal set. Not available. I skip.')
	end

case 'o'
	switch lower(to)
	case 'd'
		bits = [];
		for i = 1:length(lg_nbr_old)
			bits = [bits  num2bit(str2num(lg_nbr_old(length(lg_nbr_old)-i+1)),3)];
		end
		lg_nbr_new = long_bit2num(bits,cardinal);
	case 'b'
		bits = [];
		for i = 1:length(lg_nbr_old)
			bits = [bits  num2bit(str2num(lg_nbr_old(length(lg_nbr_old)-i+1)),3)];
		end
		lg_nbr_new = fliplr(bits);
	case 'o'
		lg_nbr_new = lg_nbr_old;
	case 'x'
		bits = [];
		for i = 1:length(lg_nbr_old)
			bits = [  fliplr(num2bit(str2num(lg_nbr_old(length(lg_nbr_old)-i+1)),3)) bits];
		end
		bits
		lg_nbr_new = long_number_conv(bits,'b','x',cardinal)
	case 'l'
		% Not possible
		disp('You ask me to build a logical expression from a focal set. Not available. I skip.')
	end

case 'x'  % inpout is vector of hexo string like   lg_nbr_old{i} = '4A3' lg_nbr_old(i) = '55CD3'
	switch lower(to)
	case 'd'
		lg_nbr_new = long_bit2num(fliplr(long_number_conv(lg_nbr_old,'x','b',cardinal)),cardinal);
	case 'b'
		bits = [];
		for i = 1:length(lg_nbr_old)
			bits = [bits  fliplr(num2bit(hex2dec(lg_nbr_old(i)),4)) ];
		end
		nbr_bl = 4*length(lg_nbr_old) - cardinal;
		for i = 1:nbr_bl
			bits(1) = [];
		end
		lg_nbr_new = bits;		
	case 'o'
		lg_nbr_new = long_number_conv(lg_nbr_old,'x','b',cardinal);
		lg_nbr_new = long_number_conv(lg_nbr_new,'b','o',cardinal);		
	case 'x'
		lg_nbr_new = lg_nbr_old;
	case 'l'
		% Not possible
		disp('You ask me to build a logical expression from a focal set. Not available. I skip.')
	end

case 'l' 
	% for logical case, I need the pin tables that might not yet habe been built
	% building the pin_tables for entered data
	get_all_pin_tables;
	
	belief_index = parameter(1);
	bp_index = parameter(2);
	form_index = parameter(3);
	ind_foset = parameter(4);
	
	belief(belief_index).bp(bp_index).form(form_index).log_expr{ind_foset} = lg_nbr_old;

	% here next logical expression becomes a number	
	[ok] = get_m_from_logic_expr_new('bbm_batch', belief_index,bp_index,form_index,ind_foset,[]);
	
	if ok == 0
		fprintf(1,'\nthe next logical expression is wrong.\n index of belief = %5i, bp = %5i, form = %5i, focal_sets = %5i\n',...
		[belief_index, bp_index,form_index,ind_foset]);
		fprintf(1,'%s\n',lg_nbr_old);
	else
		lgnum = belief(belief_index).bp(bp_index).form(form_index).focal_sets(ind_foset,:);
		switch lower(to)
		case 'd'
			lg_nbr_new = lgnum;
		case 'b'
			lg_nbr_new = long_number_conv(lgnum,'d','b',cardinal);
		case 'o'
			lg_nbr_new = long_number_conv(lgnum,'d','o',cardinal);
		case 'x'
			lg_nbr_new = long_number_conv(lgnum,'d','x',cardinal);
		end
	end
end
