function [bel_ind,ind_bp,ind_form_betp] = build_BetP(bel_num)
% building BetP for belief().number = bel_num. 
% bel_ind,ind_bp,ind_form_betp index where BetP stored

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position   nbr_bit_per_word
global frame structure mapping attribute variable belief

bel_ind = pin_manipulation('belief','num2ind',bel_num);

% bel domain, can be multi variates
domain = belief(bel_ind).domain_variable; 
cardi_var = prod(belief(bel_ind).domain_cardinality);
% selecting the correct bp, the easiest is m
% so if m exists, we use it, if not we build it.

% if more than one bp, I compute BetP for every bp
for ind_bp = 1:length(belief(bel_ind).bp)	
	ind_form = find_in_str({belief(bel_ind).bp(ind_bp).form(:).type},'m');
	
	if isempty(ind_form)
		% there is no m, I build it
		build_m(bel_num,bp_ind)  % to be built XXXXXXXXX should not occur presently
		ind_form_with_m = ind_form;
	elseif length(ind_form) == 1
		% there is a m, I use it
		ind_form_with_m = ind_form;
	else
		% what can I do, It is not OK
		% should only be one ind_form, multiple = error XXXX
		boum
	end


	switch belief(bel_ind).bp(ind_bp).form(ind_form_with_m).representation
	case 'selected'
		foset = belief(bel_ind).bp(ind_bp).form(ind_form_with_m).focal_sets;
		m = belief(bel_ind).bp(ind_bp).form(ind_form_with_m).values;
		
		% doing the real computation 
		BetP = zeros(cardi_var,1);
		m0 = 0;
		for i = 1:length(m)
			bit_on = long_num2onbit(foset(i),cardi_var);
			if length(bit_on)
				BetP(bit_on) = BetP(bit_on) + m(i)/length(bit_on);
			else
				m0 = m0 + m(i);
			end
		end
		if m0 < 1
			BetP = BetP/(1-m0);
		else
			% m({}) = 1n, cata I put = proba but UGLY
			% I can only do BOUM otherwise
			BetP(:) = 1/cardi_var;
		end
	
	case 'ordered'
		% used FMT as size is small (ordered does not exist for large frames)
		BetP = mtobetp(belief(bel_ind).bp(ind_bp).form(ind_form_with_m).values);
	end

	% if BetP has already been built, I overwrite it.
	ind_form_betp = find_in_str({belief(bel_ind).bp(ind_bp).form(:).type},'BerP');
	if isempty(ind_form_betp)
		ind_form_betp_v = length(belief(bel_ind).bp(ind_bp).form) + 1;
		if length(ind_form_betp_v) > 1
			ind_form_betp = ind_form_betp_v(1);
		else
			ind_form_betp = ind_form_betp_v;
		end	
	end

	belief(bel_ind).bp(ind_bp).form(ind_form_betp).type = 'BetP';
	belief(bel_ind).bp(ind_bp).form(ind_form_betp).representation = 'selected';
	belief(bel_ind).bp(ind_bp).form(ind_form_betp).focal_sets = [pow2([0:cardi_var-1])]';
	belief(bel_ind).bp(ind_bp).form(ind_form_betp).values = BetP;
end	
