function [computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_bel,ind_bp,out_form)
% building the out_form from what is available 
% in object belief(index_belief).bp(,bp_index).

% NCI

% called by Tool/run_transform_bp or by any fct  thet needs another form
%
% we look which forms exist,
% which forms are asked by out_form (can be a list)
% and produce them

% use    fmt(vect,'in_type','out_type,'n')  if cardi <= 18, store m as selected if cardi > 18

% input:
% out_form 	- {'x'} 	if only one
%			- {'x','y',...} if several
% with x,y any of {m, b, bel, pl, q, BetP, wc, wd}
% out_form 	- 'all': we get all forms: {m, b, bel, pl, q, BetP, wc, wd}

% output:
% computed_forms	: list of symbols of computed forms
% uncomputed_forms	: list of symbols of not computed forms
% error_mode		: a message

% for m, wc, wd results are apcked and representation is seleted, to save place
% m = 0, wc = 1, wd = 1 deleted

%
%   Version : May, 15, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global max_card_fmt

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% What can we do:
%
%%%%%%%%%%%%%%%%%%%%
%
% if cardi <= max_card_fmt (18?): we use FMT, 
% in  = any of m, b, q, bel, pl, wc, wd, M, Bel, Pl, Q 
% out = any of m, b, q, bel, pl, wc, wd, M, Bel, Pl, Q , BetP
%
% and store 	m, wc, wd, BetP				as selected  
% 				b, q, bel, pl, Bel, Pl, Q 	as ordered 
%
%%%%%%%%%%%%%%%%%%%%
%
% if cardi > max_card_fmt (18?):  I need input = m selected, 
% from m to b, q, bel, pl, M, Bel, Pl, Q only those on same selected fosets
% from m to BetP, all elements 
% from m to wc, wd NA  XXXXX sparce m to sparce wc algo ???
% coming back from selected b,q,bel,pl,wc,wd,M,B,Pl,Q  to selected m NA
%
%%%%%%%%%%%%%%%%%%%%
%
% note that BetP cannot be present without sometning else (like m), so never an input.
%
%%%%%%%%%%%%%%%%%%%%
%
% Computing order for FMT; to get i, the best are ithe one with smallest mat_pref(i,....)
%
% for request i, get mat_pref(i,j) for every j, take smallest
% do it for every i, take smallest of smallest
%
% so for all j available,  i requested mat_pref(i,j), take smallest
% do it, change the two lists and repeat
%
%
% in = any of m, b, q,   bel, pl,   wc, wd,   M, Bel, Pl, Q 
%     # =     1  2  3     4    5     6   7    8   9	  10  11	
% mat_pref(i,j) tells how hard it is to compute i from j where i,j are the number in line above
%
%%%%%%%%%%%%%%%%%%%%
%
% If no form available as input (stupid of course), build a vacuous m, and proceed
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mat_pref = [...
0	3	3	3	3	5	5	11	13	13	13	20	;...
3	0	3	1	2	5	4	13	10	13	11	20	;...
3	3	0	3	3	4	5	13	13	10	13	20	;...
3	1	3	0	2	5	4	13	11	13	10	20	;...
3	2	3	2	0	5	4	13	12	13	12	20	;...
5	5	4	5	5	0	6	15	15	14	15	20	;...
5	4	5	4	4	6	0	15	14	15	14	20	;...
1	3	3	3	3	5	5	 0	13	13	13	20	;...
3	1	3	1	2	5	4	13	 0	13	11	20	;...
3	2	3	1	1	5	4	13	12	 0	11	20	;...
3	3	1	3	3	4	5	13	13	11	 0	20	;...
1	2	2	2	2	6	6	11	12	12	12	0	];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% list of forms available
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

computed_forms{1} = '';
uncomputed_forms{1} = '';
i_computed_form = 0;
i_uncomputed_form = 0;
error_mode{1} ='';
ind_error_mode = 0;
card = prod([belief(ind_bel).domain_cardinality]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% order for out_form: if 
% from Tools ardered according to param = {'m','b','q','bel','pl','wc','wd','M','Bel','Pl','Q','BetP'};
% from TBMLAB call, ordered by programmer
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% which forms exist, if none I build a vacuous bba first
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

frm_list = belief(ind_bel).bp(ind_bp).form;
nbr_forms = length(frm_list);
if nbr_forms == 0
	% no form, I build a vacuous m, normaly it should never occur
	% if none exists why to transform!!!
	hdw = warfndlg('Request for new form when none exists. I cancel')
	uiwait(hdw)
	return
else
	% I prepare the new form
	for i = 1:nbr_forms
		type_list{i} = belief(ind_bel).bp(ind_bp).form(i).type;
		rep_list{i}  = belief(ind_bel).bp(ind_bp).form(i).representation;
	end
end

% type_list = available forms      
% out_form  = pending form requests
% in_form_nbr  = the number of the available forms 
% out_form_nbr = the number of the out_form requested: 1 to 12

param = {'m','b','q','bel','pl','wc','wd','M','Bel','Pl','Q','BetP'};
in_form_nbr = [];
for i = 1:length(type_list)
	in_form_nbr = [in_form_nbr strmatch(type_list{i},param,'exact')];
end
out_form_nbr = [];
for i = 1:length(out_form)
	out_form_nbr = [out_form_nbr strmatch(out_form{i},param,'exact')];
end

%
% If nbr elemerts <= 18,
% xin is built as ordered, in_type = its type, in_rep = its representation, ind_in_type = its index in form().
% transformation will be as   fmt(xin,in_type, out_type,'n')
%
% if  nbr elemerts > 18, I can only use summations formula using m.
%
% Accepatble out form are among
% param = {'m','b','q','bel','pl','wc','wd','M','Bel','Pl','Q','BetP'};
%
% the indexes of those forbidden are listed in vector forbidden_out

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% case done with fmt
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if card <= max_card_fmt   % in july 03 = 18
	while length(out_form_nbr)
		best = min(min(mat_pref(out_form_nbr,in_form_nbr)));
		[iv jv] = find(mat_pref(out_form_nbr,in_form_nbr) == best);
		iw = out_form_nbr(iv);
		jw = in_form_nbr(jv);
		if length(iw) > 1
			i_sel = iw(1);
			j_sel = jw(1);
		else
			i_sel = iw;
			j_sel = jw;
		end	
		out_sel_form = param{i_sel};		
		in_sel_form = param{j_sel};
		
		if best == 0
			% not clever, we ask what we had it already, skip comput
			% do nothing
		else
	
			% getting xin
			ind_in_type = min(strmatch(in_sel_form,type_list,'exact'));
			% in case of several same type (what should not occur) at least I don't crash
			switch belief(ind_bel).bp(ind_bp).form(ind_in_type).representation
			case 'ordered'
				xin = belief(ind_bel).bp(ind_bp).form(ind_in_type).values;	
				in_rep = 'ordered';
			case 'selected'  % only for m M wc wd
				switch belief(ind_bel).bp(ind_bp).form(ind_in_type).type
				case {'m','M'}
					xin = zeros(pow2(card),1);
				case {'wc','wd'}
					xin = ones(pow2(card),1);
				end
				xin(belief(ind_bel).bp(ind_bp).form(ind_in_type).focal_sets+1) = ...
				belief(ind_bel).bp(ind_bp).form(ind_in_type).values;
				in_rep = 'selected';
			end		
		
			if i_sel <= 7 % the unnormaized forms
				xout = fmt(xin, in_sel_form, out_sel_form);
			elseif i_sel < 12 % the normalized forms, not BetP
				xout = fmt(xin, in_sel_form, out_sel_form,'n');
			else % BetP
				[useless_bel_ind,useless_ind_bp,useless_ind_form_betp] = build_BetP(belief(ind_bel).number);
			end
		
			% storing result
			if i_sel < 12 % for BetP (=12) already done
				i_new_form = make_empty('form',ind_bel,ind_bp);
				belief(ind_bel).bp(ind_bp).form(i_new_form).type = out_sel_form;
				belief(ind_bel).bp(ind_bp).form(i_new_form).representation = 'ordered';
				belief(ind_bel).bp(ind_bp).form(i_new_form).focal_sets = [];
				belief(ind_bel).bp(ind_bp).form(i_new_form).values = xout;
				% packing m wc wd
				pack_m_wc_wd(ind_bel, ind_bp, i_new_form);
			end
			% for next form I add a new as input
			type_list{length(type_list)+1} = out_sel_form;
			in_form_nbr = [in_form_nbr i_sel];
		end % if best == 0
		i_computed_form = i_computed_form + 1;
		computed_forms{i_computed_form} = out_sel_form;
		% for next form, I get rid of what is done
		out_form_nbr(find(out_form_nbr == i_sel)) = '';
	end % 	for i_form = 1:length(out_form)
end %if card <= max_card_fmt 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% case done with summations
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if card > max_card_fmt 
	% getting xin, I need m, or M if no m, else I cann't compute
	ind_in_type = strmatch('m',type_list,'exact');
	if isempty(ind_in_type)
		ind_in_type = strmatch('M',type_list,'exact');
	end
	if  isempty(ind_in_type) % transformation imposible
		uncomputed_forms =   out_form;
		ind_error_mode =ind_error_mode + 1;
		error_mode{ind_error_mode} ='Large cardinality and no m, (nor M). Computation impossible.';
		
	else % I can do the transformation
		foset = belief(ind_bel).bp(ind_bp).form(ind_in_type).focal_sets;
		xin = belief(ind_bel).bp(ind_bp).form(ind_in_type).values;	
		[nbr_fosets nc] = size(foset);
		
		% avoiding replicates and useless computations
		out_form = setdiff(unique(out_form),type_list);
		
		for i = 1:length(out_form)
			% only possible m to b,q,bel,pl, Bel, Pl, Q on same fosets or m to BetP, but fmt cannot be used
			% we use 
			% ainb(a,b)        to see if (set with long number) a represent a subset of b
			% aaboveb(a,b)     to see if (set with long number) a represent a superset of b
			% aintersectb(a,b) to see if (sets with long number) a and b have not empty intersection
			comput_ok = 0;
			
			switch out_form{i}	
			case 'M'
				xout = xin;
				comput_ok = 1;
				get0 = find (foset(:,1:nc) == get_empty_set(card));
				if length(get0)
					m0 = sum(xin(get0));
					if m0 == 1
						ind_error_mode =ind_error_mode + 1;
						error_mode{ind_error_mode} ='Normalization impossible: m({}) = 1.';
						comput_ok = 0;
					else
						xout(get0) = 0;					
						xout = xout / (1 - m0); 
						comput_ok = 1;
					end		
				end							
			case {'b','bel','Bel'}
				for j = 1:nbr_fosets
					y(j) = 0;
					for k = 1:nbr_fosets
						if ainb(foset(k,:),foset(j,:))				
							y(j) = y(j) + xin(k);
						end
					end
				end
				if strcmp(out_form{i},'b')
					xout = y';
					comput_ok = 1;
				else
					get0 = find (foset(:,1:nc) == get_empty_set(card));
					if length(get0)
						m0 = sum(xin(get0));
						xout = y' - m0*ones(nbr_fosets,1);
						xout(get0) = 0;
						comput_ok = 1;
						if strcmp(out_form{i},'Bel')
							if m0 == 1
								ind_error_mode =ind_error_mode + 1;
								error_mode{ind_error_mode} ='Normalization impossible: m({}) = 1.';
								comput_ok = 0;
							else
								xout = xout / (1 - m0); 
								comput_ok = 1;
							end
						end
					else
						xout = y';
						comput_ok = 1;
					end
				end
			case {'q','Q'}
				for j = 1:nbr_fosets
					y(j) = 0;
					for k = 1:nbr_fosets
						if aaboveb(foset(k,:),foset(j,:))				
							y(j) = y(j) + xin(k);
						end
					end
				end
				if strcmp(out_form{i},'q')
					xout = y';
					comput_ok = 1;
				else
					get0 = find (foset(:,1:nc) == get_empty_set(card));
					if length(get0)
						m0 = sum(xin(get0));
						if m0 == 1
							ind_error_mode =ind_error_mode + 1;
							error_mode{ind_error_mode} ='Normalization impossible: m({}) = 1.';
							comput_ok = 0;
						else					
							xout = y' / (1 - m0);
							xout(get0) = 1;
							comput_ok = 1;
						end
					else
						xout = y';	
						comput_ok = 1;
					end
				end	
			case {'pl','Pl'}
				for j = 1:nbr_fosets
					y(j) = 0;
					for k = 1:nbr_fosets
						if aintersectb(foset(k,:),foset(j,:))				
							y(j) = y(j) + xin(k);
						end
					end
				end
				if strcmp(out_form{i},'pl')
					xout = y';
					comput_ok = 1;
				else
					get0 = find (foset(:,1:nc) == get_empty_set(card));
					if length(get0)
						m0 = sum(xin(get0));
						if m0 == 1
							ind_error_mode =ind_error_mode + 1;
							error_mode{ind_error_mode} ='Normalization impossible: m({}) = 1.';
							comput_ok = 0;
						else					
							xout = y' / (1 - m0);
							comput_ok = 1;
						end
					else
						xout = y';
						comput_ok = 1;
					end
				end					
			case {'wc','wd'}
				% NA
				comput_ok = 0;
			case 'BetP'	
				bel_num = pin_manipulation('belief','ind2num',ind_bel);
				[bel_ind,ind_bp,ind_form_betp] = build_BetP(bel_num);
				% results are stored alreday
				comput_ok = 1;
			end % switch out_form{i}
		
			if ~strcmp( out_form{i},'BetP') & comput_ok == 1
				% stroring the results, except BetP already done
				i_new_form = make_empty('form',ind_bel,ind_bp);
				belief(ind_bel).bp(ind_bp).form(i_new_form).type = out_form{i};
				belief(ind_bel).bp(ind_bp).form(i_new_form).representation = 'selected';
				belief(ind_bel).bp(ind_bp).form(i_new_form).focal_sets = foset;
				belief(ind_bel).bp(ind_bp).form(i_new_form).values = xout;
				% packing m wc wd
				pack_m_wc_wd(ind_bel, ind_bp, i_new_form);
			end
			if comput_ok
				i_computed_form = i_computed_form + 1;
				computed_forms{i_computed_form} = out_form{i};
			else
				i_uncomputed_form = i_uncomputed_form + 1;
				uncomputed_forms{i_uncomputed_form} = out_form{i};
			end
		
		end % for i = 1:length(out_form)
	end % if  isempty(ind_in_type) % transformation imposible
end % if card > max_card_fmt 

useless = pin_manipulation('belief','all','');


