function display_result_gbt_cont(ind_cd_bel,ind_belT,Pr,lkh,fromX,toX,type_pdf,ind_form_pdf)
% dispalying the results of the GBT applied to continuous and integers variables

%
%   Version : Nov 4, 2003
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global screen_size Which_Courier
global gui_position  figure_data  flags  help_level help_label

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure('name','GBT Results');
set(hd_fig,'position',gui_position(:,19))
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'GBT Window';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,    'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(1)','on');
% k=k+1;make_fig_menu(ind_fig,k,   'Tools',0,'','on');
% k=k+1;make_fig_menu(ind_fig,k,'Element details', 3,'general_clb(3);','on');
k=k+1;make_fig_menu(ind_fig,k,     help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Show Helps', 3,'general_clb(2)','on');

menu_manager('create',ind_fig)

% hd_help = forced_display_helps(0,51);
% there is only one help so I just show it 
% display_helps put the Root Window in front with a help text

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% prepare data
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tic

% sorting the Pr, first is largest
[sotr_betp ind_sort] = sort(-Pr);
sotr_betp = -sotr_betp;

% how many betp to be displayed
nbr_betp_shown = min(10,length(Pr));

% nbr of onditioning elements
nbr_condit =length(belief(ind_cd_bel).bp);

% nbr histo displayed
nbr_histo = min(5,length(Pr));

delta = .02;
if fromX < toX
	% observed data is an interval	
	bel0  = belief(ind_belT).bp(1).form(get_form_type('Bel', ind_belT,1)).values(ind_sort);
	betp0 = belief(ind_belT).bp(1).form(get_form_type('BetP',ind_belT,1)).values(ind_sort);
	pl0   = belief(ind_belT).bp(1).form(get_form_type('Pl',  ind_belT,1)).values(ind_sort);
else
	% observed data is a point, columns
	betp0 = belief(ind_belT).bp(1).form(get_form_type('m', ind_belT,1)).values(ind_sort);
	bel0 = max(zeros(nbr_betp_shown,1),betp0 - delta/2);
	pl0  = min( ones(nbr_betp_shown,1),betp0 + delta/2);
end

% getting variables names in window instruction
ind_var_hr = pin_manipulation('variable','num2ind',belief(ind_cd_bel).conditioning_variable);
ind_fra_hr = pin_manipulation('frame','num2ind',variable(ind_var_hr).frame);

for i = 1:size(frame(ind_fra_hr).elements,1)
	elem_label{i} = frame(ind_fra_hr).elements(i,:);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% parameters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

little_sh = .005; width = .5-2*little_sh;
% positions frames UL, UR, LL, LR
four_window_position = [...
little_sh    .5+little_sh  width width;...
.5+little_sh .5+little_sh  width width;...
little_sh     little_sh    width width;...
.5+little_sh  little_sh    width width]; 

shr = .005; % shrink for frames into frames
shr_title = [shr width-.04 -2*shr  -width+.035];
shr_text =  shr_title + [shr shr -2*shr -2*shr];
shr_list = [shr shr -2*shr -.04-shr];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% UR: scroll list of m,s,a,b
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i = 1:length(belief(ind_cd_bel).bp)
	param = belief(ind_cd_bel).bp(i).form(ind_form_pdf(i)).values;	
	list_param{i} = [sprintf('%3i',i),sprintf(' %10g',param(3)),sprintf(' %10g',param(4)),...
	sprintf(' %10g',param(1)),sprintf(' %10g',param(2)),sprintf(' %10s',type_pdf{i}),'    ',...
	elem_label{i}];	
end

ppos = 2; % UR

% overall frame
hd_param(1) = uicontrol(...
'position',four_window_position(ppos,:),...
'style','frame');

% title frame
hd_param(2) = uicontrol(...
'position',four_window_position(ppos,:) + shr_title,...
'style','frame');

% title text
title_line = ['t_i       mean      st_dev         a          b   pdf_type   label'];
hd_param(3) = uicontrol(...
'position',four_window_position(ppos,:) + shr_text  ,...
'style','text',...
'horizontalAlignment','left',...
'fontname',Which_Courier,...
'string',title_line);

hd_param(4) = uicontrol(...
'position',four_window_position(ppos,:) + shr_list,...
'style','listbox',...
'horizontalAlignment','left',...
'max',nbr_histo,...
'value',[ind_sort(1:nbr_histo)],...
'fontname',Which_Courier,...
'string',list_param);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% LL plot histo
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% hd_histo(6) = bar horiz from to with data from to
% hd_histo(1, 2...5) = 5 histo with 5 colors
% 
% hd_histo(7:8) indicate data from to vertical lines

% selecting the  nbr_betp_shown   pdf located at bp(ind_sort)

% I need pdf, parameters a,c

ppos = 3; % LL

for i = 1:nbr_histo
	param(i,:) = belief(ind_cd_bel).bp(ind_sort(i)).form(ind_form_pdf(ind_sort(i))).values;
	pdf{i} = belief(ind_cd_bel).bp(ind_sort(i)).form(ind_form_pdf(ind_sort(i))).representation;	
	% pdf = binomial, gaussian ...
end

from = min(param(:,3)-2.5*param(:,4)); % min = min m-2s 
to   = max(param(:,3)+2.5*param(:,4)); % max = max m+2s 
nbr_step = 100;
d = (to-from)/nbr_step;

for i = 1:nbr_histo
	x = from;
	for j = 1:nbr_step
		x = x+d;
		switch pdf{i}
		case 'gaussian'
			m = param(i,1);
			s = param(i,2);
			f(i,j) = (1/(sqrt(2*pi)*s)) * exp(-.5*((x-m)/s)^2);
		case 'laplace'
			%
		end
	end
end
maxY = 1.05*max(max(f));
color_mem = {'red','black','blue','green','yellow'};

hd_pdf_plot(1) = axes(...
'position',four_window_position(ppos,:)+[.05 .05 -.05 -.10],...
'YTick',[0:maxY/5:maxY], ...
'Xlim',[from, to],...
'Ylim',[0 maxY],...
'Ygrid','on',...
'Xgrid','on',...
'Box','on');

title('pdf for the most probable hypotheses');	
xlabel('x');
ylabel('density')

if toX > fromX
	i=i+1;hd_line(i) = patch([fromX fromX toX toX fromX]',[0 maxY maxY 0 0]',.8*[1 1 1]);
	i=i+1;hd_line(i) = line('Xdata',[toX toX],'Ydata',[0 maxY],'color','k');
	i=i+1;hd_line(i) = line('Xdata',[fromX fromX],'Ydata',[0 maxY],'color','k');
else
	i=i+1;hd_line(i) = line('Xdata',[fromX fromX],'Ydata',[0 maxY],'linewidth',2,'color','k');
end

xd = [from + [1:nbr_step]*d];
for i = 1:nbr_histo
	yd = f(i,:);
	hd_line(i) = line('Xdata',xd,'Ydata',yd,'color',color_mem{i});
end	

drawnow	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% list meaning singleotns
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ppos = 4; %LR

for i=1:nbr_betp_shown
	color{i} = ' ';
end
for i = 1:nbr_histo
	color{i} = color_mem{i};
end

k=1;text_singletons{1}   = 't_i  color_pdf    BetP    label';
k=k+1;text_singletons{k} = '--------------------------------------';
for i = 1:nbr_betp_shown
	k=k+1;
	text_singletons{k} = [sprintf('%3i',belief(ind_cd_bel).bp(ind_sort(i)).cd_focal_set),  sprintf(' %10s',color{i}),...
	sprintf(' %7.4f',betp0(i)), '    ', frame(ind_fra_hr).elements(ind_sort(i),:)];
end
k=k+1;text_singletons{k} = '--------------------------------------';
k=k+1;text_singletons{k} = ' ';
if fromX ~= toX
	k=k+1;text_singletons{k} = ['Observation: interval from ',num2str(fromX), ' to ', num2str(toX)];
else
	k=k+1;text_singletons{k} = ['Observation: point valued = ',num2str(fromX)];
end

% overall frame
hd_sing(1) = uicontrol(...
'position',four_window_position(ppos,:),...
'style','frame');

% text 
hd_sing(2) = uicontrol(...
'horizontalAlignment','left',...
'position',four_window_position(ppos,:) + [shr shr -2*shr -2*shr],...
'style','text',...
'fontname',Which_Courier,...
'string',text_singletons);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% plotting bel,BetP,pl on singletons, verticcal scale = sum BetP(1:nbr_betp_shown)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ppos = 1; % UL

maxY = sum(betp0(1:nbr_betp_shown)); % some kind of censoring when all proba are very small

hd_betp_plot(1) = axes(...
'position',four_window_position(ppos,:)+[.05 .05 -.05 -.10],...
'Box','on');


hdata = [bel0(1:nbr_betp_shown),   (betp0(1:nbr_betp_shown) - bel0(1:nbr_betp_shown)  - delta/2),   delta*ones(nbr_betp_shown,1),...
(pl0(1:nbr_betp_shown)   - betp0(1:nbr_betp_shown) - delta/2) ,   ones(nbr_betp_shown,1)-pl0(1:nbr_betp_shown)];

hd_betp_patch = bar([1:nbr_betp_shown], hdata,.3,'stacked');
colormap([1 1 1;1 .7 .7; 1 0 0; 1 .7 .7; 1 1 1]);

for i = 1:length(ind_sort)
	tick_label{i} = frame(ind_fra_hr).elements(ind_sort(i),:);
end

title('Bel, BetP, Pl: elements ordered by BetP');	
ylabel('Belief, BetP, Plausibility');
xlabel('Singleton : meaning see column index at lower left list.');
set(gca,'Layer','top', 'YTick',[0:maxY/10:maxY], ...
'Xlim',[0 nbr_betp_shown+1],'Ylim',[0 maxY],'Ygrid','on',...
'XtickLabel', tick_label );
drawnow	

disp('time needed for computing and drawing the GBT applied on ccontinuous X')
toc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% what next
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
while go_on
	uiwait(gcf)
	switch flags(1) 
	case 1  % quit
		go_on = 0;
	case 2 % get help
		gcf_mem = gcf;
		global help_level
		help_level_mem = help_level;
		help_level = 2;
		help_text_handles = display_helps(1,57);
		delete(help_text_handles)
		help_level = help_level_mem;
		figure(gcf_mem);
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% quitting
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

delete(hd_fig)
figure_data(ind_fig) = [];
