function [lkh] = gbt_lkh_wc(ind_bel,ind_belT,from,to,ind_form_pdf,type_pdf)
% input : the wc vector (selected)

% input

% ind_bel = ind bel obejct with cd beliefs
% ind_belT = index of the belief object with the bp on theta

% data : interval is [from to], (if to<from, I corrrect it)
% date : point to = from or to absent (1 argument)

% ind_form_pdf : index of form with pdf
% type_pdf : type of form with pdf (bba or Betf)

% output:
% lkh = likelihood 
% when from < to, lkh put as wc in belief object on theta
% when from = to and continuous, the solution is a bayesian bf and put in a m vector on theta

% domain variable must be unidimensional

global frame belief

lkh = []; % to be sure to get something if return acts

% checking domain variable is unidimensional
if length(belief(ind_bel).domain_variable) ~= 1
	hdw = warndlg('The GBT works only for unidimensional domain variables. I skip.')
	uiwait(hdw)
	return
end

% index of X frame of domain_variable
ind_fra = frame_of_belief(ind_bel);

% nbr of potentials (as many as cardinal T)
nbr_pot = length(belief(ind_bel).bp);
card = nbr_pot;

if nargin == 2
	to = from;
end

if to == from
	data_type = 'point';
	to = from;
else
	data_type = 'interval';
	if to < from
		toto = to;
		to = from;
		from = toto;
	end
end

switch frame(ind_fra).type
case {'Logical','Binary','Classes_Un_ordered','Classes_Ordered'}
	% not here, use full_gbt_computer	
	how_save = 'dont_save';
case 'Continuous'
	for i_pot = 1:nbr_pot	
		% the position of the conditioning element 
		pos_foset(i_pot) = belief(ind_bel).bp(i_pot).cd_focal_set;
		
		ind_for = ind_form_pdf(i_pot);
		switch  type_pdf{i_pot}	% what is the pdf?
		case 'bbf' % pdf is bbf
			pdf = belief(ind_bel).bp(i_pot).form(ind_for).representation;			
			param = belief(ind_bel).bp(i_pot).form(ind_for).values;
			
			switch data_type
			case 'interval'
				% integral from to
				lkh(i_pot) = lkh_from_pdf(pdf,param,from,to);
				% fosets arfe the complemeents of the singletons
				foset(i_pot,:) = long_bitcmp(long_onbit2num(belief(ind_bel).bp(i_pot).cd_focal_set,card),card);
			case 'point'
				% density at from
				lkh(i_pot) = lkh_from_pdf(pdf,param,from);
				% fosets are the singletons
				foset(i_pot,:) = long_onbit2num(belief(ind_bel).bp(i_pot).cd_focal_set,card);				
			end		
		case 'Betf'
			% when pdf is Betf,  
			% point or interavl, same reults, all that opunts as data closest from mode
			lkh(i_pot) = lciso_pl_from_pdf(ind_bel,i_pot,ind_for,from,to);
			foset(i_pot,:) = long_bitcmp(long_onbit2num(belief(ind_bel).bp(i_pot).cd_focal_set,card),card);
		otherwise 
			% not possible with continuous			
		end	
	end	
	if strcmp(data_type,'point') 
		lkh = lkh / sum(lkh); % the bayesian solution as infinitesimal lkh (f(x)dx)
		how_save = 'bbf';
	else	% interval, thus wc
		how_save = 'wc';
	end
case 'Integers'  % not for Betf
	for i_pot = 1:nbr_pot
		ind_for = ind_form_pdf(i_pot);
		% the position of the conditioning element 
		% fosets arfe the complemeents of the singletons
		foset(i_pot,:) = long_bitcmp(long_onbit2num(belief(ind_bel).bp(i_pot).cd_focal_set,card),card)
		pdf = belief(ind_bel).bp(i_pot).form(ind_for).representation;	
		if strcmp(pdf,'binomial')
			lkh(i_pot) = lkh_from_pdf(pdf,param,from,to);	
			how_save = 'wc';
		else
			% it means Integers not binomial, does not exist
			how_save = 'dont_save';
		end	
	end
end

switch how_save
case 'bbf'
	belief(ind_belT).bp(1).form(1).type = 'm';
	belief(ind_belT).bp(1).form(1).representation = 'selected';
	belief(ind_belT).bp(1).form(1).values = lkh';
	belief(ind_belT).bp(1).form(1).focal_sets = foset;
	% the singletons
case 'wc'
	belief(ind_belT).bp(1).form(1).type = 'wc';
	belief(ind_belT).bp(1).form(1).representation = 'selected';
	belief(ind_belT).bp(1).form(1).values = lkh';
	belief(ind_belT).bp(1).form(1).focal_sets = foset;
	% the complements of the singletons
case 'dont_save'
	% donothing
end

