function [m, mat_focal] = get_LCm_from_Pl(pl,ind_foc,cardinal)
% from the pl on the singletons, get the least committed m

% input :
% pl 		= column vector of pl order = singletons 1 to cardinal
% ind_foc	= [1:cardinal]'
% cardinal	= number of singletons

% output :
% m			= vector with masses
% mat_focal	= matrix with focal sets

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global nbr_bit_per_word

[sorted_lines useless] = sortrows([pl ind_foc]);

% eliminate the pl = 1
i_max = min(find(sorted_lines(:,1) == 1))+1;
if i_max < size(sorted_lines,1)
	sorted_lines(i_max:size(sorted_lines,1),:) = [];
end

m = diff([0 ; sorted_lines(:,1)]); % column  vector
% bit_ordered = long_num2bit(sorted_lines(:,2:size(sorted_lines,2)),cardinal);
bit_focal(1,1:cardinal) = 1;
for i = 2:size(m,1)
	bit_focal(i,:) = bit_focal(i-1,:);
	bit_focal(i,sorted_lines(i-1,2)) = 0;
end

% eliminate the pl = 0
while m(1) == 0
	m(1) = [];
	bit_focal(1,:) = [];
end

i_del = find(m == 0);
if ~isempty(i_del)
	m(i_del) = [];
	bit_focal(i_del,:) = [];
end

for i = 1:length(m)
	mat_focal(i,:) = long_bit2num(bit_focal(i,:),cardinal);
end
