function bel_ind_for_BEL = prepare_initial_VBS_request(num_bel_input)
% we build all the objects for VBS
% fliplr the focal sets
% num_bel_input = list of bel number to use for propagation
% bel_ind_for_BEL = indcex of belief used in BELIEF
% with BELIEF(4) = belief(bel_ind_for_BEL(4))

global frame structure attribute variable belief infinity
global BELIEF VARIABLE ATTRIBUTE STRUCTURE FRAME BELTRACE QUERY NODE BJTREE

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% cleaning all residual of VBS if existed
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

BELIEF = [];
VARIABLE = [];
ATTRIBUTE = [];
STRUCTURE = [];
FRAME = [];
BELTRACE = [];
QUERY = [];
NODE = [];
BJTREE = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initialisation of VBS OBJECTS, and only needed BELIEF (otherwise BJTREE does not work properly)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

FRAME = frame;
STRUCTURE = structure;
ATTRIBUTE = attribute;
VARIABLE = variable;
BELIEF = belief;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% BUG: if I use VBS from tools (not from EVN) and one bba is categorical (m(A) = 1, A  universe) 
% and I ask projection on that variable with others, boum.
% no boum if done from EVN????
% so I discount by E-40 every categorical bba
for i = 1:length(BELIEF)
	[BELIEF(i)] = disc_categorical(BELIEF(i),1);
end	
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

used_bel_ind = ismember([belief(:).number],num_bel_input);
bel_ind_for_BEL = find(used_bel_ind);

ind_delete = find(used_bel_ind == 0); 
% those belief(index) I want to delete
BELIEF(ind_delete) = []; % I keep only those I need, packing done

% % % % for debugging
% detail_on_belief(BELIEF)
% % % % for debugging

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the foset as needed for VBS
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% VBS produces 10000000....0   01100 when cardi = 55 and element 1 52 53 on.
% with word1 = 10000000....0 = 5.6295e+14 = 2^49,    word2 = 12
% I need word1 = 00...0001 = 1, word2 = 00110 = 6
%
% the idea behind is 
% for GUI order is word(2) word(1) = 00110  0000...0001, we always go from right to left
% for VBS, bits are oredred as  10000000....0   01100, the 50 first go in word(1), the next 5 in word 2
% GUI respect lexicographic order.

for ik = 1:length(BELIEF)
	% making VBS foset from TBMLAB foset
	BELIEF(ik).bp(1).form(1).focal_sets = foset_interface(...
	BELIEF(ik).bp(1).form(1).focal_sets,...
	BELIEF(ik).domain_cardinality);
end

