function init_global_variables
% initiated the GLOBAL variablesproceed_with_tbm

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

% cearing all global variables as they survive when leaving the function
clear global

global frame structure mapping attribute variable belief
% these are the objects with all the data for belief function theory

global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
% the pin = [position index number] of each object
% they must be initialized, so they exist (but can be empty)
pin_frame = [];
pin_structure = [ ];
pin_attribute = [ ];
pin_variable = [ ];
pin_mapping = [ ];
pin_belief = [ ];

% the triple is [position, index, number]
% position is 0 1 2 3 4 5...
% index is monotone increasiong, similar to position but with gaps
% number is any number 
% posiiton is the position in the list as used for the listbox, so I can read click position
% index and number are for object(index).number = number

global root_file_name save_path
% the root of the name of the files where everything is saved
% has to be in a folder with path obtained by
% save_path = fullfile(matlabroot,'toolbox','TBMLAB_Folder',...
%	'TBMLAB','Data_storage','');
% put a folder Data_storage in TBMLAB in TBMLAB_Folder in
% toolbox in MatLab folder.

global pathname2TBMLABvers
% built in build_pathname, path up to TBMLABversion folder

global screen_size   position_help_Wdw   position_help_text
% dimensions of the figures

global gui_position
% storing all position of gui objects in ONE file

global CallBackData  CallBackCell
% a way to transfer data in a callback, CallBackData(i)  CallBackCell{i}

global stored_text 
% the texts stored for comments, helps etc...

global flags flags2 flags3 flag_str
% a numearical (flag) or struing (flag_str) flag I can use 
% to communicate with the CallBack used in GUI 
flags3 = 0; % used for EVN node menus, to forbid (=1) change with belief potential editor

global nbr_bit_per_word
% number of bits that are stored in one address, normally 50
nbr_bit_per_word = 50;
if log2(bitmax) <= 50
	nbr_bit_per_word = log2(bitmax) - 1;
end
% beware VBS part is not OK for the case where nbr_bit_per_word is not 50 
% (the 50 bits per word is imposed locally)

global beta symb_and symb_or symb_impl symb_equiv symb_neg
% non secable blank, char(160) for PC, char(202) for Mac  XXXX maybe a problem with other equipemt
switch computer
case 'MAC2'
	beta = char(167);
	symb_neg = char(194);
case 'PCWIN'
	beta = char(223);
	symb_neg = char(172);
otherwise
	beta = char(223);
	symb_neg = char(172);	
end

symb_and = '&'; % char(38)
symb_or = 'v';
symb_impl = '->';
symb_equiv = '<->';

global max_pc_cumul_mass    bbm_display_order   max_nbr_bel_create_attXindex
% max percent of cumulative normalized masses to be displayed (default = 95)
max_pc_cumul_mass = 95;
% oreder ubnder which bp are listed (as entered, by magnitude)
bbm_display_order = 'by magnitude';

% max nbr of created variables, to avoid crash by memeory overflow.
max_nbr_bel_create_attXindex = 512;

global aifv_num  % for duplicate  XXXXXX
% n X 4 x 2 matrix, 
% aifv(i,:,1) = [attribute_number individual_number frame_number variable_number]
% aifv(i,:,2) = [attribute_index  individual_index  frame_index  variable_index ]
% indeed a variable is one attribute + one frame, some indexes

global width_demo_text
% in pixel
width_demo_text = 600;

global  button_num_where_pointer  long_text_help   position_figure_for_text  
global  pos_button_in_pixels    hd_lg_tx_fig  top_position_for_text
% these global are only for communicating with dialog_button though a callback fct
% used in select_buttons and get_text_for_button_pointer
hd_lg_tx_fig = -1; % just to get someting and avoid crash with isempty

global help_level 
help_level  = 2;  % initial help level max as user is beginner

global button_size
button_size(1) = 50; % width buttons in pixel
button_size(2) = 20; % height buttons in pixel

global crash_option
% when developing better use crash_option = 0 as we get the trace for errors
% an option available for developper only, 
crash_option = 1;

global proceed_with_tbm
% the flag that satys 1 up to when you wnat to quit tbm_machine, 
% used in back_to_menu and run_quit_init_all_objects
proceed_with_tbm = 1;

global node pin_node link pin_link  need_uiresume flags flagstr scaling_coef
global hd_smallUL_Button_EVN light_green light_red plot_limits_initial  plot_limits_now 
global histo pin_histo EVN_figure_exists
% used by EVN
EVN_figure_exists = 0; % tells if EVN figure is available of not

global pull_down_menu
% for each menu, when using back_to_menu, 
% pull_down_menu(i).label
% pull_down_menu(i).status = 1 for on or 0 for off

global hd_help_object hd_help_menu name_calling_window
% handle of the listbox object and calling menu with the help attached to each individual window
hd_help_object = [];
hd_help_menu = [];
name_calling_window = '';

global width_long_text_help_window  
% initail preference gor GUI
width_long_text_help_window = 0.4   ;

global cclick
% what to click when in query with pull down options
switch computer
case 'MAC2'
	cclick = 'cmd_click';
otherwise
	cclick = 'right_click';
end

global nice_yellow
% the yellow backgorund used in lisitng_exisitng
nice_yellow = [1 1 .5];

global max_card_fmt
max_card_fmt = 18;  % max number of elements to use FMT (18 = 2.5 sec for m to b)
% probably machine dependent, must be fixed if memory overflow, a parameter for preference 

global gui_settings
% see setting_gui_default_values, needed to restore them when quitting

global my_font
% the fonts for various location

global Which_Courier
switch computer
case {'MAC2','MAC'}
	Which_Courier = 'Courier';
otherwise
	Which_Courier = 'Courier New';
end

global figure_data
% storinf data reltive to figures, like in figure_data(index_figure).menu (see menu_manager and make_fig_menu

global help_label
% the label use for menu help. On Mac Matlab5.2 no way to get rid of Mas Help menu, hence I used another name
switch computer
case 'MAC2'
	help_label = 'TBM Help';
otherwise
	help_label = 'Help';
end

global infinity infinity_str
infinity = 1E40;
infinity_str = '1E40';

global open_binary_menu_used
open_binary_menu_used = 'no';

global colors
colors = list_color;
