function [hd_in_sets,cardinal] = get_element_display(belief_index,bp_handle_fig,nature_w)
% building the display for entereing data when sets are defined as list of elements 
%
%   Version : Jan 19, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global gui_position  
global stored_text 
global flags flag_str
global nbr_bit_per_word
global keyhit
global Which_Courier

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the labels for the worlds of the prodcut space, ready for display
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[var_name_list, element_list, element_numbers,useless] = ...
creating_elements (belief(belief_index).domain_variable);

[cardinal useless] = size(element_numbers);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the mass query area at bottom			
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% I put a KeyPressFcn dans le bp figure so that when hit return, mass accepted (but not belief)
% avoid mouse after entering the mass, key in keyhit
% % % % % % % set(bp_handle_fig,'KeyPressFcn','callback_key_hit;uiresume;')

% bottom frame 
ihd = 1;
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'Position',[.001 .001 .998 .048],...
'Style','Frame');

% mass query area: text
ihd = ihd + 1; %2
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'Position',[.004 .004 .24 .042],...
'Style','Text',...
'String',[nature_w,' given to selected set = '],...
'HorizontalAlignment','right');

% mass query area: get new mass
ihd = ihd + 1; %3
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'Position',[.25 .004 .10 .042],...
'Style','Edit',...
'String','0.',...
'CallBack','callback_CR_edit;uiresume;');

% % % % % mass query area: text with cumulated mass
% % % % if nature_w == 'm'
% % % % ihd = ihd + 1;
% % % %  tt =  'Total allocated masses =';
% % % % 	tt = [text_total,' ','0.0'];
% % % % 	hd_in_sets(ihd) = uicontrol(...
% % % % 	'Parent', bp_handle_fig,...
% % % % 	'Position',[.36 .004 .33 .042],...
% % % % 	'Style','Text',...
% % % % 	'String',tt);
% % % % end

% mass query area: mass done button

% button mass OK
ihd = ihd + 1; %4
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'Position',[.40 .004 .08 .042],...
'Style','PushButton',...
'String',[nature_w,' OK'],...
'BackgroundColor',[1 0 0],...
'Callback','set(gco,''UserData'',''mass'');uiresume');

% button cancel. I only entrer ONE weight here
ihd = ihd + 1; %5
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'Position',[.50 .004 .08 .042],...
'Style','PushButton',...
'String','Cancel',...
'BackgroundColor',[1 0 0],...
'Callback','set(gco,''UserData'',''cancel'');uiresume');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% focal set area 			
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% list of every worlds in new product space
ihd = ihd + 1; %6
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'Position',[.001 .050 .998 .900],...
'Style','Listbox',...
'userdata','element_list',...
'HorizontalAlignment','left',...
'FontName',Which_Courier,...
'String',element_list,...
'min',0,...
'max',1000);			
% using Which_Courier is the trick to get vertical alignment					

% variable name frame
ihd = ihd + 1; %7
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'userdata','element_list',...
'Position',[.001 .951 .998 .048],...
'Style','Frame');

% variable name
ihd = ihd + 1; %8
hd_in_sets(ihd) = uicontrol(...
'Parent', bp_handle_fig,...
'Position',[.005 .953 .996 .040],...
'userdata','element_list',...
'Style','Text',...
'HorizontalAlignment','left',...
'FontName',Which_Courier,...
'String',var_name_list);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the help in comment window			
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
