function [hd_in_logic,button_operator] = get_log_expr_display(ibel,bp_handle_fig,nw)
% build display for entering logical expression 
% input for the logical expression that builds a focal set
% ibel 				= index of the belief object
% bp_handle_fig 	= handle of figure where data are entered

% Needed : button list of variables for that belief(ibel) (and their possible values if not logical)
% button list with operators and, or, not, impl, equiv, (, ), tautology, contradiction

%
%   Version : Jan 19, 03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position
global stored_text 
global expr
global flag
global button_size
global keyhit

% button_size 
posFig = get(bp_handle_fig,'Position');	
height_but= min(button_size(2)/posFig(4),.99);
width_but = min(button_size(1)/posFig(3),.99); 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get list of frames with their types = 1=logical, 2=numerical, 3=symbolic
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

list_num_var = belief(ibel).domain_variable;
% the numbers of the variables used by this belief for its domain : [45 6 32]

list_ind_var = pin_manipulation('variable','num2ind',list_num_var);
% the list of index of these variables : [2 7 4]

variable_list = {variable(list_ind_var).short_name};
% list of short names of variable [45 6 32] : [Vx3 Nice Size]

for ik = 1:length(list_ind_var)
	i = list_ind_var(ik);
	indfr= pin_manipulation('frame','num2ind',variable(i).frame);
	frame_list{ik} = [num2str(frame(indfr).number),' ', frame(indfr).full_name];
	switch frame(indfr).type
	case 'Logical'		
		list_typ_var(ik) = 1;
	case 'Integers'
		list_typ_var(ik) = 2;
	otherwise 
		% % % % 	case {'Binary','Classes_Un_ordered','Classes_Ordered'}		
		list_typ_var(ik) = 3;
	end	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the conversation boxes where the logical expression is displayed
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ihd = 0;
ihd = ihd + 1;
hd_in_logic(ihd) = uicontrol(...
'Parent',bp_handle_fig, ...
'Position',gui_position(:,15)', ...
'Style','edit', ...
'HorizontalAlignment','left', ...
'String','',...
'Tag','logop',...
'Callback','callback_CR_edit;uiresume;');

ihd = ihd + 1;
hd_in_logic(ihd) = uicontrol(...
'Parent',bp_handle_fig, ...
'Position',gui_position(:,15)' + [0  gui_position(4,15)+.005 0  .03-gui_position(4,15)], ...
'Style','text', ...
'HorizontalAlignment','left', ...
'String','Logical expression',...
'Tag','logop');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% set of control buttons for end formula and for cancel for this focal set, or full cance
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

button_operator_crtl = {'OK','Clear Expr.','Return'};

tooltip{1} = 'Accept Expression and Mass.';
tooltip{2} = 'Delete expression in text box.';
tooltip{3} = 'Go back to potential window.';

hidden_buttons = [];

hd = button_list(bp_handle_fig, gui_position(:,12), 'Control', ...
button_operator_crtl, 'clb_button_list(3,', hidden_buttons, tooltip );%)

for i = 1:length(hd)
	ihd = ihd + 1;
	hd_in_logic(ihd) = hd(i);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% button list of logical operators
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

button_operator = {'and','or','not','impl','equiv','(',')','True','False'};
it = 0;
it=it+1;tooltiplo{it} = 'Conjunction: Operator priority = impl/equiv, not, AND, or.';
it=it+1;tooltiplo{it} = 'Disjunction: Operator priority = impl/equiv, not, and, OR.';
it=it+1;tooltiplo{it} = 'Negation: Operator priority = impl/equiv, NOT, and, or.';
it=it+1;tooltiplo{it} = 'Implication: Operator priority = IMPL/equiv, not, and, or.';
it=it+1;tooltiplo{it} = 'Equivalence: Operator priority = impl/EQIV, not, and, or.';
it=it+1;tooltiplo{it} = '(: Modify operator priority.';
it=it+1;tooltiplo{it} = '): Modify operator priority.';
it=it+1;tooltiplo{it} = 'Tautology = ''universe''. Like p or not p.';
it=it+1;tooltiplo{it} = 'Contradiction = ''empty set''. Like p and not p.';

hd = button_list(bp_handle_fig, gui_position(:,7), 'Logical Operators', ...
button_operator, 'clb_button_list(1,',[],tooltiplo);%)

for i = 1:length(hd)
	ihd = ihd + 1;
	hd_in_logic(ihd) = hd(i);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% button list of variables
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd = button_list(bp_handle_fig, gui_position(:,6)', 'Variable List', ...
variable_list, 'clb_button_list(2,',{},[]); %)

for i = 1:length(hd)
	ihd = ihd + 1;
	hd_in_logic(ihd) = hd(i);
end

% order of button = order of the variables 
% list_num_var = [45 6 32] ...
% located at list_ind_var = [2 7 4] in buttons position flag(1) = [1 2 3]
% so var 32 is index 4 in button 3

