function get_sets_weights(belief_index,ind_bp,nw)
% the fct root of bp contruction

%
%   Version : Dec 5,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%



% I must build its hd_fig









global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position
global stored_text 
global expr
global flag
global button_size
global keyhit
global selvalbp
% global selvalbp if for linear program to get LCP solutions

% hd_fig id the Alternate General Window 
% the General Window is already used by the belief request

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the index for the new bp		
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

eval('okhere = belief(belief_index).bp;','okhere=[];')
% ok = []  because belief(belief_index) not yet defined or belief(belief_index).bp empty
if isempty(okhere)
	bp_index = 1;
else
	bp_index = length(belief(belief_index).bp) + 1; 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get list of frames with their types = 1=logical, 2=numerical, 3=symbolic
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ibel = belief_index;
list_num_var = belief(ibel).domain_variable;
% the numbers of the variables used by this belief for its domain : [45 6 32]

list_ind_var = pin_manipulation('variable','num2ind',list_num_var);
% the list of index of these variables : [2 7 4]

variable_list = {variable(list_ind_var).short_name};
% list of short names of variable [45 6 32] : [Vx3 Nice Size]

for ik = 1:length(list_ind_var)
	i = list_ind_var(ik);
	indfr= pin_manipulation('frame','num2ind',variable(i).frame);
	frame_list{ik} = [num2str(frame(indfr).number),' ', frame(indfr).full_name];
	switch frame(indfr).type
	case 'Logical'		
		list_typ_var(ik) = 1;
	case 'Integers'
		list_typ_var(ik) = 2;
	otherwise 
		% % % % 	case {'Binary','Classes_Un_ordered','Classes_Ordered'}		
		list_typ_var(ik) = 3;
	end	
end

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% % step 1 : getting the nature of the weights : one of m,b,bel,pl,nq,wc,wd
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% title = 'Nature of weights.';
% text = {'m','b','bel','pl','q','wc','wd','cancel'};
% hidden_buttons = [];
% k = 0;
% k=k+1;tooltip{k} = 'basic belief masses';
% k=k+1;tooltip{k} = 'implicability function';
% k=k+1;tooltip{k} = 'belief function';
% k=k+1;tooltip{k} = 'plausibility function';
% k=k+1;tooltip{k} = 'commonality function';
% k=k+1;tooltip{k} = 'weights of the canonical conjunctive decomposition';
% k=k+1;tooltip{k} = 'weights of the canonical disjunctive decomposition';
% k=k+1;tooltip{k} = 'back to belief window';
% 
% poss = [0 0 0];
% [pushed_button, hd_buttons] = select_buttons(hd_fig, [.005 .005], text, title,...
% hidden_buttons, tooltip, 0, '');
% 
% switch pushed_button
% case 1;nw = 'm';
% case 2;nw = 'b';
% case 3;nw = 'bel';
% case 4;nw = 'pl';
% case 5;nw = 'q';
% case 6;nw = 'wc';
% case 7;nw = 'wd';
% end	
% % 
% delete(hd_buttons)	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% step 2 : get a subset of the frame of discernement
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% generate the window with the elmeents
[hd_in_sets,cardinal] = get_element_display(belief_index,hd_fig,nw);
% generate the window for the logical exprfession
[hd_in_logic,button_operator] = get_log_expr_display(belief_index,hd_fig,nw);
% hide them
set(hd_in_sets,'visible','off')
set(hd_in_logic,'visible','off')

% % % % set(hd_fig,'KeyPressFcn','callback_key_hit;uiresume;');
% the only keyhit accepted are those made IN the frame of the uicontrol it concerns

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%             Windows ready             %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%          Entering sets weights        %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
st_mass = [];
st_focal = [];
kill_bp = 0;
go_on = 1; 
cancel_bp = 0;

while go_on  % for every pair set-weight
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% step 3 : choose the window to enter a set
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	title = 'Set description.';
	text = {'Element list','Logical Expression','End','Cancel bp'};
	hidden_buttons = [];
	k = 0;
	k=k+1;tooltip{k} = 'Sets described by the set of its elements';
	k=k+1;tooltip{k} = 'Sets described by a logical expression';
	k=k+1;tooltip{k} = 'End entering set-weight.';
	k=k+1;tooltip{k} = 'Cancel this bp and go Back to belief window';
	poss = [0 0 0];	
	[pushed_button, hd_buttons2] = select_buttons(hd_fig, [.005 .005], text, title,...
	hidden_buttons, tooltip, 0, '');	
	delete(hd_buttons2);
	
	switch pushed_button
	case 1
		set(hd_in_sets,'visible','on')
		set(hd_in_logic,'visible','off')
	case 2 	
		set(hd_in_sets,'visible','off')
		set(hd_in_logic,'visible','on')
	case 3
		go_on = 0;
	case 4
		go_on = 0; % I quit without saving bp
		cancel_bp = 1;
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% step 4 : fill the set form and the weigth
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if go_on		
		switch pushed_button  % the entry_type
		case 1 % 'elem_list'
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% The set based on elements area
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			% call the list element to get ONE value			
			set(hd_in_sets(6),'Value',[]);
			set(hd_in_sets(4),'UserData',' ');
			set(hd_in_sets(5),'UserData',' ');		
			figure(hd_fig);		
			
			% i wait till the keyhit is return or I select the bbm OK button
			keyhit = 0;
			uiwait(hd_fig);
			
			if strcmp(get(hd_in_sets(4),'userdata'),'mass') | keyhit == 1
				keyhit = 1; 
				set(hd_in_sets(4),'userdata',' ');
				weight = str2num(strrep(get(hd_in_sets(3),'String'),'..','.'));
				% it user enter .5 where there is 0. , corrected
			end
			if strcmp(get(hd_in_sets(5),'userdata'),'cancel') | keyhit == 2
				keyhit = 2; % the cancel choice
				set(hd_in_sets(5),'userdata',' ');
			end	
		
			focus = [];
			bit_on = [];
			
			switch  keyhit 
			case 1	% thus keyhit = 1 return = weight OK			
				bit_on = get(hd_in_sets(6),'Value');
				% find out if this focal set not yet encountered
				% so never twice same focal set what is perfect				
				new_focal_set = long_onbit2num(bit_on,cardinal);							
				made_new_focal = 1;						
				i = 0;
				go_on_search = 1;
				while  go_on_search
					i = i + 1;
					if i > length(st_mass)
						go_on_search = 0;
					else
						if new_focal_set == st_focal(i,:)
							go_on_search = 0;
							delete_mass = i;
							text = ['You enter twice the same set. Last value is ', '. New value is ','. Which one do I keep'];
							butch = {'previous','new one','none'};
							choice = text_with_n_buttons(hd_fig, text, butch, [0 0 0 0])
							switch choice
							case 1
								made_new_focal = 0;
							case 2
								st_mass(i) = weight;
								made_new_focal = 0;
							case 3
								st_mass(delete_mass) = [];
								st_focal(delete_mass,:) = [];	
								made_new_focal = 0;
							end % switch choice
						end % if new_focal_set == st_focal(i,:)
					end	% if i > length(st_mass)	
				end % while  go_on_search
			
				if made_new_focal
					st_mass = [st_mass;weight];
					st_focal = [st_focal; new_focal_set];
					set_meaning{length(st_mass)} = '';
					% exp_for_text is a nice text representation of the logical expression 
					% to be sotred in bp().form().foset_meaning{} = exp_for_text								
				end		
			case 2 % cancel confirmed
				go_go_on = 0;
			end	% keyhit	
		
		case 2 % 'log_expr'
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% The logical epxression area
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			last_log_expr = [];
			go_go_on = 1;
			while go_go_on
				% I go on till expr is OK
				
				% call the logical expr to get ONE value
				[log_expr,weight,cancel_it] = ask_one_value_log_expr...
				(belief_index,hd_fig,hd_in_logic(1),last_log_expr,list_typ_var,list_ind_var,button_operator,nw);
				
				% memory to give it back to ask_logical_expression if notok
				last_log_expr = log_expr;
				
				% canceling this weight 	
				if cancel_it | length(deblank(log_expr)) == 0 	| isempty(weight)					
					go_go_on = 0;
				else				
			
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					%
					% list of worlds and building the logical expression exp as used by eval(exp)
					%
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					
					[exp, exp_for_text] = get_logic_expression(log_expr);	
					
					% we generate all possible values of the variables in bel, 
					% put the value as the value of the short name
					% and check if exp is true
					% if true  this world is in the focal set
					% if false this world is not in focal set
					
					% shn_list{3} is the short name of variable(ind_var_in_bel(3)).short_name
					% and ind_var_in_bel(3) is the index of the variable which number is belief(belief_index).domain_variable(3)
					
					ind_var_in_bel = pin_manipulation('variable','num2ind',[belief(belief_index).domain_variable]);
					for i = 1:length(ind_var_in_bel)
						shn_list{i} = variable(ind_var_in_bel(i)).short_name;
					end
				
					% the list of worlds of this belief
					[var_name_list, element_list, element_numbers,useless] = ...
					creating_elements(belief(belief_index).domain_variable); 
					
					% element_list(i_world,3) concerns the third variable in belief(belief_index).domain_variable.
					% It is the variable which index is ind_var_in_bel(3) 
					% and name is shn_list(3)
					
					nbr_var = length(ind_var_in_bel);
					% the list of the frames of each variable
					fr_list = pin_manipulation('frame','num2ind',[variable(ind_var_in_bel).frame]);
					% fr_list(4) is the index of the frame which number is given by the variable in bel
					% which index = ind_var_in_bel(4), and short name is shn_list{4}
					
					card = length(element_numbers);			
					focus = [];
					bit_on = [];
					i_world = 0;
					bad_exp = 0;
					
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					while i_world < card & bad_exp == 0				
						i_world = i_world  + 1; % for every world
						
						%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
						%
						% looking if the exp is true in world i_world
						%
						%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
						
						% its value are the terms of the element_list(i_world,:) line
						% finding the value of the variable in that world
						for jv = 1:nbr_var
							i_el = element_numbers(i_world,nbr_var + 1 - jv);
							fr_elem = deblank(frame(fr_list(jv)).elements(i_el,:)); % get rid of right blanks				
							if  ~strcmp(frame(fr_list(jv)).type,'Logical') % this is not a logical variables	
								eval([shn_list{jv},' = fr_elem;'],'bad_exp = 1;');
							else % for logical variables 
								if strcmp(fr_elem,'T')
									eval([shn_list{jv},' = 1;'],'bad_exp = 2;') 
								else
									eval([shn_list{jv},' = 0;'],'bad_exp = 2;') 
								end
							end	
						end		
					
						% let  exp  = alive & ismember(name,{'Jo','All'})
						% and  shn_list{1} = 'alive', shn_list{2} = 'name'
						% so the eval becomes alive = 1, name = 'Bob', in which eval(exp) is false
						
						% we test the correctness of the logical expression once
						if i_world == 1
							eval([exp,';bad_exp = 0;'],'bad_exp = 3;')
						end
					
						log_expr_correct = 1;
						if bad_exp  % bad expression			
							log_expr_correct = 0;
							text = 'This logiocal expression is not correct. ';
							switch bad_exp
							case 1
								text = [text 'Error in a non logical variable.']; 
							case 2
								text = [text 'Error in a logical variable.']; 
							case 3
								text = [text 'Error in use of logical operators.'];
							end
							hd_warn = warndlg(text);
							uiwait(hd_warn)
						end
					
						if bad_exp == 0				
							if eval(exp)
								% case where this world belongs to the focal set as the proposition is true
								% focus = [focus; element_list{i_world}];
								bit_on = [bit_on i_world];
							end
						end
					end % while i_world < card & bad_exp == 0	  
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					if ~bad_exp
						% find out if this focal set not yet encountered
						% if yes  refuse
						% so never twice same focal set what is perfect
						new_focal_set = long_onbit2num(bit_on,card);							
						made_new_focal = 1;						
						i = 0;
						go_on_search = 1;
						while  go_on_search
							i = i + 1;
							if i > length(st_mass)
								go_on_search = 0;
							else
								if new_focal_set == st_focal(i,:)
									go_on_search = 0;
									delete_mass = i;
									text = ['You enter twice the same set. Last value is ', '. New value is ','. Which one do I keep'];
									butch = {'previous','new one','none'};
									choice = text_with_n_buttons(hd_fig, text, butch, [0 0 0 0])
									switch choice
									case 1
										made_new_focal = 0;
									case 2
										st_mass(i) = weight;
										made_new_focal = 0;
									case 3
										st_mass(delete_mass) = [];
										st_focal(delete_mass,:) = [];	
										made_new_focal = 0;
									end % switch choice
								end % if new_focal_set == st_focal(i,:)
							end	% if i > length(st_mass)	
						end % while  go_on_search
					
						if made_new_focal
							st_mass = [st_mass;weight];
							st_focal = [st_focal; new_focal_set];
							set_meaning{length(st_mass)} = exp_for_text;
							% exp_for_text is a nice text representation of the logical expression 
							% to be sotred in bp().form().foset_meaning{} = exp_for_text								
						end			
						last_log_expr = []; % it is correct
						go_go_on = 0;
					end	% if bad_exp == 0
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					
				end % if cancel_it | length(deblank(log_expr)) == 0 | length(st_mass) == 0	
			end % while go_go_on so I got a correct expression
		end % switch pushed_button  
		% clean and hide both entry windows
		set(hd_in_sets,'visible','off')
		set(hd_in_logic,'visible','off')		
		
	end % if go_on
end % while go_on   all mass enterd is st_mass ans st-focal or I cancel the bp

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%           sets weights entered        %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%         LCP for missing weights       %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if ~cancel_bp
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% The weigths are in st_mass and the sets in st_focal
	% I'll proceed with another weigth till go_on = 0
	% in hich case I fimalize the weights with the LCP 
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% finalized the entry (with LCP)
	all_weight_in = 1;
	the_type = nw;
	switch nw
	
	case 'm'
		% get sum m and put unallocated to universe
		total_bbm = sum(st_mass);
		if total_bbm < 1 % what is not yet allocated is given to universe
			universe = get_universe(cardinal);
			new_focal = 1; % I check if universe was not yet entered
			for i= 1:length(st_mass)
				if universe == st_focal(i,:)
					st_mass(i) = st_mass(I) + 1 - total_bbm;
					new_focal = 0;
				end
			end		
			if new_focal
				st_mass = [st_mass ; 1-total_bbm];
				st_focal = [st_focal; universe];
				set_meaning{length(st_mass)} = 'universe';
			end	
		end	
		fit_with_lcp = 0;
		
		% 	case 'b' 
		% 		% put b(universe) = 1 
		% 		% if missing values, ask LCP completion
		% 		universe = get_universe(cardinal);
		% 		loc_es = 0; % location of empty set
		% 		new_focal = 1; % I check if universe was not yet entered
		% 		for i= 1:length(st_mass)
		% 			if universe == st_focal(i,:)
		% 				new_focal = 0;
		% 			end
		% 			if st_focal(i,:) == zeros(1,size(st_focal,2))
		% 				loc_es = i;
		% 			end
		% 		end		
		% 		if new_focal
		% 			st_mass = [st_mass ; 1];
		% 			st_focal = [st_focal; universe];
		% 			set_meaning{length(st_mass)} = 'universe';		
		% 		end	
		% 	
		% 		% do I have missing values ? if yes no need of bel and optimisation
		% 		all_weight_in = 1;
		% 		if length(st_mass) < 2^cardinal % yes
		% 			all_weight_in = 0;
		% 			% make a bel out of b
		% 			if loc_es 
		% 				st_mass = st_mass - st_mass(es);
		% 			end
		% 		end	
		% 		the_type ='bel';
		
	case 'bel'
		% 		% if bel(universe) missing, put 1, 
		% 		universe = get_universe(cardinal);
		% 		new_focal = 1; % I check if universe was not yet entered
		% 		for i= 1:length(st_mass)
		% 			if universe == st_focal(i,:)
		% 				new_focal = 0;
		% 			end
		% 		end		
		% 		if new_focal
		% 			st_mass = [st_mass ; 1];
		% 			st_focal = [st_focal; universe];
		% 		end	
		% 	
		% 		% do I have missing values ? if yes no need of bel and optimisation
		% 		all_weight_in = 1;
		% 		if length(st_mass) < 2^cardinal-1 % yes but no empty set weight
		% 			all_weight_in = 0;
		% 		end	
		
		fit_with_lcp = 1;
		
	case 'pl'
		fit_with_lcp = 1;
		% do I have missing values ? if yes no need of bel and optimisation
		% 		all_weight_in = 1;
		% 		if length(st_mass) < 2^cardinal - 1 % yes
		% 			all_weight_in = 0;
		% 			% make a bel out of b
		% 			if loc_es 
		% 				st_mass = st_mass - st_mass(es);
		% 			end
		% 		end	
		
		% 	case 'q'
		% 		% put q(empty set) = 1
		% 		% if missing values, need a LCP program, NA
		% 		BOUM 
		
		% 	case 'wc'
		% 		% keep as such (it means all missing values = 1)
		% 		% beware it may not be a belief function, check it NA XXXX
		% 		
		% 	case 'wd'
		% 		% keep as such (it means all missing values = 1)
		% 		% beware it may not be a belief function, check it NA XXXX
		
	end % switch nw

	% we save all the data in belief().bp().form(one or several) 
	% when missing data, we get the positive masses
	% I put in form(1) the m entered or computed, and in form(2) the inmput if it was not a m 
	% case interval srtill pending
	
	if fit_with_lcp
		% find missing values by optim
		selval_ind = 1; % unclear why such index needed
		selvalbp(selval_ind).belief = belief_index ;     % index of belief
		selvalbp(selval_ind).focalsets = st_focal  ;     % matrix of selected focal sets in long number format
		selvalbp(selval_ind).val = [st_mass st_mass] ;   % values of intervals for selected focal sets
		selvalbp(selval_ind).type = 'bel'        ;     % 'm', 'bel', 'pl' or 'betp'
		error_message=lcp_const(selval_ind);
		% belief(belief_index).bp(1). contains results  XXXX
		
		belief(belief_index).bp(ind_bp).form(1).type = 'm'; 
		belief(belief_index).bp(ind_bp).form(1).representation = 'selected'; 
		%  		belief(belief_index).bp(ind_bp).form(1).focal_sets % = st_focal; 	% m from lcp_const
		%  		belief(belief_index).bp(ind_bp).form(1).values % = st_mass;		% m from lcp_const
		% 		size(belief(belief_index).bp(ind_bp).form(1).focal_sets)
		% 		size(belief(belief_index).bp(ind_bp).form(1).values)	
		belief(belief_index).bp(ind_bp).form(1).log_expr = set_meaning; 
	
	end
	if  ~strcmp(the_type,'m')
		% enter data in bel
		belief(belief_index).bp(ind_bp).form(2).type = the_type; 
		belief(belief_index).bp(ind_bp).form(2).representation = 'selected'; 
		belief(belief_index).bp(ind_bp).form(2).focal_sets = st_focal;
		belief(belief_index).bp(ind_bp).form(2).values = st_mass;
		belief(belief_index).bp(ind_bp).form(2).foset_meaning = set_meaning; 
		for i = 1:length(st_mass)
			belief(belief_index).bp(bp_index).form(2).log_expr{i} = '';
		end
	
	end
end % if ~cancel_bp
