function bba_from_betp_elements(belief_index,bp_index)
% gui for building bba from pl on elements + LCP

%
%   Version : Aug 15, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global help_label  hd_help_menu 
global  keyhit  belief Which_Courier
global gui_position  figure_data  flags  help_level help_label

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure('name','Bba generated from BetP and LCP');
set(gcf,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Bba generated from BetP and LCP';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(1)','on');
% 
% k=k+1;make_fig_menu(ind_fig,k, help_label,0,'','on');
% k=k+1;make_fig_menu(ind_fig,k,'Window Helps On', 3,'general_clb(2)','on');
% k=k+1;make_fig_menu(ind_fig,k,'Window Helps Off',3,'general_clb(3)','off');

menu_manager('create',ind_fig)

hd_help = forced_display_helps(0,51);
% there is only one help so I just show it 
% display_helps put the Root Window in front with a help text

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the labels for the worlds of the product space, ready for display
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % % [list_discr,list_continuous, list_integers] = type_variable(belief(belief_index).domain_variable);

[var_name_list, element_list, element_numbers,useless] = ...
creating_elements(belief(belief_index).domain_variable);

cardinal = max(size(element_numbers,1),1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its data 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[handle_building_bba,handle_mass] = figure_for_get_bp_m(hd_fig,'from_BetP',element_list,var_name_list);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% for each element
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% default initial value is betp = 0

mat1 = zeros(cardinal,1);
mat2 = [1:cardinal]';

set(handle_mass(1),'String','BetP for singleton');	
on_bit = 0;

go_on = 1;
while go_on % the loop for one element
	
	mat1_str = strvcat(num2str(mat1));
	% present values as per now
	% list of every worlds in new product space
	
	for i = 1:cardinal
		v{i} = [element_list{i} mat1_str(i,:)];
	end
	set(handle_building_bba(2),	'String',v);			
	
	% I must propose a smart element, the next one, 
	% if not possible, the first with pl = 1, 
	% if none 1
	on_bit = on_bit + 1;
	if on_bit > cardinal
		on_bit = min(find(mat1 == 0));
		if isempty(on_bit)
			on_bit = 1;
		end
	end	
	set(handle_building_bba(2),'Value',on_bit); % element on_bit selected
	set(handle_mass(2),'UserData',' ','String',num2str(mat1(on_bit))); % default betp
	
	% i wait till the keyhit is returned or I select the bbm OK button
	go_uiwait = 1;
	while go_uiwait % the loop for all data for one element + menus
		% button userdata = ' '
		set(handle_mass(4),'UserData',' ');
		set(handle_mass(5),'UserData',' ');
		set(handle_mass(6),'UserData',' ');		
		set(handle_mass(2),'UserData',' ','String',num2str(mat1(on_bit))); % its stored betp
		
		keyhit = 0;		
		flags = 0;
		uiwait(hd_fig);			
		on_bit = get(handle_building_bba(2),'Value'); % element i selected	
		
		if flags(1)
			% case menu selected
			switch flags(1)
			case 1
				go_uiwait = 0;
				go_on = 0;
% % % % % % 			case 2
% % % % % % 				callback_help_menu(1,51,hd_fig)
% % % % % % 			case 3
% % % % % % 				callback_help_menu(2,51,hd_fig)
			end	
		else
			% case button selected	
			if strcmp(get(handle_mass(4),'userdata'),'mass') | keyhit == 1
				% I entered a mass
				go_uiwait = 0;
				mat1(on_bit) = str2num(get(handle_mass(2),'String'));	
				total_bbm = sum(mat1);	
				tt = ['Total allocated masses = ',num2str(total_bbm)];
				% text with cumulated mass
				set(handle_mass(3),'string',tt);
				if total_bbm > 1
					hdw = warndlg('Error. The sum of the masses entered is > 1. I proceed but you must correct them.');
					uiwait(hdw)
				end				
			end		
			if strcmp(get(handle_mass(5),'userdata'),'bp')
				% bp entered, I am thru. Do computation of bba, store it and quit figure
				% Confirm cancel of the whole bp
				text = 'Confirm all BetP are entered. If yes, I will build the bba and leave the window.';
				choice = text_with_n_buttons(hd_fig, text, {'Do it','Cancel'}, [0 0 0 0]);
				if choice == 1
					go_uiwait = 0;
					go_on = 0;
					
					% what is not yet allocated is split equally among all elements
					total_bbm = sum(mat1);
					if total_bbm < 1 
						% a short cut to get equiproba
						mm = (1 - total_bbm)/length(element_list);
						mat1 = mat1 + mm;
					end
				
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% saving BetP in form(2)
					ok = build_form(belief_index,bp_index,2,'BetP','selected',mat2,mat1,[],[]);					
					%
					% the real computation : building the LC bba isoplausibility with Pl
					%
					[m, mat_focal] = get_LCm_from_BetP(mat1,mat2);
					%
					% saving data
					%
					ok = build_form(belief_index,bp_index,1,'m','selected',mat_focal,m,[],[]);
					%
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				end
			end			
			if strcmp(get(handle_mass(6),'userdata'),'cancel')		| keyhit == 2		
				% Confirm cancel of the whole bp
				text = 'Confirm you want to delete the bba you were building.';
				choice = text_with_n_buttons(hd_fig, text, {'Do it','Cancel'}, [0 0 0 0]);
				if choice == 1
					go_uiwait = 0;
					go_on = 0;
				end
			end
		end	
	end % while go_uiwait
end % while go_on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% deleting figure and its figure_data
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

delete(hd_help)
delete(hd_fig)
figure_data(ind_fig) = [];
