function [log_expr,mass,cancel] = ask_logical_expression_new(ibel,bp_handle_fig,...
sum_masses,log_expr_correct,last_log_expr,hd_logexp,...
shn_list,frame_list,list_typ_var,list_ind_var,button_operator)
% input for the logical expression that builds a focal set and gives it a mass

% ibel 				= index of the belief object
% bp_handle_fig 	= handle of figure where data are entered
% sum_masses 		= sum allocated masses up to here
% log_expr_correct  = 0 = you produce a non logical expression (thus error)
% last_log_expr		= the last entered logical expr 
% hd_logexp			= handle from get_m_log_init_screen
% shn_list			= short names of the variables
% frame_list		= frame for the variables
% list_typ_var		= type of the variables
% button_operator	= label of the buttons (logical operators {2} and control {1})

% log_expr			= the logical expression you have entered (may be wrong)
% mass 				= the bbm allocated to that focal set
% cancel			= 0 if OK, 
%					= 1 if operation canceled (nothing saved in belief), 
%					= 2 if quit (thus save stored data)

% at exit, we MUST produce (an expression and a mass)   or   cancel = 1
% or a wait request (thus with empty mass + empty expr but cancel = 0)

%
%   Version : Feb 18,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable pin_mapping pin_belief
global gui_position flag button_size keyhit

mass = 0;
log_expr = '';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% if log expr not ok, I reuse it , else I put ''
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

if log_expr_correct == 0
	set(hd_logexp{1}(1),'String',last_log_expr);
else
	set(hd_logexp{1}(1),'String','');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% loop repeated till we have a OK expr + OK mass
% or we say cancel bp, or we quit (so repeat if expr not OK only)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

go_go_on = 1;
while go_go_on
	set(hd_logexp{2}(6),'visible','off'); % the quit button
	if log_expr_correct == 0
		hide_buttons(0,1,hd_logexp)
	else
		hide_buttons(0,0,hd_logexp)
	end
	set(hd_logexp{1}(3),'visible','off');
	set(hd_logexp{1}(4),'visible','off');	
	
	go_on = 1;	
	cancel = 0; % 0 = no cancel,   1 = quit without saving,   2 = quit with save
	
	while go_on
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% building the expression
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		% needed for ok keyhit		
		set(bp_handle_fig,'currentobject',hd_logexp{1}(1))
		
		% 		gco_pos = get(gco,'position')
		% 		gcf_pos = get(gcf,'position')
		% 		pos_xy = [gco_pos(1)+gco_pos(3)/2   gco_pos(2)+gco_pos(4)/2]
		% 		pos_xy = [gcf_pos(1)+gcf_pos(3)*pos_xy(1)  gcf_pos(2)+gcf_pos(4)*pos_xy(2)]
		% % 		set(0, 'pointerlocation',pos_xy)
		% 		set(bp_handle_fig,'currentpoint',pos_xy)
		% % 		set(gco,'selected','on')	
		
		flag = [0 0]; keyhit = 0;
		uiwait(bp_handle_fig)
		
		% fprintf(1,'\nflags = %3i %3i keyhit = %3i %s',[flag keyhit get(h_expr,'string')]);
		% uiresume from return in expression box
		
		if flag(2) == 0 & keyhit == 1
			% generated by clb on return in expr box, and not by button
			% assimilated to control = OK
			flag(2) = 3;
			flag(1) = 1; % expression is OK
		end
	
		% uiresume from button panel
		% examining the flag(2) which state which panel was selected 1 = log, 2 = var, 3 = control
		if flag(2) == 3 % the control panel
			switch flag(1) 
			case 1 % OK
				cancel = 0;
				flag(2) = 1; flag(1) = 8; % so I end expression
				set(hd_logexp{2}(6),'visible','on'); % the quit button
			case 2 % Quit and save
				cancel = 2;
				flag(2) = 0; % so I skip switch logvar and ask for new expr	
				go_on = 0; % and I leave while go_on
				go_go_on = 0;
			case 3 % Clear Expr.
				expr = '';
				set(hd_logexp{1}(1),'String',expr);
				flag(2) = 0; % so I skip switch logvar and ask for new expr
				hide_buttons(0,0,hd_logexp)
			case 4 % Cancel no save
				expr = '';
				set(hd_logexp{1}(1),'String',expr);				
				cancel = 1;
				flag(2) = 0; % so I skip switch logvar and ask for new expr	
				go_on = 0; % and I leave while go_on
				go_go_on = 0; 
			end
		end
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% list of values in a listbox
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		% flag comes from callback of button_list 
		butt   = flag(1);	% the selected button
		logvar = flag(2);	% the pushed button is in log operator list (1) or in var list (2)
		
		expr = get(hd_logexp{1}(1),'String');
		expr = [expr, ' ']; % to be sure it is not empty 
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% logvar 
		switch logvar 	
		case 1 % logical operator		
			if butt == 8  % end of expression input 
				if length(ddblank(expr)) 
					% thus I typed data other than spaces
					go_on = 0;
				else
					go_on = 1;
				end
			else
				expr = [expr,' ',button_operator{2}{butt}];
				set(hd_logexp{1}(1),'String', expr)					
				hide_buttons(1,butt,hd_logexp)
			end
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% logvar 
		case 2 % variable
	
			%%%%%%%%%%%%%
			%%%%%%%%%%%%% 
			% list_typ_var(butt) = 1 for logical, 2 for integers, 3 for other
			%%%%%%%%%%%%% 
			
			switch list_typ_var(butt)
			case 1 % logical
				% just keep it,	elem = {'F','T'};
			case 2 % numerical
				num_fr = variable(list_ind_var(butt)).frame;
				index_fr = pin_manipulation('frame','num2ind',num_fr);
				for i = frame(index_fr).min: frame(index_fr).max
					elem{i} = num2str(i);
				end
			case 3 % symbolic
				num_fr = variable(list_ind_var(butt)).frame;
				index_fr = pin_manipulation('frame','num2ind',num_fr);
				elem = frame(index_fr).elements;		
			end % switch list_typ_var(butt)
		
			%%%%%%%%%%%%% 
			%%%%%%%%%%%%%
			if list_typ_var(butt) > 1 
				% not for logical variable
				% the listbox with the possible values of the frame of the variable
				hd_elem(1) = uicontrol(...
				'Parent',bp_handle_fig, ...
				'Position',gui_position(:,7), ...
				'Style','listbox', ...
				'string',elem,...
				'max',1000,...
				'value',[]);
				
				sel_elem = [];
				while length(sel_elem) == 0					
					% comments stop till you hit Go_On on panel
					text = 'Select the possible values by multi selection. Then click Go_On';
					choice = text_with_n_buttons(bp_handle_fig, text, {'Go_On'}, [1]);				
					sel_elem = get(hd_elem,'value');
					if length(sel_elem) == 0
						text = 'You MUST select at least one possible value. Do it.';
						choice = text_with_n_buttons(bp_handle_fig, text, {'OK'}, [1]);				
					end
				end
			
				set(bp_handle_fig,'KeyPressFcn','callback_key_hit;uiresume;');
				% keyhit becomes 1-2-3 when I hit CR, Esc, Erase in the figure area
				
				delete(hd_elem);					
			end % if list_typ_var(butt) > 1 
		
			%%%%%%%%%%%%%
			%%%%%%%%%%%%%  
			
			switch list_typ_var(butt)
			case 1 % logical variable
				expr = [expr,' ',shn_list{butt}];			
			case 2 % numbers. I need [ 43 56 17] as a string
				text = ['(', shn_list{butt},' in [', num2str(sel_elem) ,'])'];					
				expr = [expr,text];
			case 3 % symbols. I need {'vv','cc'}
				text = [' (', shn_list{butt},' in {','''',elem(sel_elem(1),:),''''];				
				for i = 2:length(sel_elem)
					text = [text,',''', elem(sel_elem(i),:),''''];
				end
				text = [text,'})'];
				expr = [expr,text];
			end	% switch list_typ_var(butt)
		
			hide_buttons(2,[],hd_logexp)
			set(hd_logexp{1}(1),'String', expr) ;			
			
			%%%%%%%%%%%%% 
			%%%%%%%%%%%%%
			
		end % switch logvar
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
	end % of while go_on 

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% entering the mass input area
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	if length(ddblank(expr)) % thus there is a focal set = logical expression and I need its mass
		hide_buttons(-1,0,hd_logexp);
		set(hd_logexp{1}(4),'visible','on','String',{'Enter mass.','End with OK button.', ['Total mass = ',num2str(sum_masses)]});
		set(hd_logexp{1}(3),'visible','on','String','0');
		log_expr = expr;
		
		set(bp_handle_fig,'currentobject',hd_logexp{1}(3))
		% so the gco is the correct object for the keyhit
		
		you_are_stupid = 1; % to avoid hitting out of control or using return
		while you_are_stupid	
			
			flag = [0 0]; keyhit = 0;
			uiwait(bp_handle_fig)  % input mass, entered by either return or pushbuton OK
			
			if keyhit == 1 % I hit return, hence mass entered
				go_go_on = 0;
			end
		
			if go_go_on == 0 % I hit return in hd_logexp{1}(3)
				cancel = 0;	
				you_are_stupid = 0;
			else % I select a control button
				% examining the flag(2) which states which panel was selected 1 = log, 2 = var, 3 = control
				if flag(2) == 3 % the control panel
					you_are_stupid = 0;
					switch flag(1) 
					case 1 % Mass OK, proceed
						cancel = 0;
						go_go_on = 0;												
						eval(char(13))
					case 2 % mass OK, quit and store
						cancel = 2;	
						go_go_on = 0;	
						eval(char(13))
					case 3 % Clear Expr.
						expr = '';
						set(hd_logexp{1}(1),'String',expr);
						you_are_stupid = 0;
						% we start over with the logicl expression
					case 4 % Cancel no save
						cancel = 1; 
						go_go_on = 0;
					end
				else % i hit another set of buttons, how stupid
					text = 'Hit a button in CONTROL list. To proceed click Go_On';
					choice = text_with_n_buttons(bp_handle_fig, text, {'Go_On'}, [1]);
					% insults and repeat uiwait, it uses the you_are_stupid	
					set(bp_handle_fig,'KeyPressFcn','callback_key_hit;uiresume;');					
				end		
			end % if go_go_on == 0
		
		end % while you_are_stupid	
	
		% the saved mass
		mass = str2num(get(hd_logexp{1}(3),'String'));
		
	end % if length(ddblank(expr)) 

end % while go_go_on use only if clear expression was used when in mass area
