function [foset, bad_exp] = get_m_log_foset(expr,belief_index,ind_var_in_bel, shn_list)
% verify that expr is a correct logical expr (otherwise ok = 0)
% then find the decimal representation of the set as a long number

%
%   Version : Feb 14,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global belief variable frame

% we generate all possible values of the variables in bel, 
% put the value as the value of the short name
% and check if expr is true
% if true  this world is in the focal set
% if false this world is not in focal set

% shn_list{3} is the short name of variable(ind_var_in_bel(3)).short_name
% and ind_var_in_bel(3) is the index of the variable which number is belief(belief_index).domain_variable(3)


% we must modify the short names of terh indexed variable as a(b) and a(b,c) are NOT ok for eval MatLab
% the short namles are in shn_list, we look if any is in expr, change it into a_b_ and a_b_c_

for i=1:length(shn_list)
	shn_list_new{i} = strrep(shn_list{i},'(','_');
	shn_list_new{i} = strrep(shn_list_new{i},')','_');
	shn_list_new{i} = strrep(shn_list_new{i},',','_');	
	expr = strrep(expr,shn_list{i},shn_list_new{i});
end
shn_list = shn_list_new;

% the list of worlds of this belief
[var_name_list, element_list, element_numbers,useless] = ...
creating_elements(belief(belief_index).domain_variable); 

% element_list(i_world,3) concerns the third variable in belief(belief_index).domain_variable.
% It is the variable which index is ind_var_in_bel(3) 
% and name is shn_list(3)

nbr_var = length(ind_var_in_bel);
% the list of the frames of each variable
fr_list = pin_manipulation('frame','num2ind',[variable(ind_var_in_bel).frame]);
% fr_list(4) is the index of the frame which number is given by the variable in bel
% which index = ind_var_in_bel(4), and short name is shn_list{4}

card = length(element_numbers);			
focus = [];
bit_on = [];
i_world = 0;
bad_exp = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while i_world < card & bad_exp == 0				
	i_world = i_world + 1; % for every world
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% looking if the expr is true in world i_world
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% its value are the terms of the element_list(i_world,:) line
	% finding the value of the variable in that world
	for jv = 1:nbr_var
		i_el = element_numbers(i_world,nbr_var + 1 - jv);
		fr_elem = ddblank(frame(fr_list(jv)).elements(i_el,:)); % get rid of right/left blanks				
		if  ~strcmp(frame(fr_list(jv)).type,'Logical') % this is not a logical variables	
			eval([shn_list{jv},' = fr_elem;'],'bad_exp = 1;');
		else % for logical variables 
			if strcmp(fr_elem,'T')
				eval([shn_list{jv},' = 1;'],'bad_exp = 2;') 
			else
				eval([shn_list{jv},' = 0;'],'bad_exp = 2;') 
			end
		end	
	end		

	% let  expr  = alive & ismember(name,{'Jo','All'})
	% and  shn_list{1} = 'alive', shn_list{2} = 'name'
	% so the eval becomes alive = 1, name = 'Bob', in which eval(expr) is false
	
	% we test the correctness of the logical expression once
	if i_world == 1
		eval([expr,';bad_exp = 0;'],'bad_exp = 3;')
	end

	log_expr_correct = 1;
	if bad_exp  % bad expression			
		log_expr_correct = 0;
		text = 'This logiocal expression is not correct. ';
		switch bad_exp
		case 1
			text = [text 'Error in a non logical variable.']; 
		case 2
			text = [text 'Error in a logical variable.']; 
		case 3
			text = [text 'Error in use of logical operators.'];
		end
		hd_warn = warndlg(text);
		uiwait(hd_warn)
	end

	if bad_exp == 0	
		if eval(expr)
			% case where this world belongs to the focal set as the proposition is true
			% focus = [focus; element_list{i_world}];
			bit_on = [bit_on i_world];
		end
	end
end % while i_world < card & bad_exp == 0	 

foset = long_onbit2num(bit_on,card);
