function [ind_var_in_bel, shn_list, frame_list,list_typ_var,card] = get_m_log_init_variable(belief_index)
%

%
%   Version : Feb 18,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global belief variable frame

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% number, index of the variables 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% the numbers of the variables used by this belief for its domain : [45 6 32]
list_num_var = belief(belief_index).domain_variable;
% the list of index of these variables : [2 7 4]
ind_var_in_bel = pin_manipulation('variable','num2ind',list_num_var);

% variable names may only contains alphanumericals and _ and ( ) and ,
% the logical expr translators requires variable short names and frame.elem  without blank or space.
% hence I must adapt all input so that there no spcase in short names end elements lables

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% list of short names of variables involved in the bel 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

shn_list = {variable(ind_var_in_bel).short_name};
% list of short names of variable [45 6 32] : [Vx3 Nice Size]


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get list of frame numbers, full names, 
% with their types = 1=logical, 2=numerical, 3=symbolic
% stored in list_typ_var
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

card = 1;
for ik = 1:length(ind_var_in_bel)
	i = ind_var_in_bel(ik);
	indfr= pin_manipulation('frame','num2ind',variable(i).frame);
	card = card * frame(indfr).cardinality;
	frame_list{ik} = [num2str(frame(indfr).number),' ', frame(indfr).full_name];
	switch frame(indfr).type
	case 'Logical'		
		list_typ_var(ik) = 1;
	case 'Integers'
		list_typ_var(ik) = 2;
	otherwise 
		% % % % 	case {'Binary','Classes_Un_ordered','Classes_Ordered'}		
		list_typ_var(ik) = 3;
	end	
end
% adding variable universe and contradiction
ik = length(shn_list);
ik = ik + 1;
shn_list{ik} = 'universe';
list_typ_var(ik) = 1;
frame_list{ik} = 'universe';
ik = ik + 1;
shn_list{ik} = 'contradiction';
list_typ_var(ik) = 1;
frame_list{ik} = 'contradiction';
