function edit_bp_with_log_expr(belief_index,bp_index,ind_for,log_expr_exist)

%
%   Version : July 9,03
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global flags  help_level
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global screen_size figure_data figure_handles 
global Which_Courier stored_text help_level

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% I want to edit log expr
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
cardinal = prod(belief(belief_index).domain_cardinality);
nbr_fosets = length(belief(belief_index).bp(bp_index).form(ind_for).values);
scrsize = screen_size;

for iline = 1:nbr_fosets
	if iline <= 9
		val = ['  ',num2str(iline)];
	elseif iline <= 99
		val = [' ',num2str(iline)];
	else
		val = num2str(iline);
	end
	mass = belief(belief_index).bp(bp_index).form(ind_for).values(iline);
	if log_expr_exist(iline)
		line_text{iline} = [val,' ',num2str(mass,'%5.3f'),' ',...
		belief(belief_index).bp(bp_index).form(ind_for).log_expr{iline}];
	elseif belief(belief_index).bp(bp_index).form(ind_for).focal_sets(iline) == get_universe(cardinal)
		line_text{iline} = [val,' ',num2str(mass,'%5.3f'),' universe'];
	else
		line_text{iline} = [val,' ',num2str(mass,'%5.3f'),' no logical epxression'];
	end					
end % for iline = 1:nbr_fosets

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

scrsize = screen_size;
height_window = scrsize(4)-100;
width_window = scrsize(3)-20;
pos_fig = [10 50  width_window height_window];

hd_fig = figure(...
'Units','pixels',...
'Color',[1 1 1], ...
'name','bba editor: logical expression mode');
set(gcf,'position',pos_fig);

ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'bba editor: logical expression mode';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = pos_fig;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% fontsize for Which_Courier
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

switch computer
case 'MAC2'
	ftsz = 10;
otherwise
	ftsz = 9;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% select which focal set/mass to modify
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_lg_expr = uicontrol(hd_fig,...
'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
'position',[1 65 pos_fig(3)-2 pos_fig(4)-66],...
'style','listbox',...
'max',1000,...
'string',line_text);

go_on = 1;
proceed = 1;
while go_on
	text = ['Select those focal sets for which you want to modify the logical espression and/or the mass.',...
	' For no modification, use Cancel.'];   					
	choice = text_with_n_buttons(gcf,text,{'OK','Help','Cancel'}, [.005 .005 300/scrsize(3) 50/scrsize(4)]);
	switch choice 
	case 1	
		list_bbm_for_change = get(hd_lg_expr,'value');
		% only those with a logical expression, so I kill stupid requests
		del_ind = [];
		for i = 1:length(list_bbm_for_change)
			if log_expr_exist(list_bbm_for_change(i)) == 0
				del_ind = [del_ind i];
			end
		end
		if length(del_ind)
			list_bbm_for_change(del_ind) = [];
		end	
		if length(list_bbm_for_change) == 0
			proceed = 0;
			hdw = warndlg('There is no logical expressions for editing. I quit');
			uiwait(hdw)
		end
		go_on = 0;
	case 2 % show help
		gcfmem = gcf;
		help_level_mem = help_level;
		help_level = 1; % I must cheat the display_helps that skip if help_level = 0
		hd_help = display_helps(1,[55]); 
		delete(hd_help);
		% the weclome text displayed. It stays till you select a menu, userdata = hc -> deleted 
		help_level = help_level_mem;
		figure(gcfmem);
	case 3
		list_bbm_for_change = [];
		go_on = 0;
	end	
end
delete(hd_lg_expr)

if proceed 
	% there are logical expr for editing
	for ifs = 1:length(list_bbm_for_change)	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% 
		% here we really edit the masses and focal sets	
		ok = get_m_from_logic_expr_new('edit', belief_index,bp_index,ind_for, ...
		list_bbm_for_change(ifs),...
		belief(belief_index).bp(bp_index).form(ind_for).log_expr{list_bbm_for_change(ifs)});
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	end	

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% 
	% handling missing masses, and packing 
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	total_bbm = sum(belief(belief_index).bp(bp_index).form(ind_for).values);
	if total_bbm < 1
		idx = length(belief(belief_index).bp(bp_index).form(ind_for).values) + 1;					
		belief(belief_index).bp(bp_index).form(ind_for).values = ...
		[belief(belief_index).bp(bp_index).form(ind_for).values ; 1-total_bbm ];
		belief(belief_index).bp(bp_index).form(ind_for).focal_sets(idx,:) = get_universe(cardinal);
		belief(belief_index).bp(bp_index).form(ind_for).log_expr{idx} = 'universe';								
	elseif total_bbm > 1
		hdw = warndlg('Error. The sum of the masses entered is > 1. I proceed but you must correct them.');
		uiwait(hdw)
	end					
	pack_mass(belief_index,bp_index,ind_for);	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% quit
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
delete(hd_fig)
figure_data(ind_fig) = [];
