function [ind_for] = edit_one_bp(belief_index,bp_index)
% selecting editing mode for a belief potential (set or logical)

% methods. 
% If focal sets are list of elements, I display all masses in one big screen
% at left all the elements, then columns with 0 1 for selected eleemnts and mass + a number at top
% then I can edit the whole screen  by
% 	changing a mass
% 	changing the on/off bits (click on digits and it flips 0 <-> 1.)
% at bottom buttons with store changes, forget about what I did.

% If focal sets are logical expression, I display all masses in one big screen
% one row = number, mass, log expr. 
% you can change the mass here, not the logical expressions
% to change logical expression, store the number for later request

% for ecah focal set, I display it 
%	as a logical expression if log_expr not empty, or 
%	as a set of elements
% you can then: 
%	delete it, 
%	change the mass, 
%	change the log expr or 
%	change the selected elemnts
% when done 
%	I can ask for next focal set or 
%	just quit (remaining focal sets/masses kept as it was) or 
%	cancel the whole procedure (and we keep the previous bp)

% NIC  Not for continuous and integers

% in case only sets and everything ok, you hardly see this window as we just go thru at full spead

% beware on PC it is right-click

%
%   Version : Aug, 15, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global screen_size
global frame structure mapping attribute variable belief
global gui_position help_label 
global stored_text 
global flags  help_level figure_data
global nbr_bit_per_word
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its help text
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_help = forced_display_helps(0,54);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% finding the m
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
if  ~isfield(belief(belief_index).bp(bp_index),'form')
	hd_warn = warndlg('There is no form in this belief potential. Did you create it?');
	ind_for = []; % so it exists for the calling function
	uiwait(hd_warn)
	go_on = 0;
elseif  length(belief(belief_index).bp(bp_index).form) == 0
	hd_warn = warndlg('There is no form in this belief potential. Did you create it?');
	ind_for = []; % so it exists for the calling function
	uiwait(hd_warn)
	go_on = 0;	
else
	% there are forms, be sure to get a m
	[computed_forms,uncomputed_forms, error_mode] = transform_bp(belief_index,bp_index,{'m'});
	ind_for = find_name('m',{belief(belief_index).bp(bp_index).form(:).type});
	
	if length(ind_for) > 1
		hd_warn = warndlg('There are several bba''s for this belief potential. Rule is: one bba per bp.');
		uiwait(hd_warn)
		go_on = 0;
	elseif length(ind_for) == 0
		hd_warn = warndlg('There is no form in this belief potential. I could not even create one.');
		ind_for = []; % so it exists for the calling function
		uiwait(hd_warn)
		go_on = 0;	
	else	

		% I have the m to edit: I must chose between log expr or bits
		% no logical expr, do edit direct
		% if there are logical expr, ask what to do direct (go ahead) or log expr editor			
		% if expr asked = list expression with foset numbers, mass, expr or blank,
		% store the numbers to change by multiselection click
		% propose each number as one logical expr to redo
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% locating the logical epxressions
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		nbr_fosets = length(belief(belief_index).bp(bp_index).form(ind_for).values);
		nbr_log_expr = 0;
		if  isfield(belief(belief_index).bp(bp_index).form(ind_for),'log_expr')
			fosets = belief(belief_index).bp(bp_index).form(ind_for).log_expr;
			if length(fosets) < nbr_fosets
				fosets{nbr_fosets} = '';
			end
			for i = 1:nbr_fosets
				log_expr_exist(i) = 0;
				if length(ddblank(fosets{i})) > 0
					log_expr_exist(i) = 1;
					nbr_log_expr = nbr_log_expr + 1;
				end
			end
			if nbr_log_expr == 0
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% there are no logical expressions
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				choice_edit = 1; % edit with sets
			else
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% there are logical expressions
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%				
				text = ['Nbr focal sets = ',num2str(nbr_fosets),', nbr logical epxressions = ',num2str(nbr_log_expr),...
				'. Select editing logical expressions or editing sets. To edit masses only, use Sets.'];   					
				choice = text_with_n_buttons(gcf,text,{'LogExp','Sets','Cancel'}, [0 0 0 0]);	
				
				switch choice
				case 1 % log exp	
					choice_edit = 2; % edit with log expr
				case 2 % sets
					choice_edit = 1; % edit with sets
				case 3 % quit
					go_on = 0; % no edit w
				end % switch choice
			end % if nbr_log_expr == 0		
		else
			choice_edit = 1 ; % edit with sets
		end % 		if  isfield(belief(belief_index).bp(bp_index).form(ind_for),'log_expr')		
	end % if length(ind_for) ~= 1
end %if  ~isfield(belief(belief_index).bp(bp_index),'form')			

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% closing window
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % % delete(hd_fig)
delete(hd_help)
% % % % % figure_data(ind_fig) = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% choice_edit tells if we go to sets or logic editor
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if go_on == 1
	switch choice_edit 
	case 1 % sets
		edit_bp_with_sets(belief_index,bp_index,ind_for);							
	case 2 % logical
		edit_bp_with_log_expr(belief_index,bp_index,ind_for,log_expr_exist);
	end			
end
