%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the line separators
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% = horizontal length 
total_hor_length =  left_sh + width_elements + (to_hor - from_hor + 1)*pos_box(3);

% = vertical length
total_vert_length = (to_vert  - from_vert +1 +nbr_forms+1)*pos_box(4) + top_sh;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% fontsize for Which_Courier
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global Which_Courier
switch computer
case 'MAC2'
ftsz = 10;
otherwise
ftsz = 9;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% drawing the horizontal lines
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pos_line = [0  pos_fig(4)-top_sh-(nbr_forms+1)*pos_box(4)   total_hor_length 1];

% under mass
hd_line(1) = uicontrol(hd_fig,...
'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
'style','text','position',pos_line,...
'backgroundcolor',[0 0 0],...
'ButtonDownFcn','clb_edit_bp;uiresume(gcf);');	

% the others horizontal lines
iline = 1;
vert_max = to_vert - from_vert + 1 ;
if to_vert ~= dist_inter_horiz*fix(to_vert/dist_inter_horiz)
	vert_max = to_vert - from_vert + 1 - dist_inter_horiz;
end
for i = 1:dist_inter_horiz:vert_max 
	iline = iline + 1;
	pos_line(2) = pos_line(2)-dist_inter_horiz*pos_box(4);
	
	hd_line(iline) = uicontrol(hd_fig,...
	'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
	'style','text','position',pos_line,...
	'backgroundcolor',[0 0 0],...
	'ButtonDownFcn','clb_edit_bp;uiresume(gcf);');	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% drawing the vertical lines
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pos_line = [left_sh+width_elements   pos_fig(4)-top_sh-total_vert_length   1 total_vert_length];

iline = iline+1;
hd_line(iline) = uicontrol(hd_fig,...
'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
'style','text','position',pos_line,...
'backgroundcolor',[0 0 0],...
'ButtonDownFcn','clb_edit_bp;uiresume(gcf);');	

% the others vertical lines
hor_max = to_hor - from_hor + 1 ;
if to_hor ~= dist_inter_vert*fix(to_hor/dist_inter_vert)
	hor_max = to_hor - from_hor + 1 - dist_inter_vert;
end
for i = 1:dist_inter_vert:hor_max
	iline = iline+1;
	pos_line(1) = pos_line(1)+dist_inter_vert*pos_box(3);
	hd_line(iline) = uicontrol(hd_fig,...
	'fontname',Which_Courier,'fontsize',ftsz,'units','pixels',...
	'style','text','position',pos_line,...
	'backgroundcolor',[0 0 0],...
	'ButtonDownFcn','clb_edit_bp;uiresume(gcf);');		
end	
