function [sel_butt] = bp_request_window(bp_handle_fig,ind_bel,ind_pot)

% index_set_but used to select the help tetx in    get_help_text_for_set_buttons
%
%   Version : Jan 22, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags   gui_position   width_long_text_help_window belief
% a set of global used only for callback, clear when button clicked
global  button_num_where_pointer  long_text_help   position_figure_for_text  flag_str flags2 flags3
global  pos_button_in_pixels    hd_lg_tx_fig  top_position_for_text   help_level

posFig = get(bp_handle_fig,'Position') ; % not normalized as it is a figure
button_w = 130/posFig(3);	% normalized
skip_w =.01;
total_width = button_w + 2*skip_w ;

r_pos = .665 + .33/2 - button_w/2 - skip_w;
skl = (.65 - 2*total_width)/3;
l_pos1 = .005 + skl;
l_pos2 = .005 + 2*skl + total_width;

it = 0;

it = it + 1; title{it} = 'Base on focal sets desribed by:';
text{it} = {'Sel.elem.: Cont/Int','Sel.elem.: No Cont/Int','Logical expression','Based on pdf: Cont/Int'};
k = 0;
k=k+1;tooltip{it,k} = 'Subsets built from lists of elements and limits of intervals. You select elements. Only one mass at a time.';
k=k+1;tooltip{it,k} = 'Subsets built from lists of elements or logiocal expressions. No Continuous or Integers allowed.';
k=k+1;tooltip{it,k} = 'Subsets built from a logical expression. You enter their expressiopn.';
k=k+1;tooltip{it,k} = 'Bba created by a .m function, or derived from a pdf. Fon Continuous/Integers only.';
positionXY(it,1:2) = [l_pos1 .105];
index_set_but(it) = 14;

it = it + 1; title{it} = 'Base on related functions:';
text{it} = {'BetP on elements','Pl on elements','With .m function NA','With random masses'};
k = 0;
k=k+1;tooltip{it,k} = 'Enter BetP on every elements, get least committed underlying bba.';
k=k+1;tooltip{it,k} = 'Enter pl or likelihoods on elements, get least committed underlying bba.';
k=k+1;tooltip{it,k} = 'Use your own .m function to generate bba.';
k=k+1;tooltip{it,k} = 'Generate ramdom masses on many focal sets. No Continuous or Integers allowed.';
positionXY(it,1:2) = [l_pos2 0.105];
index_set_but(it) = 9;

it = it + 1; title{it} = 'Base on LCP and some constraints on:';
text{it} = {'bel NA','pl NA','wc NA','wd NA'};
k = 0;
k=k+1;tooltip{it,k} = 'Enter bel on some or all subsets. If incomplete, filled by LCP.';
k=k+1;tooltip{it,k} = 'Enter pl on some or all subsets. If incomplete, filled by LCP.';
k=k+1;tooltip{it,k} = 'Enter wc on some or all subsets. If incomplete, filled by LCP.';
k=k+1;tooltip{it,k} = 'Enter wd on some or all subsets. If incomplete, filled by LCP.';
positionXY(it,1:2) = [l_pos1 0.510];
index_set_but(it) = 15;

it = it + 1; title{it} = 'Base on LCP and some Interval-value constraints on';
text{it} = {'m NA','bel NA','pl NA','wc NA','wd NA'};
k = 0;
k=k+1;tooltip{it,k} = 'Enter interval_valued m on some or all subsets. Masses computed from LCP.';
k=k+1;tooltip{it,k} = 'Enter interval_valued bel on some or all subsets. Masses computed from LCP.';
k=k+1;tooltip{it,k} = 'Enter interval_valued pl on some or all subsets. Masses computed from LCP.';
k=k+1;tooltip{it,k} = 'Enter interval_valued wc on some or all subsets. Masses computed from LCP.';
k=k+1;tooltip{it,k} = 'Enter interval_valued wd on some or all subsets. Masses computed from LCP.';
positionXY(it,1:2) = [l_pos2 0.510];
index_set_but(it) = 16;

it = it + 1; title{it} = 'View  a potential';
text{it} = {'Largest m + focal','Bel,BetP,Pl,bba','Best supported set','Several forms','Available forms'};
% if prod(belief(ind_bel).domain_cardinality) <= 12
% 	text{it} = {'Largest m + focal','Bel,BetP,Pl,bba','Best supported set','Several forms'};
% else
% 	text{it} = {'Largest m + focal','Bel,BetP,Pl,bba','Best supported set'};
% end

k = 0;
k=k+1;tooltip{it,k} = 'List the largest bbm and focal set';
k=k+1;tooltip{it,k} = 'Full screen display of Bel, BetP, Pl and of bba';
k=k+1;tooltip{it,k} = 'Full screen display of best supported set';
% if prod(belief(ind_bel).domain_cardinality) <= 12
k=k+1;tooltip{it,k} = 'Full screen display of several requested forms for one potential. Cardinal <= 12.';
k=k+1;tooltip{it,k} = 'List of forms available for present potential. To view them, use button above.';
% end
positionXY(it,1:2) = [r_pos .105];
index_set_but(it) = 11;

it = it + 1; title{it} = 'Control';
text{it} = {'Save data','Another belief','Get next potential','Quit'};
k = 0;
k=k+1;tooltip{it,k} = 'Save all objects. Do it often  for safety reasons.';
k=k+1;tooltip{it,k} = 'Display list of beliefs. You can select another one.';
k=k+1;tooltip{it,k} = 'Use the next potential (for conditional beliefs).';
k=k+1;tooltip{it,k} = 'Leave potential window.';
positionXY(it,1:2) = [r_pos .510];
index_set_but(it) = 12;

hd_fr(1) = uicontrol(bp_handle_fig, 'style','frame','position',[.005 .005 .65 .99]);
hd_fr(2) = uicontrol(bp_handle_fig, 'style','text','position',[.010 .9 .64 .09],...
'fontsize',18,'foregroundcolor','r',...
'string',{'Creating basic belief assignment','LCP is Least Commitment Principle'});
hd_fr(3) = uicontrol(bp_handle_fig, 'style','frame','position',[.665 .005 .33 .99]);
hd_fr(4) = uicontrol(bp_handle_fig, 'style','text','position',[.67 .9 .32 .09],...
'fontsize',18,'foregroundcolor','r',...
'string','View and Control');
for i = 1:4
	set(hd_fr(i),'userdata','sets_of_set_of_buttons')
end

pos_button_in_pixels_mem = []; % used for temporary storing of the button positions
imem = 0;
long_text_help_mem = [];
for it = 1:size(positionXY,1)
	hidden_buttons = [];	
	% flags produced in calling fct run_belief_potential and transferred as global
	% global flags2 == 1  when there are continuous or integers var, else 0.
	% global flags3 == 1 is used by EVN (for the node menus) to forbid the modific ation of any object 
	switch it 
	case 1
		%  {'Sel.elem.: Cont/Int','Sel.elem.: No Cont/Int','Logical expression','Based on pdf: Cont/Int'};
		if flags2 == 1
			% there are continuous integers var
			hidden_buttons = [2 3];
		else
			% there are NO continuous integers var
			hidden_buttons = [1 4];
		end	
		if flags3 == 1
			hidden_buttons = [1 2 3 4];
		end
	case 2
		% {'BetP on elements','Pl on elements','With .m function NA','With random masses'};
		if flags2 == 1
			% there are continuous integers var
			hidden_buttons = [1 2 4 ];
		end
		if flags3 == 1
			hidden_buttons = [1 2 3 4];
		end	
	case 3
		% {'bel','pl','wc NA','wd NA'};
		if flags2 == 1
			% there are continuous integers var
			hidden_buttons = [1 2 3 4];
		end
		if flags3 == 1
			hidden_buttons = [1 2 3 4];
		end	
	case 4
		% {'m','bel','pl','wc NA','wd NA'};
		if flags2 == 1
			% there are continuous integers var
			hidden_buttons = [1 2 3 4 5];
		end	
		if flags3 == 1
			hidden_buttons = [1 2 3 4];
		end	
	case 5
		% 'Largest m + focal','Bel,BetP,Pl,bba','Best supported set','Several forms','Available forms'
		if prod(belief(ind_bel).domain_cardinality) > 12
			% we must only avoid clever set repmresentation with high cardinality as very long
 			hidden_buttons = [4];
		end
		% if 'm' does not exist (like when cardinal is VERY large, and onlt wc BetP available)				
		if max(strcmp({belief(ind_bel).bp(ind_pot).form(:).type},'m')) == 0
			hidden_buttons = [1 2 3 4];
		end	
		% not ready for interval variables
		if flags2
			hidden_buttons = [1 2 3 4];
		end	
	case 6
		% control
		if prod(belief(ind_bel).conditioning_cardinality) > 1
			hidden_buttons = [];
		else
			hidden_buttons = [3];
		end	
	end
	long_text_help = [];
	pos_button_in_pixels = [];
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% where you really draw a button
	%
	select_buttons_no_wait(bp_handle_fig, [positionXY(it,:)], text{it}, title{it},...
	hidden_buttons, {tooltip{it,:}}, index_set_but(it),'UL',it);
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	pos_button_in_pixels_mem = [pos_button_in_pixels_mem   pos_button_in_pixels];
	for i = 1: size(long_text_help,1) 
		imem = imem + 1;
		kmax = str2num(long_text_help{i,1});
		for j = 1:kmax
			long_text_help_mem{imem,j} = long_text_help{i,j};
		end
	end
end
flags = [];
pos_button_in_pixels = pos_button_in_pixels_mem;
long_text_help = long_text_help_mem;

% hence I have 24 buttons as per now, and button position + help text in one matrix each (as if one set of buttons)
figure(bp_handle_fig)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
uiwait(bp_handle_fig)
% I select one of the buttons, brought back with flags and stored in sel_butt
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sel_butt = flags;
delete(findobj('userdata','sets_of_set_of_buttons'));
delete(findobj('userdata','button_long_helps'));

if ishandle(hd_lg_tx_fig) ; delete(hd_title_lg_tx); delete(hd_lg_tx_fig); end
% clearing the global data without using clear global that might misbehave?
button_num_where_pointer = []; 
long_text_help = [];   
position_figure_for_text = [];
pos_button_in_pixels = [];  
hd_lg_tx_fig = [];
top_position_for_text = [];



