function ok = build_form(ind_bel,ind_bp, ind_form, ntype, nrepr,nfoc,nmass,nlogexpr,contint)
% storing in object the values for a form
% checking not twice same focal set
% checking sum masses = 1

% used in get_bp_m, get_m_from_logic_expr_new
% not for pdf

%
%   Version : Mar 31, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global belief

if strcmp(nrepr,'ordered')
	nfoc = [1:pow2(length(nmass))]';
	% not OK is nbr erlements > 50, which is stupid when ordered
	% if ordered no Cont/Int
end

ok = 0;

ok_mass = 1;
if strcmp(ntype,'m')
	ok_mass = check_masses(nmass);
end

if ok_mass == 1	
	% verify length nfoc and nmass equal	
	if strcmp(nrepr,'ordered') | length(nmass) == size(nfoc,1)		
		nle = length(nlogexpr);
		if nle < length(nmass)
			for ii = nle+1:length(nmass)
				nlogexpr{ii} = '';
			end		
		end 
		ok = 1;
		belief(ind_bel).bp(ind_bp).form(ind_form).type = ntype;
		belief(ind_bel).bp(ind_bp).form(ind_form).representation = nrepr;
		[nl nc] = size(nmass);
		if nl > nc 
			% vertical vector
			belief(ind_bel).bp(ind_bp).form(ind_form).values = nmass;
			nbr_mass = size(nmass,1);
		else
			belief(ind_bel).bp(ind_bp).form(ind_form).values = nmass';
			nbr_mass = size(nmass,2);
		end
		belief(ind_bel).bp(ind_bp).form(ind_form).focal_sets = nfoc;
		belief(ind_bel).bp(ind_bp).form(ind_form).log_expr = nlogexpr;
		
		if nargin == 9 % thus contint exists in call			
			if ~isempty(contint)
				% handling cont iont variables
				% contint.limits = limit_contint;
				% contint.universe = limit_mem_x;
				% contint.variables = [var_continuous_integers(:).num];
				
				% belief(ind_bel).bp(ind_bp).form(ind_form).contint(i).limits = matrix; 
				
				% when continuous or integer var, for value(i) given to focal_sets(i,1:N) with bit(1:N) = list of bits of foset i
				% limits = matrix(j,k) is the limits for bits j, and k means var1_inf var1_sup var2_inf var2_sup ...
				% to give a limits for bits 0 is useless, and bit on without limits means limits are universe 
				
				% example
				% index values  	focal_set		
				%   1	 .2			01011 = 11		matrix 3x4 		[2 v1l v1u v2l v2u ; 1 v1l v1u v2l v2u ; 4 v1l v1u v2l v2u ] 
				%   2	 .5			00101 =  6		matrix 2x4		[1 v1l v1u v2l v2u ; 3 v1l v1u v2l v2u ]
				%   3	 .3			10000 = 16		matrix 1x4		[5 v1l v1u v2l v2u ]
				
				for i = 1:nbr_mass
					belief(ind_bel).bp(ind_bp).form(ind_form).contint(i).limits = contint.limits{i}; 
				end			
				if strcmp(ntype,'m')
					pack_mass(ind_bel,ind_bp,ind_form);
				end
			end
		end
	end
	if ok == 0
		% not ok, nothing stored
		hdw = warndlg('You ask to store a bba which is not correct. I cancel')
		uiwait(hdw)
	end
end		
