function display_all_forms(ind_bel,ind_pot,option)
% display in columns mode the selected functions, m, bel, pl...

% a long list as size = 2^cardinal
% not allowed for cardinal > 10 (option)  I cannot handle more than 17 for FMT
% and even list is crazy (10 = 1024 line!!!)

% called from bp_editor so only one bp as choosen before entering this window

% display a list for selecting the forms

% one line = one element
% one column = one subset (crosses)
% the top are the requested forms (any among m,b,bel,pl,q,wc,wd,BetP and Normalized
% thus several lines
% to read a fct one must scroll horizontally,
% to read one subsets, one must scroll vertically
% based on edit_bp_with_sets

% option = 'new_forms'       : you can create and display values of several forms
%        = 'available_forms' : you get just t he list of available forms

%
%   Version : May, 15, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position figure_data  help_label  hd_help_menu help_level
global screen_size flags keyhit  Which_Courier

if  prod(belief(ind_bel).domain_cardinality) > 12 & strcmp(option,'new_forms')
	hdw = warndlg('The cardinality is larger than 12. Too large to display all values, so I skip');
	uiwait(hwd)
	return
else

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% get the figure
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	hd_fig = figure('name','Forms Window');
	set(gcf,'position',gui_position(:,5))
	ind_fig = length(figure_data) + 1;
	figure_data(ind_fig).name = 'Forms Window';
	figure_data(ind_fig).handle = hd_fig;
	figure_data(ind_fig).position = gui_position(:,5);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% put its menus
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	k=0;
	k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
	k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(1)','on');
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% what forms you want
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	param = [];
	param = {'m','b','q','bel','pl','wc','wd','M','Bel','Pl','Q','BetP'};
	
	handle_list3 = listing_existing('general', gui_position(:,6), gcf,param);
	set(handle_list3(1),'String','Form List') 
	
	switch option
	case 'new_forms'
		select_list(handle_list3,'on','many')
		text = 'Select the forms you want to display. Forms name starting with a capital are normalized. Not seeing an asked form = computation problem.';
		choice = text_with_n_buttons(gcf, text, {'Done','Cancel'}, 1);
		sel_val = get(handle_list3(2),'value');
		
		if choice == 2
			delete(hd_fig);
			figure_data(ind_fig) = [];
			return
		end
		if length(sel_val) == 0
			hwd = warndlg('You must ask for at least one form. I skip.');
			uiwait(hwd)
			delete(hd_fig);
			figure_data(ind_fig) = [];
			return	
		end
		for i = 1:length(sel_val)
			out_form_req{i} = param{sel_val(i)};
		end	
	case 'available_forms'
		list_form = [];
		for i = 1:length(belief(ind_bel).bp(ind_pot).form)
			pos = find(strcmp(belief(ind_bel).bp(ind_pot).form(i).type, param));
			if pos	
				list_form = [list_form pos];
			end
		end
		set(handle_list3(2),'min',0,'max',1000,'value',list_form)
		text = 'List of available forms. To display them or the create new ones, use button ''Several forms''';
		choice = text_with_n_buttons(gcf, text, {'Done'}, 1);
	end

	delete(hd_fig);
	figure_data(ind_fig) = [];
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% the call for computing/displaying the forms 
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	if strcmp(option, 'new_forms')
		[computed_forms,uncomputed_forms, error_mode] = transform_bp(ind_bel,ind_pot,out_form_req);
		
		% producing the window for displaying what I asked for
		edit_bp_with_sets(ind_bel,ind_pot,[],computed_forms) 
	end
end	
