clear
clear global
global belief selvalbp
global nbr_bit_per_word
global BelfrM PlfrM BetPfrM     % should be declared in calling program. Avoids recalculation


nbr_bit_per_word=50;


% Example 1: constraints on masses
card=3;
N=randperm(2^card-1);
belief(1).domain_cardinality=card;
selvalbp(1).belief=1;
selvalbp(1).focalsets=N(1:5)';
%selvalbp(1).val=[0.2 0.4;0.1 0.5;0.05 0.2;0.05 0.5;0.4 0.5];
x=rand(5,1);x=x./sum(x);
selvalbp(1).val=[0.5*x 1.5*x];
selvalbp(1).type='m';
selval_ind=1;
bel_ind=1;

error_message=lcp_const(selval_ind);
F=long_num2bit(belief(1).bp(1).form(1).focalsets,card);
disp([F belief(1).bp(1).form(1).values])
disp([belief(1).bp(1).form(1).focalsets belief(1).bp(1).form(1).values])

% Example 2: constraints on bel (numbers)
card=3;
m=createbbm(card);
bel=mtob(m)-m(1);
N=[1 4 6];
belief(1).domain_cardinality=card;
selvalbp(1).belief=1;
selvalbp(1).focalsets=N';
selvalbp(1).val=bel(N+1)';
selvalbp(1).type='bel';
selval_ind=1;
bel_ind=1;

error_message=lcp_const(selval_ind);

m1=zeros(2^card,1);
m1(belief(1).bp(1).form(1).focalsets+1)=belief(1).bp(1).form(1).values;
bel1=mtob(m1)-m1(1);
disp([bel;bel1])

% Example 3: constraints on bel (intervals)
card=5;
m=createbbm(card);
bel=mtob(m)-m(1);
N=[3 6 15 20];
belief(1).domain_cardinality=card;
selvalbp(1).belief=1;
selvalbp(1).focalsets=N';
selvalbp(1).val=[0.9*bel(N+1)' 1.1*bel(N+1)'];
selvalbp(1).type='bel';
selval_ind=1;
bel_ind=1;

error_message=lcp_const(selval_ind)

m1=zeros(2^card,1);
m1(belief(1).bp(1).form(1).focalsets+1)=belief(1).bp(1).form(1).values;
bel1=mtob(m1)-m1(1);
disp([bel(N+1);bel1(N+1)])
disp(selvalbp(1).val)

% Example 4: constraints on pl (numbers)
card=3;
m=createbbm(card);
pl=mtopl(m);
N=[1 2 3 4 6];
belief(1).domain_cardinality=card;
selvalbp(1).belief=1;
selvalbp(1).focalsets=N';
selvalbp(1).val=pl(N+1)';
selvalbp(1).type='pl';
selval_ind=1;
bel_ind=1;

error_message=lcp_const(selval_ind);

m1=zeros(2^card,1);
m1(belief(1).bp(1).form(1).focalsets+1)=belief(1).bp(1).form(1).values;
pl1=mtopl(m1);
disp([pl;pl1])

% Example 5: constraints on pl (intervals)
card=5;
m=createbbm(card);
pl=mtopl(m);
N=[3 6 15 20];
belief(1).domain_cardinality=card;
selvalbp(1).belief=1;
selvalbp(1).focalsets=N';
selvalbp(1).val=[0.9*pl(N+1)' 1.1*pl(N+1)'];
selvalbp(1).type='pl';
selval_ind=1;
bel_ind=1;

error_message=lcp_const(selval_ind)

m1=zeros(2^card,1);
m1(belief(1).bp(1).form(1).focalsets+1)=belief(1).bp(1).form(1).values;
pl1=mtopl(m1);
disp([pl(N+1);pl1(N+1)])
disp(selvalbp(1).val)


% Example 6: constraints on pl (numbers)
card=5;
nf=2^card;      % the total number of subsets
cardA=[0;1];
for i=2:card,
   cardA=[cardA;1+cardA];          % vector with cardinalities of all subsets
end;
cardAB=[0 0;0 1];
for i=2:card,
    cardAB=[cardAB cardAB;cardAB 1+cardAB];
end;
cardAmoins=[0;1./cardA(2:end)];
R=cardAB*diag(cardAmoins);

m=createbbm(card);
betp=R*m';
N=[1 2  6];
belief(1).domain_cardinality=card;
selvalbp(1).belief=1;
selvalbp(1).focalsets=N';
selvalbp(1).val=betp(N+1);
selvalbp(1).type='betp';
selval_ind=1;
bel_ind=1;

error_message=lcp_const(selval_ind);

m1=zeros(2^card,1);
m1(belief(1).bp(1).form(1).focalsets+1)=belief(1).bp(1).form(1).values;
betp1=R*m1;
disp([betp';betp1'])


% Example 7: constraints on pl (intervals)
card=5;
nf=2^card;      % the total number of subsets
cardA=[0;1];
for i=2:card,
   cardA=[cardA;1+cardA];          % vector with cardinalities of all subsets
end;
cardAB=[0 0;0 1];
for i=2:card,
    cardAB=[cardAB cardAB;cardAB 1+cardAB];
end;
cardAmoins=[0;1./cardA(2:end)];
R=cardAB*diag(cardAmoins);

m=createbbm(card);
betp=R*m';
N=[1 2  6 20];
belief(1).domain_cardinality=card;
selvalbp(1).belief=1;
selvalbp(1).focalsets=N';
selvalbp(1).val=[0.6*betp(N+1) 1.2*betp(N+1)];
selvalbp(1).type='betp';
selval_ind=1;
bel_ind=1;

error_message=lcp_const(selval_ind);

m1=zeros(2^card,1);
m1(belief(1).bp(1).form(1).focalsets+1)=belief(1).bp(1).form(1).values;
betp1=R*m1;
disp([betp(N+1)';betp1(N+1)'])
disp(selvalbp(1).val)

