function run_belief_potential(belief_index)
% display the belief potentials (bp) or get new ones (one by one)
% we work only on belief(bel_index)  

%
%   Version : Jan 22, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global gui_position  help_level
global stored_text figure_data help_label
global flags flag_str flags2
global nbr_bit_per_word
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% one bel has k bp , one per conditioning element (initialy = vacuous), or one if marginal
% one belief(belief_index).bp may have several forms, m, bel, BetP, etc...
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% listing the potentials: bel is fixed as input is bel for belief(index)
% ONE potential per conditioning element
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
okhere = 1;
eval('okhere = belief(belief_index).bp;','okhere=[];')
% ok = []  because belief(belief_index) not yet defined or belief(belief_index).bp empty
% it should not occur as we have one bp for each conditioning element

% % % % % % if ~isempty(okhere)	
% % % % % % 	nbrbp = length(belief(belief_index).bp);
% % % % % % 	if nbrbp == 1;
% % % % % % 		bp_index = 1;
% % % % % % 	else
% % % % % % 		% building the full name for this belief potential with its possible forms
% % % % % % 		for i = 1:nbrbp
% % % % % % 			nbr_forms(i) = length(belief(belief_index).bp(i).form);
% % % % % % 			typ = ' ';
% % % % % % 			for j = 1:nbr_forms(i)
% % % % % % 				typ = [typ,' ',belief(belief_index).bp(i).form(j).type];  
% % % % % % 			end	
% % % % % % 			belief(belief_index).bp(i).number = i;	
% % % % % % 			belief(belief_index).bp(i).full_name = ['bp',num2str(i), typ];
% % % % % % 		end
% % % % % % 	end
% % % % % % end

% full name is like 'bp9 m BetP q', 9 is the number of the potential, 
% followed by the list of forms
% this index of bp (9) appears once we have conditional, 
% and 9 is the elements number in the conditioning_domain
% with marginal only, always only 1 bp
% when conditioning will show up, the number should be replaced by the condition XXX

help_level_mem = help_level;
help_level = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure that contains the several panels with buttons
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

namefig = ['Potential Control for belief ',num2str(belief(belief_index).full_name),...
', bp number = ',num2str(1)];
hd_fig = figure('name',namefig);
set(gcf,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = namefig;
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'push_set_buttons(7,1)','on');

k=k+1;make_fig_menu(ind_fig,k,help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Button Helps On',3,'push_set_buttons(7,2)','on');	
menu_manager('create',ind_fig)

% Root Window is forced so no button
if help_level_mem == 2
	help_level = 2;
	make_fig_menu(ind_fig,4,'Button Helps Off',3,'push_set_buttons(7,3)','on');
	menu_manager('modify',ind_fig)	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% select the bp to use NOW, 1 if only one,  0 = cancel
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

bp_index = select_bp(belief_index); 

if  bp_index ==  0
	hdw = warndlg('This belief has NO potential! Delete it and rebuild it. I skip.');
	uiwait(hdw);
	delete(hd_fig)
	figure_data(ind_fig) = [];
	help_level = help_level_mem;
	return
elseif 	bp_index > 0
	set(hd_fig,'name',['Potential Control for belief ',num2str(belief(belief_index).full_name),...
	', bp number = ',num2str(bp_index)]);
else
	hdw = warndlg('Wrong request in run_belief_potential: negative index')
	uiwait(hdw)
	help_level = help_level_mem;
	return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% what are its domain variables	Discrete, Continuous, Integers
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[list_discr,list_continuous, list_integers] = type_variable(belief(belief_index).domain_variable);
flags2 = [];
if length(list_continuous.num) == 0 & length(list_integers.num) == 0 
	flags2 = 0;
else
	flags2 = 1;
end
% when calling bp_request_window, flags2 is 1 if there is cont or int, 0 otherwise
% use to hidde some options

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% proceeding to the 'all bp' case if cont or int and asked so (bp_index == -1)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if flags2 == 1 & bp_index == -1
	delete(hd_fig)
	figure_data(ind_fig) = [];
	enter_bbd_cont_int(bel_ind)	
	help_level = help_level_mem;
	return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop into which we stay until you ask to quit
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
while go_on	 % external while
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% build window with buttons and its help 
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	hd_help = forced_display_helps(0,22);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	sel_butt = bp_request_window(hd_fig,belief_index,bp_index);
	% the uiwait is in bp_request_window
	% What you want to do  is in sel_butt : 
	% sel_butt(1) = the set, 
	% sel_butt(2) = the button in the set
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% I delete the help text, not needed now
	delete(hd_help);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% what to do next  
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		
	
	% we can avoid controling for continuous integers 
	% as we hide the forbidden buttons accordingly in bp_request_window
	
	switch sel_butt(1)
	
	case 1 % 'Create New bba : enter masses';
		switch sel_butt(2)
		case 1 % selected one mass OK for integers continuous
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% selected values, display one mass at a time
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			get_bp_m(belief_index,bp_index);
		case 2 % selected many masses NIC (not for integers continuous)
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% selected values, display all masses together
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			ind_for = edit_one_bp(belief_index,bp_index);			
			if ~isempty(okhere)	& ~isempty(ind_for) % bp and form exist
				pack_mass(belief_index,bp_index,ind_for);
			end
			% hd_fig is still behind and just show up with delete(hd_fig)
		case 3 % logical expr
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% produce mass from logical expressions
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
			ind_for = 1; % we are in the creation phase of a new bp so form ind = 1
			[ok] = get_m_from_logic_expr_new('bba',belief_index,bp_index,ind_for,[],'');	
			if ok
				% I verify there is something to add in total_bbm
				eval('okm = 1;useless = belief(belief_index).bp(bp_index).form(ind_for).values(1);','okm = 0;')				
				if okm					
					total_bbm = sum(belief(belief_index).bp(bp_index).form(ind_for).values);				
					if total_bbm > 1
						hdw = warndlg('Error. The sum of the masses entered is > 1. I proceed but you must correct them.');
						uiwait(hdw)
					end	
				end
			end
		case 4 % a function that generates the bbm, bbd
			% done for the selectede bp
			enter_bbd_cont_int(belief_index, bp_index)			
		end
	case 2 % 'Create New bba : enter'
		switch sel_butt(2)
		case 1 % BetP
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% BetP on elements and LCP NIC (no integer continuous)
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
			bba_from_betp_elements(belief_index,bp_index)
		case 2 % pl 
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% from plausibilities on singletons = likelohoods + LCP NIC (no integer continuous)
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			bba_from_pl_elements(belief_index,bp_index)
		case 3 % .m fct
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% .m function NA
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
		case 4 % random
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% produce random masses on the whole frame, OK for small frames, up to 10+ elements
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
			get_random_m(belief_index,bp_index);
		end
	case 3 % 'Create New bba : enter some of';
		switch sel_butt(2)
		case 1 % bel
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% selected m values
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			get_sets_weights(belief_index,bp_index,'bel')
		case 2 % pl
			get_sets_weights(belief_index,bp_index,'pl')
		case 3 % wc
			get_sets_weights(belief_index,bp_index,'wc')
		case 4 % wd
			get_sets_weights(belief_index,bp_index,'wd')
		end
	case 4 % 'Create New bba : enter Interval-values for some of';
		switch sel_butt(2)
		case 1 % m
			get_sets_weights(belief_index,bp_index,'m')
		case 2 % bel
			ind_bp = length(belief(belief_index).bp) + 1;
			get_sets_weights(belief_index,bp_index,'bel')
		case 3 % pl
			get_sets_weights(belief_index,bp_index,'pl')
		case 4 % wc
			get_sets_weights(belief_index,bp_index,'wc')
		case 5 % wd
			get_sets_weights(belief_index,bp_index,'wd')
		end
	case 5 % 'View  a potential';
		switch sel_butt(2)
		case 1 % large m
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% listing selected potential: 
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			% for bp position = index = number
			showing_bp_selected(belief_index,bp_index,0);
			
		case 2 % bel Bet pl
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% listing one exisiting potential: one per conditioning element
			% if card <= 12 we use clever set represnetation, else we don't show it
			% use option large m if you wnat to see masses
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			% fincding the form that is m. I can come here ONLY if an m exists
			% bp_request_window hides the button
			form_ind = min (find(strcmp({belief(belief_index).bp(bp_index).form(:).type}, 'm')));
			if isempty(form_ind)
				% % % % 				% no m form I build the m form TOO DANGEROUS, user must do it himself
				% % % % 				[computed_forms,uncomputed_forms, error_mode] = transform_bp(belief_index,bp_index,{'m'});
				% % % % 				form_ind = find(strcmp({belief(belief_index).bp(bp_index).form(:).type}, 'm'));
			end		
			results_display(belief_index,bp_index,form_ind)	
			
		case 3 % best supported set
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% Appriou idea of best supported set considereing cardinality
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			best_supported_set(belief_index,bp_index);
			
		case 4 % several forms
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% values of several forms
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			display_all_forms(belief_index,bp_index,'new_forms')
			
		case 5 % available forms
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% list of available forms for that bp
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			display_all_forms(belief_index,bp_index,'available_forms')
			
		end % switch sel_butt(2) in case 5
	
	case 6 % 'Control';
		switch sel_butt(2)
		case 1 % save all object
			% manip_data_files('save','belief');
			handling_files('save')
		case 2 % change belief quickly
			bel_handle_ui = listing_existing('belief', gui_position(:,6), hd_fig,belief_index);
			% list of belief displayed 		
			select_list(bel_handle_ui,'on','one');				
			text = 'Select the belief you want to use.';
			choice = text_with_n_buttons(hd_fig,text,{'Done','Cancel'}, []);
			
			if choice == 1
				% get the position,index,number for the requested object
				belief_index = get(bel_handle_ui(2),'Value'); % position
				delete(bel_handle_ui)
				% check if several potential, in which case ask which one					
				bp_index = select_bp(belief_index);	
			end	
			set(hd_fig,'name',['Potential Control for belief ',num2str(belief(belief_index).full_name),...
			', bp number = ',num2str(bp_index)]);		
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% what are its domain variables	Discrete, Continuous, Integers
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			[list_discr,list_continuous, list_integers] = type_variable(belief(belief_index).domain_variable);
			flags2 = [];
			if length(list_continuous.num) == 0 & length(list_integers.num) == 0 
				flags2 = 0;
			else
				flags2 = 1;
			end
			% when calling bp_request_window, flags2 is 1 if there is cont or int, 0 otherwise
			% use to hidde some options
			
		case 3 % move to next potential when conditional
	
			if ~isempty(belief(belief_index).conditioning_variable)
				max_bp_index = prod(belief(belief_index).conditioning_cardinality);
				bp_index = bp_index + 1;
				if bp_index > max_bp_index
					bp_index = 1;
				end
				set(hd_fig,'name',['Potential Control for belief ',num2str(belief(belief_index).full_name),...
				', bp number = ',num2str(bp_index)]);
			end
		
		case 4 % quit potential window
			delete(hd_fig)
			figure_data(ind_fig) = [];		
			go_on = 0;
		end
	
	case 7
		% I have created with callback push_set_buttons,
		% a fake extra list (with 1 button) for the Quit menu action
		switch sel_butt(2)
		case 1 % quit
			delete(hd_fig)
			figure_data(ind_fig) = [];		
			go_on = 0;
		case 2 % button helps was off, I put it on
			help_level = 2; 
			make_fig_menu(ind_fig,4,'Button Helps Off',3,'push_set_buttons(7,3)','on');
			menu_manager('modify',ind_fig)
		case 3 % button helps  was on, I put it off
			help_level = 0; 			
			set(hd_fig,'WindowButtonMotionFcn','')	
			make_fig_menu(ind_fig,4,'Button Helps On',3,'push_set_buttons(7,2)','on');
			menu_manager('modify',ind_fig)
		end
	end % switch sel_butt(2) in case 6
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% creating a bba based on the focal elmeents
	% you feed the bbm and its focal element
	% no need to feed the mass given to universe, done automaticaly
	% negative mass is allowed, even if abnormal
	% but might be useful for generalized ssf encountered in canonical decomposition
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	% 	delete(findobj('userdata','sets_of_set_of_buttons'));	
end	 %while go_on	 % external while

help_level = help_level_mem;
