function run_belief(return_where)
% building belief object
% return_where = 'menu' if call from menu,'EVN' if called from EVN

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global file_name_begin
global stored_text 
global flag_str 
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global new_flag
global hd_help_object   hd_help_menu    name_calling_window
global gui_position  figure_data  flags  help_level help_label
global long_text_help    pos_button_in_pixels    hd_lg_tx_fig

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% help handled inside the window
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

help_long_mem = help_level;
help_level = 0; % min forced, if you want help, use menu Help

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure('name','Belief Editor');
set(gcf,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Belief Editor';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(6)','on');
k=k+1;make_fig_menu(ind_fig,k,help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Window Helps On',3,'general_clb(7)','on');
k=k+1;make_fig_menu(ind_fig,k,'Button Helps On',3,'general_clb(9)','on');
menu_manager('create',ind_fig)

hd_help_on = 0;
hd_help = -1; % so I can use ishandle(hd_help)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building pin_belief for safety
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[useless] = pin_manipulation('belief','all',[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% produce list of variables with multi_selection enable/disable
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% verifying some variables are loaded, otherwise back to Root Window
if length(variable) == 0 
	% this is stupid
	hdw = warndlg('Build variables. There are none by now.');
	uiwait(hdw);
	ok = 0; % i just leave belief
else
	% listing all variables and put temporarily off
	handle_list_variable = listing_existing('variable', gui_position(:,6),hd_fig);
	select_list(handle_list_variable,'off','many');	
	% hence single selection not yet allowed, wait for enable= on  when OK
	ok = 1;
	if length(belief)
		okbel = 1;
	else
		okbel = 0;
	end
	% listing all beliefs and put temporarily off
	handle_list_belief = listing_existing('belief', gui_position(:,7), hd_fig);
	select_list(handle_list_belief,'off','many');	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% asking what you want to do
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ok 
	
	title_but{1}= 'BELIEF';
	ik = 0;
	ik = ik+1;text_but{ik} = 'new';
	ik = ik+1;text_but{ik} = 'edit belief';
	ik = ik+1;text_but{ik} = 'edit bba';
	ik = ik+1;text_but{ik} = 'delete';
	ik = ik+1;text_but{ik} = 'Duplicate -> index';
	
	positionUL = [.005 .005]; 
	
	ik = 0;
	ik = ik+1;tooltip{ik} = 'Building a new belief';
	ik = ik+1;tooltip{ik} = 'Edit exisiting belief object';
	ik = ik+1;tooltip{ik} = 'Edit bba';
	ik = ik+1;tooltip{ik} = 'Delete exisiting beliefs';
	ik = ik+1;tooltip{ik} = 'Build same belief for each values of indexes';
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% the loop into which we stay until you ask to quit from the File menu
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	go_on = 1;
	while go_on	
		
		if exist('hd_button_bel') ; delete(hd_button_bel);end
		% hd_button_bel are the handles of the buttons listed above
		
		if okbel == 0 
			% no belief object yet
			hidden = [2 3 4 5];
		else
			hidden = [];
		end		
	
		[pushed_button,hd_button_bel] = select_buttons(hd_fig,positionUL,...
		text_but,title_but,hidden,tooltip,8,'UL');
		
		switch pushed_button
		
		case 1  % make a new one
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% request for a new belief 
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		
			
			% the variable list are already displayed		
			% building a new vacuous belief with default values based on attrribute ind = 1
			
			ibel = make_empty('belief'); % get belief itself, but no bp (I need cond var before doing it)			
			useless = pin_manipulation('belief','all',[]); % so the 0 0 0 is out
			
			% by default, you get variable number = pin_variable(1,3)
			% so show belief and make_empty will work
			nbr = get_cardinal_var(variable(pin_variable(1,2)).frame);						
			belief(ibel).domain_variable = variable(pin_variable(1,2)).number;
			belief(ibel).domain_cardinality = nbr;
			belief(ibel).computed = 'keyboard';
			
			% the bp and forms will be built in show_belief once I know if conditional or marginal
			
			% deleting help if exist
			get_help_back = 0;
			if ishandle(hd_help)
				delete(hd_help);
				get_help_back = 1;  
			end
		
			%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% showing belief
			%%%%%%%%%%%%%%%%%%%%%%%%%%%
			[handle_list_belief] = show_belief(ibel, ...
			handle_list_variable,handle_list_belief,'new',hd_help_on);	
			
			% get back to belief help
			if get_help_back
				hd_help = forced_display_helps(0,[6 19 20]);
			end
		
			if length(belief)
				okbel = 1;
			end
		
		case 2  % display belief object for editing
			% the attribute list is already displayed
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% display an existing variable that can be modified
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			% get the index in belief list			
			text = 'Select in BELIEF list the belief you want to see, then Done';
			select_list(handle_list_belief,'on','one');			
			set(handle_list_belief,'value',1);
			choice = text_with_n_buttons(hd_fig,text, {'Done','Cancel'},[]);
			% get the position,index,number for the requested belief
			selected_item = get(handle_list_belief(2),'Value'); % position
			select_list(handle_list_belief,'off','many');	
			
			if choice == 1				
				% the index of the belief object you want to see			
				belief_index = pin_manipulation('belief','pos2ind',selected_item);
				% now we display the selected belief with index = belief_index	
				
				% deleting help if exist
				get_help_back = 0;
				if ishandle(hd_help)
					delete(hd_help);
					get_help_back = 1;  
				end
			
				%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% showing belief
				%%%%%%%%%%%%%%%%%%%%%%%%%%%
				[handle_list_belief] = show_belief(belief_index, ...
				handle_list_variable,handle_list_belief,'old',hd_help_on);	
				
				% get back to belief help
				if get_help_back
					hd_help = forced_display_helps(0,[6 19 20]);
				end
			end
		
		case 3
	
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% going directlty to mass display as sets
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			% get the index in belief list			
			text = 'Select in BELIEF list the belief you want to see, then Done';
			select_list(handle_list_belief,'on','one');	
			set(handle_list_belief,'value',1);
			choice = text_with_n_buttons(hd_fig,text, {'Done','Cancel'},[]);
			% get the position,index,number for the requested belief
			selected_item = get(handle_list_belief(2),'Value'); % position
			select_list(handle_list_belief,'off','many');	
			
			if choice == 1				
				% the index of the belief object you want to see			
				belief_index = pin_manipulation('belief','pos2ind',selected_item);
				% now we display the selected belief with index = belief_index	
				
				% deleting help if exist
				get_help_back = 0;
				if ishandle(hd_help)
					delete(hd_help);
					get_help_back = 1;  
				end
			
				%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% run directly potential for bba
				%%%%%%%%%%%%%%%%%%%%%%%%%%%
				run_belief_potential(belief_index)
				
				% get back to belief help
				if get_help_back
					hd_help = forced_display_helps(0,[6 19 20]);
				end
			
			end
		
		case 4
	
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% deleting a belief
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			select_list(handle_list_belief,'on','many');	
			text = 'Select those belief objects you want to delete. Then click Done';
			choice1 = text_with_n_buttons(hd_fig,text,{'Done','Cancel'}, gui_position(:,13));
			% get the position for the requested belief
			selected_item = get(handle_list_belief(2),'Value'); % position		
			if isempty(selected_item )
				choice1 = 2;
			end
		
			if choice1 == 1			
				text = 'Confirm these belief must be deleted.';
				choice2 = text_with_n_buttons(hd_fig, text, {'Do it','Cancel'}, []);
				select_list(handle_list_belief,'off','many');			
				if choice2 == 1 % delete		
					belief_index  = pin_manipulation('belief','pos2ind',[selected_item]);	
					belief_number = pin_manipulation('belief','pos2num',[selected_item]);
					% the index - numbers of the frames you want to delete		
					uselee = deleting_objects('belief', belief_number);
				end
				if exist('handle_list_belief'); delete(handle_list_belief); end
				handle_list_belief = listing_existing('belief', gui_position(:,7), hd_fig);
				select_list(handle_list_belief,'off','many');	
				
				if length(belief) == 0
					okbel = 0;
				end
			else
				select_list(handle_list_belief,'off','many');
			end
		
		case 5 % 
	
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% Duplicate for all indexes
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			% Getting the belief of reference		
			if exist('handle_list_variable'); delete(handle_list_variable); end
			if exist('handle_list_belief'); delete(handle_list_belief); end
			
			hd_list_bel =  listing_existing('belief', gui_position(:,6), hd_fig,[]);
			select_list(hd_list_bel ,'on','one');	
			
			% list of belief displayed or refreshed
			text = 'Select the belief object you want to duplicate.';
			choice = text_with_n_buttons(hd_fig,text, {'OK'}, gui_position(:,13));			
			pos = get(hd_list_bel(2),'value');
			index_which_belief = pin_manipulation ('belief','pos2ind',pos);
			
			varnum = [belief(index_which_belief).domain_variable belief(index_which_belief).conditioning_variable];
			ind_var = pin_manipulation('variable','num2ind',unique([varnum]));
			ind_att = pin_manipulation('attribute','num2ind',[unique( [variable(ind_var).attribute])]);
			
			indmax = 0;
			for i25 = ind_att
				indmax = max([indmax,length(attribute(i25).index)]);
			end
			if indmax
				% only if one of the var of belief made on attr with an index
				duplicate_bel(index_which_belief);
			end
		
			% restroring the belief list
			delete(hd_list_bel)
			handle_list_belief = listing_existing('belief', gui_position(:,7), hd_fig);
			select_list(handle_list_belief,'off','one');				
			handle_list_variable = listing_existing('variable', gui_position(:,6), hd_fig);
			select_list(handle_list_variable,'off','one');	
			
		case 6
	
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% quit  
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			go_on  = 0;	
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% answering to menu help requets
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		case 7 % show Root Window
			hd_help = forced_display_helps(0,[6 19 20]);
			make_fig_menu(ind_fig,4,'Window Helps Off',3,'general_clb(8)','on');
			menu_manager('modify',ind_fig)
			hd_help_on = 1;
		case 8 % hide Root Window
			delete(hd_help)
			make_fig_menu(ind_fig,4,'Window Helps On',3,'general_clb(7)','on');
			menu_manager('modify',ind_fig)	
			hd_help_on = 0;
			
		case 9 % show button helps	
			% activate button helps
			help_level = 2;
			make_fig_menu(ind_fig,5,'Button Helps Off',3,'general_clb(10)','on');
			menu_manager('modify',ind_fig)				
		case 10 % hide button helps
			% desactivate button helps
			help_level = 0;
			make_fig_menu(ind_fig,5,'Button Helps On',3,'general_clb(9)','on');
			menu_manager('modify',ind_fig)
			
		end % of the switch
	
	end % while go_o
	if exist('handle_list_belief'); delete(handle_list_belief); end
	if exist('handle_list_variable'); delete(handle_list_variable); end
	if exist('hd_button_bel'); delete(hd_button_bel); end
	if exist('handle_list_attribute'); delete(handle_list_attribute); end
	
end % ok
delete(hd_fig)
figure_data(ind_fig) = [];
if hd_help_on ; delete(hd_help), end
eval('delete(hd_lg_tx_fig)','')
% restore the help level
help_level = help_long_mem;
