function [handle_list_belief] = show_belief(belief_index,handle_list_variable,...
handle_list_belief,age,hd_help_on)
% showing a belief object

% age = 'old' or 'new' depending if belief is an old or a new object  (old for edit button, new for 'new' button)

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global gui_position
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure, same as the caller run_belief
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Wdw_Cmd_handle = gcf;
hd_help = -1; % so I can use ishandle(hd_help)

% storing belief object so I can restore it if I cancel
belief_mem = belief(belief_index);

kill_it = 0;
get_initial_bel_back = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting number and names
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear queries default_answer

title = 'Belief';
queries{1} = 'short name';
queries{2} = 'full name ( = short if blank)';
queries{3} = 'disposable Y/N';
queries{4} = 'agent';
queries{5} = 'time';
queries{6} = 'evidential corpus';
queries{7} = 'conditional beliefs Y/N';

default_answer{1} = belief(belief_index).short_name;
if strcmp(belief(belief_index).full_name,belief(belief_index).short_name)
	default_answer{2} = '';
else
	default_answer{2} = belief(belief_index).full_name;
end
default_answer{3} = YN_01(belief(belief_index).disposable,'1_to_Y');
default_answer{4} = belief(belief_index).agent;
default_answer{5} = num2str(belief(belief_index).time);
default_answer{6} = belief(belief_index).ec;
if length(belief(belief_index).conditioning_variable)
	default_answer{7} = 'yes';
	past_condit = 1; % past belief was conditional
else
	default_answer{7} = 'no';
	past_condit = 0; % past belief was marginal
end

% show the variables in domain_variable
sel_var = pin_manipulation('variable','num2pos',belief(belief_index).domain_variable);
if isempty(sel_var)
	sel_var = 1;
end
select_list(handle_list_variable,'on','many');		
set(handle_list_variable(2),'Value',sel_var);

% query panel for object
[answer,choice] = dialog_queries(Wdw_Cmd_handle, title, queries, ... 
default_answer,[.01 .01],[],2,[],[],[],[]);

if choice == 2 % cancel it if new, get back if old
	if strcmp(age,'new')
		kill_it = 1;
	else
		get_initial_bel_back = 1;
	end
else % ok with data for belief
	if isempty(answer{1})
		answer{1} = ['B',num2str(belief(belief_index).number)];
	end
	belief(belief_index).short_name = answer{1};
	if isempty(answer{2})
		belief(belief_index).full_name = answer{1};
	else
		belief(belief_index).full_name = answer{2};
	end

	belief(belief_index).disposable = YN_01(answer{3},'Y_to_1');
	belief(belief_index).agent = answer{4};
	belief(belief_index).time = str2num(answer{5});
	belief(belief_index).ec = answer{6};
	
	useless = pin_manipulation('belief','all',[]);
	
	if findstr('y',lower(answer{7})) % a 'y' anywhere = yes
		condit_bf = 1;
	else
		condit_bf = 0;						
	end

	% % % % 	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% % % % 	%
	% % % % 	% deciding if the past bp must be deleted
	% % % % 	%
	% % % % 	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% % % % 	
	% % % % 	make_new_bp = 0;
	% % % % 	cond_bp_changed = 0;
	% % % % 	
	% % % % 	if strcmp(age,'old') % the old belief
	% % % % 		if length(belief(belief_index).conditioning_variable) 
	% % % % 			if condit_bf == 0; %% we had condit and ask for marg 				
	% % % % 				make_new_bp = 1;
	% % % % 				cond_bp_changed = 1;
	% % % % 				belief(belief_index).conditioning_variable = [];
	% % % % 				belief(belief_index).conditioning_cardinality = [];
	% % % % 			end
	% % % % 		else
	% % % % 			if condit_bf == 1; % we had marginal and ask for con dit
	% % % % 				make_new_bp = 1;
	% % % % 				cond_bp_changed = 1;
	% % % % 			end
	% % % % 		end
	% % % % 	else % the new belief
	% % % % 		make_new_bp = 1;
	% % % % 		cond_bp_changed = 1;
	% % % % 	end
	% % % % 
	% % % % 
	% % % % 
	% % % % 	if make_new_bp
	% % % % 		belief(belief_index).bp = [];		
	% % % % 		make_empty('bp',belief_index)
	% % % % 	end
	% % % % 	% bp and forms exist, but I fail in their nunber
	
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% getting the domain variable (one or several)
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% get real position of text
	text = 'The variables are selected in VARIABLE list. Can be modified. Exit with Done';
	choice1 = text_with_n_buttons(Wdw_Cmd_handle, text, {'Done','Cancel'},[]);
	selected_item = get(handle_list_variable(2),'Value'); % position
	select_list(handle_list_variable,'off','one');	
	
	if choice1 == 2  
		if strcmp(age,'new')
			kill_it = 1;
		else
			get_initial_bel_back = 1;
		end
	else
		% get the position, index, number for the domain variable
		pin_listm = pin_manipulation('variable','pos2num',selected_item);	
		pin_list  = pin_manipulation('variable','pos2ind',selected_item);
		for i = 1:length(pin_list)
			list_card(i) = get_cardinal_var(variable(pin_list(i)).frame);
		end
		% we save possible modifications
		belief(belief_index).domain_variable = pin_listm; 	% get domain variable numbers
		belief(belief_index).domain_cardinality = list_card; 
		% partitioning domain_var for Discrete/Continuous/Integers
		var_continuous_integers = [];
		[list_discr,list_continuous, list_integers] = type_variable(belief(belief_index).domain_variable);
		belief(belief_index).dci_var.pin_d = [list_discr.pos; list_discr.ind; list_discr.num];		
		belief(belief_index).dci_var.pin_c = [list_continuous.pos; list_continuous.ind; list_continuous.num];
		belief(belief_index).dci_var.pin_i = [list_integers.pos; list_integers.ind; list_integers.num];
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% getting the conditioning variable (one or several) 
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	if choice1 == 1
		choice2 = 1;
		if length(belief(belief_index).conditioning_variable)
			% there are cond var but I can change them
			% list cond var
			sel_var = pin_manipulation('variable','num2pos',belief(belief_index).conditioning_variable);	
			select_list(handle_list_variable,'on','many');	
			set(handle_list_variable(2),'Value',sel_var);			
			% get real position of text
			text = 'The conditioning variables are selected in VARIABLE list. Can be modified.';
			choice2 = text_with_n_buttons(Wdw_Cmd_handle, text, {'Done','Cancel'},[]);
			
			if choice2 == 2
				if strcmp(age,'new')
					kill_it = 1;
				else
					get_initial_bel_back = 1;
				end 
			else			
				% now we have condit var
				% get the position,index,number for the conditioning variable
				selected_item = get(handle_list_variable(2),'Value'); % position
				pin_listmC = pin_manipulation('variable','pos2num',selected_item);
				
				cont = max([is_var_cont(pin_listmC),is_var_int(pin_listmC)]); 
				if cont == 1
					% continuous integers forbidden
					hdw = warndlg('Variables with continuous or integers frames forbidden as conditioning variables');
					uiwait(hdw)
					if strcmp(age,'new')
						kill_it = 1;
					else
						get_initial_bel_back = 1;
					end
					choice2 == 2;
				else
					pin_listC = pin_manipulation('variable','pos2ind',selected_item);				
					num_new_cd_var = pin_manipulation('variable','pos2num',selected_item);
					% did I xchange the condit var, if yes I must delete and rebuild the bp						
					cond_bp_changed = 0;
					for i = 1:length(pin_listC)
						list_cardC(i) = get_cardinal_var(variable(pin_listC(i)).frame);
					end
					belief(belief_index).conditioning_variable = pin_listmC; % get its number
					belief(belief_index).conditioning_cardinality = list_cardC;
					select_list(handle_list_variable,'off','one');	
				end
			end % if choice2 == 2 ... else ...
		
		else % % there were no cond var (else I skip)
			if condit_bf  == 1 % I ask for cond var
				select_list(handle_list_variable,'on','many');	
				% get real position of text
				text = 'Select conditioning variables in VARIABLE list. Exit with Done';
				choice2 = text_with_n_buttons(Wdw_Cmd_handle, text, {'Done','Cancel'},[]);
				
				if choice2 == 2
					if strcmp(age,'new')
						kill_it = 1;
					else
						get_initial_bel_back = 1;
					end
				else
					% get the position,index,number for the conditioning variable
					selected_item = get(handle_list_variable(2),'Value'); % position
					pin_list_numc = pin_manipulation('variable','pos2num',selected_item);
					cont = max([is_var_cont(pin_list_numc) is_var_int(pin_list_numc)]); 
					if cont == 1
						% continuous forbidden
						hdw = warndlg('Variables with continuous or integers frames forbidden as conditioning variables');
						uiwait(hdw)
						if strcmp(age,'new')
							kill_it = 1;
						else
							get_initial_bel_back = 1;
						end
						choice2 == 2;
					else				
						pin_list_indc = pin_manipulation('variable','pos2ind',selected_item);
						for i = 1:length(pin_list_indc)
							list_card_cd(i) = get_cardinal_var(variable(pin_list_indc(i)).frame);
						end							
						% verifying not same var in both domain and conditioning, stupid, but....
						if intersect(pin_listm, pin_list_numc)
							hdw = warndlg('A domain variable may never be also a conditioning vcariable. I cancel');
							uiwait(hdw)
							choice2 = 2;
							if strcmp(age,'new')
								kill_it = 1;
							else
								get_initial_bel_back = 1;
							end
						else
							% everything OK, I store data and generated bp form				
							belief(belief_index).conditioning_variable = pin_list_numc; 	% get its number				
							belief(belief_index).conditioning_cardinality = list_card_cd;
							select_list(handle_list_variable,'off','one');	
						end		
					end % if cont == 1
				end % if choice2 == 2
			end		%  if condit_bf  == 0
		end % if length(belief(belief_index).conditioning_variable)
	
		if choice2 == 1	% still OK		
			% did I change anything important in belief that requires a new bp	
			% comparing if belief objects bel1 and bel2 are identical or not 
			eq = 1;
			if     belief_mem.domain_variable ~= belief(belief_index).domain_variable
				eq = 0;
			elseif belief_mem.domain_cardinality ~= belief(belief_index).domain_cardinality
				eq = 0;
			else	
				a = belief_mem.conditioning_variable;
				b = belief(belief_index).conditioning_variable;
				if isempty(a);a = 0;end
				if isempty(b);b = 0;end
				if a ~= b
					eq = 0;
				end			
				a = belief_mem.conditioning_cardinality;
				b = belief(belief_index).conditioning_cardinality;
				if isempty(a);a = 0;end
				if isempty(b);b = 0;end
				if a ~= b
					eq = 0;
				end
			end
		
			if eq
				a = belief_mem.dci_var.pin_d;
				b = belief(belief_index).dci_var.pin_d;
				if isempty(a);a = 0;end
				if isempty(b);b = 0;end
				if a ~= b
					eq = 0;
				end
				a = belief_mem.dci_var.pin_c;
				b = belief(belief_index).dci_var.pin_c;
				if isempty(a);a = 0;end
				if isempty(b);b = 0;end
				if a ~= b
					eq = 0;
				end
				a = belief_mem.dci_var.pin_i;
				b = belief(belief_index).dci_var.pin_i;
				if isempty(a);a = 0;end
				if isempty(b);b = 0;end
				if a ~= b
					eq = 0;
				end
			end
		
			% building the bp (1 if marginal, several is condit) with one form per bp
			if eq == 0
				belief(belief_index).bp = [];
				useless = make_empty('bp',belief_index); % as manu bp as ondit elements
			end		
		
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% refreshing belief list
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			if exist('handle_list_belief'); protected_delete(handle_list_belief);end
			handle_list_belief = listing_existing('belief', gui_position(:,7), Wdw_Cmd_handle); 
			select_list(handle_list_belief,'off','one');	
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% going to the belief potential section
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			text = 'Do you want to go to the belief potential window ?';
			choicen = text_with_n_buttons(Wdw_Cmd_handle, text, {'Yes','No'}, []);
			
			if choicen == 1
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% we must hide the helps of the belief window buttons 
				% as they create a messy help display for the potential buttons
				% the belief button helps shows up whenever I am not on a potential buttton
				% but I have to briong the belief button help back when leaving potential
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%				
				
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% The entry point into bp_editor
				%
				run_belief_potential(belief_index);
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				
				if hd_help_on
					hd_help = forced_display_helps(0,[6 19 20]);	
				end
			end	 % if choicen == 1
		end % if choice2 == 1
	end % choice1 == 2 
end % if choice == 1

if kill_it % when cancel is asked for
	belief(belief_index) = [];	
end

if get_initial_bel_back
	% because I updated it 
	belief(belief_index) = belief_mem;
end

useless = pin_manipulation('belief','all',[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% refreshing belief list
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if exist('handle_list_belief'); protected_delete(handle_list_belief);end
handle_list_belief = listing_existing('belief', gui_position(:,7), Wdw_Cmd_handle); 
select_list(handle_list_belief,'off','one');	
if ishandle(hd_help)
	delete(hd_help);
end
