% Object editor   case Attribute


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% if no strucure, I skip
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if exist_str == 0
	hdw = warndlg('There are no structures. Create them.');		
	uiwait(hdw);
else

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% strucure ok
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	sel_val = [];
	set_list_selection(hd_list,[0,1,1,0])
	switch option
	case 'Attribute'
		choicex = text_with_n_buttons(gcf,'Attribute object. For Edit, first select it, then click on Edit.',{'New','Edit','Cancel'}, []);
		switch choicex 
		case 1
			option = 'New_Attribute';
			skip_it = 0;
		case 2
			option = 'Edit_Attribute';
			skip_it = 0;
		case 3
			skip_it = 1; % I do nothing and leave
		end	
	case 'New_Attribute'
		skip_it = 0;
	case 'Edit_Attribute'
		% I must decide which one
		skip_it = 0;
	end

	if skip_it == 0
		% you ask edit and there is NO Attributes, I made it New_Attribute
		if strcmp(option,'Edit_Attribute') & exist_att == 0
			option = 'New_Attribute';
			sel_val = -1; % new case
		end
	
		if strcmp(option,'Edit_Attribute')
			% case edit object
			sel_val = [];
			choicex = 1;
			while length(sel_val) == 0 & choicex == 1
				choicex = text_with_n_buttons(gcf,'Select ONE Attribute object, then Done',{'Done','Cancel'}, []);
				if choicex == 1
					sel_val = get(hd_list(3,2),'value');
				end
			end
			ind_att = pin_manipulation('attribute','pos2ind',sel_val);	
			object = attribute(ind_att);
			pos_str = pin_manipulation('structure','num2pos',attribute(ind_att).structure);
			new_one = 0;
			set(hd_list(2,2),'value',pos_str);
		else 
			% case new object
			sel_val = -1;
			ind_att = make_empty('attribute');
			object = attribute(ind_att);
			pos_str = []; % no structure yet
			new_one = 1;
		end
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% displaying values and reading modifications
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		nbr_index = length(object.index);
		
		title = 'ATTRIBUTE';
		
		k = 0;
		k=k+1;querry{k} = 'short name';
		k=k+1;querry{k} = 'full name (= short if blank)';
		k=k+1;querry{k} = 'nbr of indexes (if >0, you will have to select their frames.) #';
		
		k = 0;
		k=k+1;default_answer{k} = object.short_name;
		if strcmp(object.short_name,object.full_name)
			k=k+1;default_answer{k} = '';
		else
			k=k+1;default_answer{k} = object.full_name;
		end
		k=k+1;default_answer{k} = num2str(nbr_index);
		
		[answer,choice] = dialog_queries(hd_full_scr_fig,title,querry,default_answer,[.005 .005],[],2,[],[],0,' ');
		clear querry default_answer
		
		if choice == 1	
			pos_str = [];
			while length(pos_str) ~= 1	& skip_it == 0			
				choicex = text_with_n_buttons(gcf,'Select the structure, then Done.',{'Done','Cancel'}, []);
				switch choicex 
				case 1
					pos_str = get(hd_list(2,2),'value');
				case 2
					skip_it = 1;
				end
			end		
		
			if skip_it == 0
				object.structure = pin_manipulation('structure','pos2num',pos_str);				
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% finishing the attribute
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				if isempty(answer{1})
					answer{1} = ['A',num2str(object.number)];
				end			
				object.short_name = answer{1};	
				if isempty(answer{2})
					object.full_name = answer{1};
				else
					object.full_name = answer{2};
				end
			
				nbr_index_new = str2num(answer{3});
				for i_index = nbr_index+1: nbr_index_new
					% there a more indexes then previoulsy, so I give them temporary default name, + empty frame_number
					object.index(i_index).name = ['Ind',num2str(i_index)];
					object.index(i_index).frame =  [];
				end
			
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% building the indexes
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				set_list_selection(hd_list, [1,0,1,0])
				
				skip_me = 0;
				title = 'INDEX: select its frame';
				for i_index = 1:nbr_index_new
					
					querry{1} = ['index ',num2str(i_index),' name'];
					default_answer{1} = object.index(i_index).name;
					
					if ~isempty(object.index(i_index).frame)
						pos_fra = pin_manipulation('frame','num2pos',object.index(i_index).frame);
						set(hd_list(1,2),'value',pos_fra);
					end
				
					[answer,choice] = dialog_queries(hd_full_scr_fig,title,querry,default_answer,[.005 .005],[],2,[],[],0,' ');
					clear querry default_answer					
					if choice == 1
						object.index(i_index).name = answer{1};						
						pos_fra = get(hd_list(1,2),'value');
						
						while length(pos_fra) ~= 1	& skip_me == 0			
							choicex = text_with_n_buttons(gcf,'Select the frame, then Done.',{'Done','Cancel'}, []);
							switch choicex 
							case 1
								pos_fra = get(hd_list(1,2),'value');
							case 2
								skip_it = 1;skip_me = 1;
							end
						end		
						if skip_me == 0
							object.index(i_index).frame = pin_manipulation('frame','pos2num',pos_fra);
						end 
					else
						skip_me = 1;
					end
				end	
			
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%				
				if skip_me == 0
					% beware defining frame ... as global implies frame exists and is [] (double)`
					% and frame = object would be Ok, but not frame(1) = object
					% the tric is to say frame = object the first time, then frame(2) = object...
					
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					%
					attribute(ind_att) = put_in_fields(object,attribute(ind_att)); %  data saved
					%
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					
					exist_att = 1;						
					if new_one
						nbr_att = nbr_att + 1;
					end				
					% updating pin_attribute	
					useless = pin_manipulation('attribute','all',[]);					
					% refreshing  attribute list
					delete(hd_list(3,:));
					hd_list(3,:) = listing_existing('attribute', gui_pos(:,3), hd_full_scr_fig,[]);	
				end
			end % if pos_str == 0
		end
	end
end % if skip_it == 0
