function var_ind_out = get_all_var(VSHN, VFRA, VATT,var_ind)
% building all the variables that can be built for one given attribute 
% by considering all posible values of its  values

% for the attribute, list all possible index values, and build one var for each possible index value.
% nbr of variables = sulm over attributes, product cardinalities frames of each index.

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

% automatic = 0 if done from screen editor (with querries), = 1 if done in batch mode (without querries)`
% parameter is a convenient way to feed extra parameter whenever needed
% In batch_mode, only one attribute. One request per attribute with syntax
% VARIABLE   VSHN ... VFRA .... VATT ..... then ask GET ALL for VINX

global frame structure mapping attribute variable belief
global gui_position 
global stored_text 
global flags flag_str
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief

get_all_pin_tables
useless = pin_manipulation('attribute','all',[]);
% % % % % % % var_num = pin_manipulation('variable','ind2num',var_ind)
% % % % % % % param_out = deleting_objects('variable', var_num)
% % % % % % % var_ind = var_ind - 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the attribute index list. If empty, create nothing
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

att_ind = pin_manipulation('attribute','num2ind',VATT);
nbr_index = length(attribute(att_ind).index);

ind_frax = [];
card_frames = [];	
ind_frax(1) = 1;
card_frames(1) = 1; % to handle the case without index
for ii = 1:nbr_index
	ind_frax(ii) = pin_manipulation('frame','num2ind',attribute(att_ind).index(ii).frame);
	card_frames(ii) = frame(ind_frax(ii)).cardinality;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% build a matrix with all the possible values
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% possible values with {i,j} : j = 1 to nbr of index, i = 1:nbr_var_to_create = nbr poss combination
% mat_ind are the possible index value with index = 1,2...cardinal frame
% the symbol of i refers to frame().element(i,:)
mat_ind = [1:card_frames(1)]';
for i = 2:length(card_frames)
	mat_ind = [kron(ones(card_frames(i),1),mat_ind) ...
	kron([1:card_frames(i)]', ones(size(mat_ind,1),1)) ];
end	
% mat_ind(i,j) tells us that index-j has value element(mat_ind(i,j),:)
% and we store in index_value the mat_ind(i,j)
% the j in mat_ind(,j) points to the j attribute index

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% create the variable object
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% as we met VARIABLE, I had created ONE variable object, 
% so the next are build with the loop, 

% I finish the frst variable object
root_att = pin_manipulation('attribute','ind2num',att_ind);
variable(var_ind).attribute = root_att;
variable(var_ind).index_value = [mat_ind(1,:)]; 
variable(var_ind).frame = VFRA; 
root_short_name = variable(var_ind).short_name;
root_full_name = variable(var_ind).full_name;

% the names of the variables
% [lg_name, sh_name] = build_var_name(var_ind); % default names not used anymore
sh_name = [VSHN,'(']; %)
lg_name = [variable(var_ind).full_name,'(']; %)
for i = 1:size(mat_ind,2)
	fra_ind = pin_manipulation('frame','num2ind',attribute(att_ind).index(i).frame);	
	sh_name = [sh_name    ddblank(frame(fra_ind).elements(mat_ind(1,i),:)),','];	
	lg_name = [lg_name,   attribute(att_ind).index(i).name,'=',...
	frame(fra_ind).elements(variable(var_ind).index_value(i),:),','];		
end
sh_name(length(sh_name)) = ')';	
lg_name(length(lg_name)) = ')';	

variable(var_ind).full_name = lg_name;
variable(var_ind).short_name = sh_name;
useless = pin_manipulation('variable','all',[]);

fprintf(1,'List of short and full names of created variables\n',[]);
fprintf(1,'%s\n',[variable(var_ind).short_name,'   ',variable(var_ind).full_name]);

for ii = 2:size(mat_ind,1)
	var_ind = var_ind + 1;	
	ind_new_obj = make_empty('variable');
	useless = pin_manipulation('variable','all',[]);
	
	variable(ind_new_obj).attribute = root_att;
	variable(ind_new_obj).index_value = [mat_ind(ii,:)]; 
	variable(ind_new_obj).frame = VFRA; 
	variable(ind_new_obj).full_name = root_full_name;
	variable(ind_new_obj).short_name = root_short_name;
	
	% the names of the variables
	% [lg_name, sh_name] = build_var_name(var_ind); % default names not used anymore
	sh_name = [VSHN,'(']; %)
	lg_name = [variable(var_ind).full_name,'(']; %)
	for i = 1:size(mat_ind,2)
		fra_ind = pin_manipulation('frame','num2ind',attribute(att_ind).index(i).frame);	
		sh_name = [sh_name    ddblank(frame(fra_ind).elements(mat_ind(ii,i),:)),','];	
		lg_name = [lg_name,   attribute(att_ind).index(i).name,'=',...
		frame(fra_ind).elements(variable(var_ind).index_value(i),:),','];		
	end
	sh_name(length(sh_name)) = ')';	
	lg_name(length(lg_name)) = ')';	
	variable(ind_new_obj).full_name = lg_name;
	variable(ind_new_obj).short_name = sh_name;
	fprintf(1,'%s\n',[variable(ind_new_obj).short_name,'   ',variable(ind_new_obj).full_name]);
end
var_ind_out = var_ind;
