function object_editor
% the editor for frame structure attribute variable objets

%
%   Version : Apr 6,03
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global screen_size gui_position
global flags  flag_str cclick
global hd_help_object   hd_help_menu    name_calling_window
global CallBackData  CallBackCell


global gui_position  figure_data  flags  help_level help_label
global help_label  hd_help_menu 
global keyhit  belief Which_Courier

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% creating full screen window with the 4 objects in listbox
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_full_scr_fig = figure('name','Object Editor');
set(gcf,'position',gui_position(:,19));

ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Object Editor';
figure_data(ind_fig).handle = hd_full_scr_fig;
figure_data(ind_fig).position = gui_position(:,19);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% put its menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(''Quit'')','on');

k=k+1;make_fig_menu(ind_fig,k, 'Edit',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'New Frame', 3,'general_clb(''New_Frame'')','on');
k=k+1;make_fig_menu(ind_fig,k,'New Structure', 3,'general_clb(''New_Structure'')','on');
k=k+1;make_fig_menu(ind_fig,k,'New Attribute', 3,'general_clb(''New_Attribute'')','on');
k=k+1;make_fig_menu(ind_fig,k,'New Variable', 3,'general_clb(''New_Variable'')','on');

k=k+1;make_fig_menu(ind_fig,k,'Edit Frame', 3,'general_clb(''Edit_Frame'')','on','separator');
k=k+1;make_fig_menu(ind_fig,k,'Edit Structure', 3,'general_clb(''Edit_Structure'')','on');
k=k+1;make_fig_menu(ind_fig,k,'Edit Attribute', 3,'general_clb(''Edit_Attribute'')','on');
k=k+1;make_fig_menu(ind_fig,k,'Edit Variable', 3,'general_clb(''Edit_Variable'')','on');

k=k+1;make_fig_menu(ind_fig,k,'Delete Frame', 3,'general_clb(''Delete_Frame'')','on','separator');
k=k+1;make_fig_menu(ind_fig,k,'Delete Structure', 3,'general_clb(''Delete_Structure'')','on');
k=k+1;make_fig_menu(ind_fig,k,'Delete Attribute', 3,'general_clb(''Delete_Attribute'')','on');
k=k+1;make_fig_menu(ind_fig,k,'Delete Variable', 3,'general_clb(''Delete_Variable'')','on');

k=k+1;make_fig_menu(ind_fig,k, help_label,0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'View Help', 16,'general_clb(''view_help'')','on');

menu_manager('create',ind_fig)

% figure_data(ind_fig).menu(k).handle is the menu handle  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% % The 4 listbox for frame, structure, attribute, variable (larger as longer names)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% their position (larger for variable as longer names)
ht_text = .92;

for i = 1:3
	gui_pos(:,i) = [.25+(i-1)*.165  .01 .16 ht_text]';
end

switch computer
case 'PCWIN' 
	gui_pos(:,4) = [ .745  .01  .26 ht_text]';
case 'MAC2'
	gui_pos(:,4) = [ .745  .01  .26 ht_text]';  
otherwise
	gui_pos(:,4) = [ .745  .01  .26 ht_text]';
end

gui_pos(:,5) = [ .005  .01  .24 .982]'; % for left list

% the number of real objects of each type  
% length is with blanks
nbr_fra = length(frame);
nbr_str = length(structure);
nbr_att = length(attribute);
nbr_var = length(variable);

if nbr_fra; 	exist_fra = 1; else ; exist_fra = 0; end
if nbr_str; 	exist_str = 1; else ; exist_str = 0; end
if nbr_att; 	exist_att = 1; else ; exist_att = 0; end
if nbr_var; 	exist_var = 1; else ; exist_var = 0; end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% listing all objects
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_list(1,:) = listing_existing('frame', 	 gui_pos(:,1), hd_full_scr_fig,[]);
hd_list(2,:) = listing_existing('structure',  gui_pos(:,2), hd_full_scr_fig,[]);
hd_list(3,:) = listing_existing('attribute',  gui_pos(:,3), hd_full_scr_fig,[]);
hd_list(4,:) = listing_existing('variable',	 gui_pos(:,4), hd_full_scr_fig,[]);	

select_list(hd_list,'off','one');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% % The local help at upper left
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% make a box, type text
k = 0;
k=k+1;ht{k} = 'Beliefs built on product space of several Variables';
k=k+1;ht{k} = ' ';
k=k+1;ht{k} = 'Every object has a short name, which must be unique.';
k=k+1;ht{k} = 'You may add a full name. By default, it will be equal to the short_name';
k=k+1;ht{k} = ' ';
k=k+1;ht{k} = 'Frame = set of possible values';
k=k+1;ht{k} = 'Structure = set of Frames';
k=k+1;ht{k} = 'Attribute = Structure + Indexes';
k=k+1;ht{k} = 'Index = name + Frame';
k=k+1;ht{k} = 'Variable = Attribute + Frame';
k=k+1;ht{k} = '         + values for indexes';
k=k+1;ht{k} = ' ';
k=k+1;ht{k} = 'New objects can be created using the Edit menu. Fill the boxes in the query panel.';
k=k+1;ht{k} = 'Deleting objects can be done using the Edit menu.';
k=k+1;ht{k} = 'Double click on an object in a list produces a display of the object content. It can be edited by just rewriting the text in the queries.';
k=k+1;ht{k} = 'Sometime the system asks you to select one and only one object, just do it.';
k=k+1;ht{k} = ' ';
k=k+1;ht{k} = 'Mapping = relation between Frames of same Structure (found in another menu NA)';
k=k+1;ht{k} = ' ';
k=k+1;ht{k} = 'If you start creating an object and then stop its creation, be sure to delete it if it shows up in its list.';
k=k+1;ht{k} = ' ';
k=k+1;ht{k} = 'Yellow header = list is selected';
k=k+1;ht{k} = 'White header = list not accessible';

hd_help = uicontrol('style','text','position',gui_pos(:,5)'+[.005 .005 -.015 -.01]);
[out_text, pos_ht] = textwrap(hd_help,ht);
delete(hd_help)

posit_fr = [gui_pos(1,5)    gui_pos(2,5)+gui_pos(4,5)-pos_ht(4)-.05  gui_pos(3,5)-.005  pos_ht(4)+.05];
posit_tx = posit_fr + [.005 .005 -.01 -.01];
hd_help(1) = uicontrol('style','frame',...
'position',posit_fr);
hd_help(2) = uicontrol('style','text',...
'position',posit_tx,...
'string',out_text,...
'HorizontalAlignment','left');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% either a menu is selected (and executed) or a line in a list box is selected
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
while go_on
	object = [];
	flags = 0;
	flag_str = '';
	% menus are on/off as possible as now
	
	setting_menus(nbr_fra,nbr_str,nbr_att,nbr_var,hd_list)
	% the callback for hd_list(i,1) and hd_list(i,2) is Frame, Structure... in flag_str
	% so one can selet the title of the panel or anywhere in panel
	
	set_list_selection(hd_list,[1,1,1,1]) % 4 lists on on , one 
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	uiwait(gcf)
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	option = flag_str;  % either from the menu (New_xxx, Edit_xxx, or as I select the panel xxx
	
	skip_it = 0;
	% I MUST use object. and not diurectly the end object, 
	% so I can cancel the process anywhere without destroying data
	
	switch option
	
	% rules for edit, new: 
	% first click window  = select the window, 
	% second click window = 
	%         if on an object = edit,   option = Edit_XXX
	%         if on space = new         option = New_XXX
	
	case 'view_help'
		gcf_mem = gcf;
		% handlingt the view help, with its own wait	
		hd_help_gen = forced_display_helps(1,44);
		delete(hd_help_gen)
		figure(gcf_mem)
		
	case {'Frame','New_Frame','Edit_Frame'}
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% Edit Frame
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		Obj_Ed_Frame
		
	case {'Structure','New_Structure','Edit_Structure'}
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% Edit Structure
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		Obj_Ed_Structure
		
	case {'Attribute','New_Attribute','Edit_Attribute'}
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% Edit Attribute
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		Obj_Ed_Attribute
		
	case {'Variable','New_Variable','Edit_Variable'}
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% Edit Variable
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		Obj_Ed_Variable
		
	case {'Delete_Frame','Delete_Structure','Delete_Attribute','Delete_Variable'}
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% Delete
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	`
		
		Obj_Ed_Delete
		
	case 'Quit'
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% Quit
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		go_on = 0;
		delete(hd_full_scr_fig);	
		figure_data(ind_fig) = [];
		
	end % switch
end % while go_on
