function batch_mode(fid)
% getting all instructions from a file

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% when adding instruction, check file    list_field_kw_fn
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
%   Version : June 12,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global pathname2TBMLABvers
global flagstr flags infinity

disp('Report: entering batch_mode')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the field keywords and full names kwfn  and the object names kwobj
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[kwfn, kwobj] = list_field_kw_fn;
skip_verify = 0; % by default verification is done, skipped with SKIP VERIFICATION

ind_var = 0;
ind_att = 0;
ind_ind = 0;
ind_map = 0;
ind_str = 0;
ind_fra = 0;
ind_bel = 0;
ind_pot = 0;
ind_for = 0;

% get_all_pin_tables already executed in run_inititiating_TBM

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% eliminating the data in front of the relevant data 
% that are produced as header by the text editor
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
while go_on
	text_line = fgetl(fid); % Read line from file, discard newline character
	if ~isempty(findstr('TBMLAB BEGIN',text_line))
		go_on = 0;
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% we begin by storing in test_line_mem the instructions, so I can reorder them
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ok = 1;
go_on = 1;
i_mem = 0;
while go_on
	line_cont = 1;
	line_inst = [];
	
	% reading one instruction, maybe on several lines (with ... )
	while line_cont 
		text_line = fgetl(fid);
		if isempty(text_line)
			text_line  = '%'; % i made it as a comment, so skipped later
		end
		if strcmp(text_line(1),'\') % it is a line without data but with layout instruction, i skip	
			text_line = '%'; % i made it as a comment, so skipped later
		end
		% for mysterious reason Mac put ascii 92 = \ at many places XXXX
		text_line = strrep(text_line,'\','');  % PRINTED if error
		text_line = ddblank(text_line); % leading and trailing blanks are gone
		
		skp = 0;		
		if isempty(text_line)
			skp = 1; % empty text_line, I skip
		elseif strcmp(text_line(1),'%')  
			skp = 1; % a comment, I skip
		else	
			% looks like a good line
			% checking line continuation
			if length(text_line) >= 3  % so I can use a line with just )
				if  strcmp(text_line(length(text_line)-2:length(text_line)),'...')
					% blanks have been removed
					% there is a continuation, I must read it and add it to previous one.
					line_cont = 1;					
					text_line = [ddblank(text_line(1:length(text_line)-3)) ' '];% i clear the ...
					% For logical expressions a line to be contined MUST end with space so I add it for safety
				else
					line_cont = 0;
				end
			else
				line_cont = 0;			
			end
			line_inst = [line_inst text_line];
		end
	end	
	% if user stupid and put ... without CR, I handle it as ... CR thus eradicate ...
	line_inst = strrep(line_inst,'...',''); 
	
	if skp == 0 % I keep only useful lines
		i_mem = i_mem + 1;
		text_line_mem{i_mem} = 	line_inst;		
	end

	if	strmatch('TBMLAB END',text_line)
		% we encounter the END of useful data, remainder technical for text editor, we quit
		go_on = 0;		
	end
end
% data stored
last_line = i_mem;
fclose(fid);
% text_line_mem contains every usefull line after TBMLAB BEGIN (not included) and before TBMLAB END (not included)

% % % % for debugging
% % % for i = 1:length(text_line_mem)
% % % 	fprintf(1,'%s\n',text_line_mem{i});
% % % end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Looking for begin and end of objects. All object before TBMLAB END
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% In the batch mode instructions, objects must be in right order
% the user MUST respect the order as a frame defined after a structure that uses it = boum
% previously I was reordering objeccts, but collapses when I enter SAVE
% % finding individual object area for frame...belief
list_beg = [];





for i = 1:length(kwobj)   % the kwobj  FRAME, .... BELIEF ... GBT ...
	% for these objects, creation order is relevant
	obj_beg{i} = find(strcmp(text_line_mem,kwobj{i})); 
	% row vector with list of lines with FRAME ... BELIEF... GBT
	list_beg = [list_beg   obj_beg{i}]; 
	% row with index of list lines where an object start
end	
list_beg = sort([list_beg  last_line]);
nbr_objects = length(obj_beg);	

for i = 1:nbr_objects
	for j = 1:length(obj_beg{i})
		obj_end{i}(j) = list_beg(find(obj_beg{i}(j) == list_beg)+1) - 1 ;		
	end
end
% so we know where each object begins and ends
% they will be executed in order of entry

disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
disp('Begin of text read for batch mode input')
disp('In case of crash, errror occured while translating the last displayed line of text')

% % % % % % % % % for debugging phase
% % % % size(text_line_mem)
% % % % for i = 1:length(text_line_mem)
% % % % 	fprintf(1,'line %3i   %s \n',[i text_line_mem{i}])
% % % % end
% % % % for i_obj = 1:length(obj_beg)
% % % % 	for j_obj = 1:length(obj_beg{i_obj}) 
% % % % 		[obj_beg{i_obj}(j_obj) obj_end{i_obj}(j_obj) ]
% % % % 	end
% % % % end
% % % % for i_list_beg = 1:length(list_beg)-1
% % % % 	i_line = list_beg(i_list_beg);
% % % % 	obj_end = list_beg(i_list_beg+1) - 1; 
% % % % 	[i_line   obj_end]
% % % % 	text_line_mem{i_line}
% % % % end
% % % % % % % % % for debugging phase

for i_list_beg = 1:length(list_beg)-1
	i_line = list_beg(i_list_beg) - 1;
	obj_end = list_beg(i_list_beg+1) - 1;
	
	% for i_obj = 1:length(obj_beg)
	% I look for each object one after the other, order = FRAMES, STRUCTURES, ... BELIEF , and compuation objects
	% 	for j_obj = 1:length(obj_beg{i_obj})  % For object type XXX (FRAMES ... BELIEF) numbers of XXX object asked		
	% 		i_line = obj_beg{i_obj}(j_obj)-1;
	
	while i_line < obj_end % now object use lines from ... to.
		i_line = i_line + 1;
		text_line = text_line_mem{i_line};
		% I dispaly the line on which I work, usefull for error
		fprintf(1,'%s \n',text_line)
		
		switch upper(text_line)
		case 'VARIABLE'
			which_object = {'variable'};
			ind_var = make_empty('variable');
			useless = pin_manipulation('variable','all',[]);
		case 'MAKE_ALL_VARIABLES'
			which_object = {'make_all_variables'};
			indices(5) = ind_var;
			[ok,ind_var_out,out_i_line] = execute_line(which_object,indices,text_line,text_line_mem,i_line);
			ind_var = ind_var_out(1);
			i_line = out_i_line;
		case 'FINISH_VAR'
			which_object = {'variable'};
			[ok,ind_var_out,out_i_line] = execute_line(which_object,indices,text_line,text_line_mem,i_line);
			i_line = out_i_line;
		case 'ATTRIBUTE'	
			which_object = {'attribute',''};
			ind_ind = 0;
			ind_att = make_empty('attribute');
			useless = pin_manipulation('attribute','all',[]);
		case 'INDEX'
			which_object = {'attribute','index'};
			ind_ind = ind_ind + 1;
		case 'STRUCTURE'
			which_object = {'structure'};
			ind_str = make_empty('structure');
			useless = pin_manipulation('structure','all',[]);
		case 'FRAME'
			which_object = {'frame'};
			ind_fra = make_empty('frame');
			useless = pin_manipulation('frame','all',[]);
		case 'DO_VAR'
			% a frame has been built and I must get an unindexed variable made with it
			frame_do_var(ind_fra);
		case 'BELIEF'
			% building the pin_tables for entered data, so OK for frame to past belief
			% needed for conditional beliefs (BPCN)
			get_all_pin_tables;				
			which_object = {'belief','',''};
			ind_pot = 0;
			ind_bel = make_empty('belief');
			useless = pin_manipulation('belief','all',[]);
		case 'POTENTIAL'
			which_object = {'belief','potential',''};
			% either cond var is empty and then ind_pot = 1 (line BPCN is absent)
			% either cond var is not empty and then ind_pot produced by next line BPCN
			if isempty(belief(ind_bel).conditioning_variable)
				wait_for_cond_elem = 0;
				ind_pot = make_empty('bp',ind_bel);
			else
				% bp to be entered in the same order as the elements of condit var
				wait_for_cond_elem = 1;
				ind_pot = ind_pot + 1; % if I don't use BPCN, I'll use the next potential
				if ~isfield(belief(ind_bel),'bp')  
					% the first time I meet POTENTIAL, I build all the condit bp with one form each, and vacuous bba						
					index_object = make_empty('bp',ind_bel);
				else
					if length(belief(ind_bel).bp) == 0
						index_object = make_empty('bp',ind_bel);
					end
				end
			end
			ind_for = 0;
			ik = 5;
			ik = ik + 1; indices(ik) = ind_bel;
			ik = ik + 1; indices(ik) = ind_pot;
			ik = ik + 1; indices(ik) = ind_for;				
			[ok,out_data,out_i_line] = execute_line(which_object,indices,text_line,text_line_mem,i_line);
			i_line = out_i_line;
			ind_var = out_data(1);
			ind_pot = out_data(2);
		case 'FORM'  % empty one built by make_empty('potential'...)
			which_object = {'belief','potential','form'};
			ind_for = ind_for + 1;
			% but for next form I need an empty one
			if ind_for > 1
				index_object = make_empty('form',ind_bel,ind_pot,ind_for);
			end								
		case 'RANDOM'
			which_object = {'belief','potential','form'};
			ik = 5;
			ik = ik + 1; indices(ik) = ind_bel;
			ik = ik + 1; indices(ik) = ind_pot;
			ik = ik + 1; indices(ik) = ind_for;
			[ok,out_data,out_i_line] = execute_line(which_object,indices,text_line,text_line_mem,i_line);
			ind_var = out_data(1);
			i_line = out_i_line;
		case 'RANDOM_N'		
			which_object = {'belief','potential','form'};
			ik = 5;
			ik = ik + 1; indices(ik) = ind_bel;
			ik = ik + 1; indices(ik) = ind_pot;
			ik = ik + 1; indices(ik) = ind_for;
			[ok,out_data,out_i_line] = execute_line(which_object,indices,'RANN',text_line_mem,i_line);
			ind_var = out_data(1);
			i_line = out_i_line;
		case 'PRDF'
			which_object = {'belief','potential','form'};
			ik = 5;
			ik = ik + 1; indices(ik) = ind_bel;
			ik = ik + 1; indices(ik) = ind_pot;
			ik = ik + 1; indices(ik) = ind_for;
			[ok,out_data,out_i_line] = execute_line(which_object,indices,text_line,text_line_mem,i_line);
			ind_var = out_data(1);
			i_line = out_i_line;
		case 'RUN'
			i_line = i_line + 1;
			text_line = text_line_mem{i_line};
			eval(text_line);			
			% I will evaluate the function, I keep paraleters as last instruction
		case 'LOAD'
			% load a binary file previously saved
			out = handling_files('open');			
		case 'SAVE'
			% save all objects in file with name in asked on screen
			out = handling_files('save_obj');
		case 'COMPUTATION'
			% make sure all pin are ok
			get_all_pin_tables;	
		case 'CHANGE_FRAME'
			% change frame with martginalization/vacuous extension						
			which_object = {'CHFR','',''};
			useless = pin_manipulation('belief','all','');
			ind_bel = ind_bel + 1;
			ind_pot = 1;
			ind_for = 1;
			flagstr = ''; % used for storing tempor data
			% empty belief built in change_frame itself
		case 'GBT'
			% all I need is num bel cond and cond event (bba or subset)	and prior on T							
			which_object = {'GBT','',''};
			useless = pin_manipulation('belief','all','');
			ind_bel = ind_bel + 1;
			ind_pot = 1;
			ind_for = 1;
			flagstr = ''; % used for storing tempor data
			% empty belief built in gbt itself
		case 'DRC'
			% all I need is num bel cond and cond event								
			which_object = {'DRC','',''};
			useless = pin_manipulation('belief','all','');
			ind_bel = ind_bel + 1;
			ind_pot = 1;
			ind_for = 1;
			flagstr = ''; % used for storing tempor data
			% empty belief built in gbt itself
		case 'GBTPDF'
			% for GBT with only continuous/integer X based on pdf for each t
			which_object = {'GBTPDF','',''};
			useless = pin_manipulation('belief','all','');
			ind_bel = ind_bel + 1;
			ind_pot = 1;
			ind_for = 1;
			flagstr = ''; % used for storing tempor data
			% empty belief built in gbtpdf itself
		case 'CCR'
			which_object = {'CCR','',''};
			flagstr = '';
			ind_bel = make_empty('belief'); 
			ind_pot = make_empty('bp',ind_bel);% produces empty belief bp and form
			ind_for = 1;	
			useless = pin_manipulation('belief','all',[]);
		case 'DCR'
			which_object = {'DCR','',''};
			flagstr = '';
			ind_bel = make_empty('belief'); 
			ind_pot = make_empty('bp',ind_bel);% produces empty belief bp and form
			ind_for = 1;	
			useless = pin_manipulation('belief','all',[]);
		case 'CAUTIOUSCC'
			% cautious conjunctive combination rule
			which_object = {'CAUTC','',''};
			% belief built in cautious combi itself
			ind_bel = make_empty('belief'); 
			ind_pot = make_empty('bp',ind_bel);% produces empty belief bp and form
			ind_for = 1;	
			flagstr = '';
			useless = pin_manipulation('belief','all',[]);				
		case 'VBS'
			which_object = {'VBS','',''};
			useless = pin_manipulation('belief','all','');
			useless = pin_manipulation('variable','all','');
			new_pin = get_next_pin('belief');
			ind_bel = new_pin(2);
			ind_pot = 1;
			ind_for = 1;	
			flagstr = '';
		case 'PRINT'
			which_object = {'PRINT','',''};	
			flagstr = '';
		case 'REPORT'
			fid = 1; % printed on command window
			print_report
		case {'PBEG','PEND','PRBT','PRBX','COMP'}
			ik = 5;
			ik = ik + 1; indices(ik) = ind_bel;
			ik = ik + 1; indices(ik) = ind_pot;
			ik = ik + 1; indices(ik) = ind_for;
			[ok,out_data,out_i_line] = execute_line(which_object,indices,text_line,text_line_mem,i_line);
			ind_var = out_data(1);
			i_line = out_i_line;
		case 'SKIP VERIFICATION'	
			skip_verify = 1;
			which_object = '';
			flagstr = '';	
		case 'TBMLAB END'
			which_object = '';
			flagstr = '';
		otherwise
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% the instructions with XXXX = something
			% preparing for the    eval('XXXX = xxxx')
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			if isempty(findstr(text_line,'=')) & max(strcmp(text_line(1),{'0','1','.'}))~= 1
				% error missing =
				disp('There is an arror in your input file. I stop here. Wrong text_line is ')
				text_line
				go_on = 0;			
			else
				% rewriting the text_line by adding [] or '' or {'',''}
				% no space allowed in a name, always _
				switch upper(text_line(1:4))
				case {'VINX','BDCR','BCCR'}
					% making DATA = [...]
					text_line = strrep(text_line,'=','=[');
					text_line(length(text_line)+1) = ']';
				case {'FSHN','FFLN','FTYP',...
					'SSHN','SFLN','SMRF',...
					'ASHN','AFLN','ASTR','AIXN','AIXF',...
					'VSHN','VFLN','VFRM',...
					'BSHN','BFLN','BAGN','BEVC','BCMP',...
					'PFRM','PFMN','PREP'}
					% making DATA = '...'
					text_line = strrep(text_line,' ','');
					text_line = strrep(text_line,'=','=''');    
					text_line(length(text_line)+1) = '''';
				case {'SSFR','VATT','CNDB','FILE','BDVR','BCVR'}
					% making DATA = '...' keeping the spaces when multi references
					pos_eq = min(findstr('=',text_line));
					text_line(pos_eq) = '?';
					text_line = strrep(text_line,'?','=''');    
					text_line(length(text_line)+1) = '''';
				case {'ELEM','BPCN','CNDE','BELF','PVAR'}
					% making DATA = {'...','...'}
					pos_eq = min(findstr('=',text_line));
					text_line(pos_eq) = '?';
					text_line = strrep(text_line,' ','');
					text_line = strrep(text_line,'?','={''');
					text_line = strrep(text_line,',',''',''');
					text_line(length(text_line)+1) = '''';
					text_line(length(text_line)+1) = '}';
				case {'DISC','DATA'}
					% making DATA = [ xxx yyy zzz] or [xxx,yyy,zzz] (it does not matter)
					text_line = strrep(text_line,'=','=[');
					text_line(length(text_line)+1) = ']';
				case 'SMAP' 
					% to do XXXXX	
				otherwise
					% making DATA = ...  (do nothing)
				end % switch text_line(1:4)
			
				text_line(length(text_line)+1) = ';';
				% now text_line is evaluable with eval
				% not ok if (mass,focal_set), I will take it away then.
				ik = 0;
				ik = ik + 1; indices(ik) = ind_fra;
				ik = ik + 1; indices(ik) = ind_str;
				ik = ik + 1; indices(ik) = ind_att;
				ik = ik + 1; indices(ik) = ind_ind;
				ik = ik + 1; indices(ik) = ind_var;
				ik = ik + 1; indices(ik) = ind_bel;
				ik = ik + 1; indices(ik) = ind_pot;
				ik = ik + 1; indices(ik) = ind_for;
				ik = ik + 1; indices(ik) = ind_map;
				
				[ok,out_data,out_i_line] = execute_line(which_object,indices,text_line,text_line_mem,i_line);
				
				ind_var = out_data(1);
				ind_pot = out_data(2);
				i_line = out_i_line;
				if ok == 0
					disp('There is an error in your input file. I stop here. Wrong text_line is ')
					text_line
					go_on = 0;
				end				
			end % if isempty(findstr(text_line,'='))
		end % switch upper(text_line)		
	end % i_line
end % i_list_beg

if ok == 0 
	% it was wrong
	text = 'There is a mistake in your input file for the batch mode. See MATLAB Command Window. I stop and cancel batch mode.';
	choice = text_with_n_buttons(gcf, text,{'Cancel'}, [0 0 0 0]);
	text_line
	return
end

% building the pin_tables for entered data, supposedly already done
get_all_pin_tables;



% finishing cardinalities
for i = 1:length(belief)	
	var_ind = pin_manipulation('variable','num2ind',[belief(i).domain_variable]);	
	bel_fra_ind = pin_manipulation('frame','num2ind',[variable(var_ind).frame]);	
	belief(i).domain_cardinality = [frame(bel_fra_ind).cardinality];	
	if length(belief(ind_bel).conditioning_variable)		
		var_ind = pin_manipulation('variable','num2ind',[belief(i).conditioning_variable]);	
		bel_fra_ind = pin_manipulation('frame','num2ind',[variable(var_ind).frame]);			
		belief(i).conditioning_cardinality = [frame(bel_fra_ind).cardinality];
	end		
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Displaying what I have read 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

text = {'To get a listing of the created objects on MATLAB Command Window, just select a format for the focal sets.'};
choice = text_with_n_buttons(gcf, text,{'No','Decim','Octal','Hexad','Binary'}, [0 0 0 0]);
if choice > 1
	conv = {'','decimal','octal','hexadecimal','binary'};
	for i_obj = 1:length(kwobj) 
		if max(strcmp(kwobj{i_obj},{'FRAME','STRUCTURE','ATTRIBUTE','VARIABLE','BELIEF'})) == 1
			fprintf(1,'\n\n%s\n',[kwobj{i_obj}]);
			clear object;
			object = eval( lower(kwobj{i_obj}));
			for i = 1:length(object)
				object(i)
				if strcmp(kwobj{i_obj},'FRAME')					
					fprintf(1,'\nLabels of the elements\n',[])
					for ki = 1:size(object(i).elements,1)
						fprintf(1,'element %3i, label = %s \n',[ki, object(i).elements(ki,:)]);
					end	
					fprintf(1,'\n',[]);
				end  
				if strcmp(kwobj{i_obj},'BELIEF')
					
					% only for only discrete frames
					if size(object(i).dci_var.pin_c,1) == 0 & size(object(i).dci_var.pin_i,2) == 0
						card = prod(object(i).domain_cardinality);
						% if card == 0 or missing BOUM					
						for kl = 1:length(object(i).bp)
							fprintf(1,'\nPotential %-3i\n',[kl]);
							object(i).bp(kl)													
							for kn = 1:length(object(i).bp(kl).form)
								fprintf(1,'\nPotential %-3i Form %-3i\n',[kl,kn]);
								object(i).bp(kl).form(kn)
								
								fprintf(1,'\n  index   mass   focal set in %s\n',[conv{choice}]);
								for kk = 1:length(object(i).bp(kl).form(kn).values)	
									if strcmp(object(i).bp(kl).form(kn).representation,'ordered')
										focs = kk-1;
									else
										focs = object(i).bp(kl).form(kn).focal_sets(kk,:);
									end
									switch choice
									case 2
										foset = int2str(focs);						
									case 3
										foset = long_number_conv(focs,'d','o',card);
									case 4
										foset = long_number_conv(focs,'d','X',card);
									case 5
										bits = long_number_conv(focs,'d','b',card);
										fr = length(bits)+1;
										foset = [];
										for im=1:fix((length(bits)-1)/10) + 1
											to = fr - 1;
											fr = max(fr - 10,1);
											foset = [num2str([bits(fr:to)],'%1i'),' ',foset];
										end
									end
									fprintf(1,'  %3i   %6.4f   ',[kk   object(i).bp(kl).form(kn).values(kk)]);
									fprintf(1,'%s \n', [foset]);
								end
							end
						end
						fprintf(1,'\n\n',[]);
					end
				end % if strcmp(kwobj{i_obj},'BELIEF')
			end	% for i = 1:length(object)`
		end
	end % for i_obj = 1:length(kwobj)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% verifying entered data are adequate
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if skip_verify == 0
	ok_objects = verifying_object_data;
	if ok_objects == 0
		hdw = warndlg('There are errors in your data. See the Command Window.');
		uiwait(hdw)
	end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% reactivate menu at root level : obtain by opening closing another window
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[index_fig, hd_fig] = handling_all_figures('put_in_front',{'General Window'});
