function [ok,out_data,out_i_line] = execute_line(...
which_object,indices,text_line,text_line_mem,i_line)

% out_data is used for any output needed for giving data back to calling fct
% before using it,  a clear is needed as its structure changes

%
%   Version : Nov 21,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global flagstr flags infinity

ok = 1;

ik = 0;
ik = ik + 1; ind_fra = indices(ik);
ik = ik + 1; ind_str = indices(ik);
ik = ik + 1; ind_att = indices(ik);
ik = ik + 1; ind_ind = indices(ik);
ik = ik + 1; ind_var = indices(ik);
ik = ik + 1; ind_bel = indices(ik);
ik = ik + 1; ind_pot = indices(ik);
ik = ik + 1; ind_for = indices(ik);
ik = ik + 1; ind_map = indices(ik);
out_data = [];
out_data(1) = ind_var;
out_data(2) = ind_pot;
out_i_line = i_line;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% the focal sets and their mass (belief)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

% handling the single word instruction
if strcmp(upper(text_line),'PBEG')
	% read till PEND
	i_line = i_line + 1;
	text_line = text_line_mem{i_line};
	fprintf(1,'%s\n',text_line)	
	% clear default belief
	belief(ind_bel).bp(ind_pot).form(ind_for).values = [];
	belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = [];
	
	while ~strcmp(upper(text_line),'PEND')
		mass_foset_case
		i_line = i_line + 1;
		text_line = text_line_mem{i_line};
		fprintf(1,'%s\n',text_line)
	end	

	% the unallocated mass is given to universe
	tot_m = sum(belief(ind_bel).bp(ind_pot).form(ind_for).values);
	if tot_m < 1
		belief(ind_bel).bp(ind_pot).form(ind_for).values = [...
		belief(ind_bel).bp(ind_pot).form(ind_for).values ; 1-tot_m];
		
		if length(belief(ind_bel).dci_var.pin_c) |  length(belief(ind_bel).dci_var.pin_i)
			hdw = warndlg('ececute_line function not yet programmed for continuous or integer variables');
			uiwait(hdw)
		else
			belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets = [...
			belief(ind_bel).bp(ind_pot).form(ind_for).focal_sets ;...
			get_universe(prod(belief(ind_bel).domain_cardinality)) ];
		end
		ij = length(belief(ind_bel).bp(ind_pot).form(ind_for).values);
		belief(ind_bel).bp(ind_pot).form(ind_for).log_expr{ij} = 'universe';
	end
	% we read line after line, one value par line
	% stop with 'PEND
	out_i_line = i_line;
	return	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% the marginal bleiefs used for GBT/DRC (computation)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

if max(strcmp(upper(text_line),{'PRBX','PRBT','COMP'}))
	
	% initilaize as vacuous
	ind_cd_bel = flagstr{3};  % given by CNDB in gbt_drc_case
	num_cd_bel = pin_manipulation('belief','ind2num',ind_cd_bel);
	
	X_info = [2,[]];
	T_info = [2,[]];
	
	if strcmp(which_object{1},'GBT')
		gbt_drc = 'T';
		comput = ['gbt ',num2str(num_cd_bel)];
	else
		gbt_drc = 'X';
		comput = ['drc ',num2str(num_cd_bel)];
	end			
	orig = [num_cd_bel,0];
	
	while ~strcmp(text_line,'COMP')
		switch upper(text_line)
		case 'PRBT'
			card = prod(belief(ind_cd_bel).conditioning_cardinality);
			mem_TX = 'PRBT';
		case 'PRBX'
			card = prod(belief(ind_cd_bel).domain_cardinality);
			mem_TX = 'PRBX';
		end			
		i_line = i_line + 1;
		text_line = text_line_mem{i_line};
		fprintf(1,'%s \n',text_line);
		
		marginal_data_case		
		
		switch text_line(1)			
		case 'B' % given by a prior belief
			switch mem_TX
			case 'PRBT'
				T_info = [0 num_bel];
				comput = [comput,' bba on T = ',num2str(num_bel)];
				orig = [orig; num_bel,0];
			case 'PRBX'
				X_info = [0 num_bel];
				comput = [comput,' bba on X = ',num2str(num_bel)];				
				orig = [orig; num_bel,0];
			end	
		case 'S' % given as a subset
			switch mem_TX
			case 'PRBT'
				T_info = [1 condit_foset];
			case 'PRBX'
				X_info = [1 condit_foset];
			end	
		end		
		i_line = i_line + 1;
		text_line = text_line_mem{i_line};	
		fprintf(1,'%s \n',text_line);
	end

	% I met COMP, compute GBT/DRC
	num_post_belief = full_gbt_computer(num_cd_bel,X_info,T_info,gbt_drc);
	% new belief created in  	full_gbt_computer
	% change its names
	ind_post_belief = pin_manipulation('belief','num2ind',num_post_belief);
	
	belief(ind_post_belief).short_name = [flagstr{1}];	
	belief(ind_post_belief).origin = orig;	
	belief(ind_post_belief).computed = comput;
	
	if isempty(flagstr{2})
		belief(ind_post_belief).full_name = [flagstr{2}];
	else
		belief(ind_post_belief).full_name = [flagstr{1}];
	end
	out_i_line = i_line;
	return	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%
% to be here = I did not encountered the special cases above
% I assign the right hand term to the left hand variable like in FSHN = 43 or FSHN = 'my_frame'
% The ' where added before
%

text_line(1:4) = upper(text_line(1:4)); % to be sure 4 letters instructions are capital
eval(text_line,'ok = 0;')
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	

ok = 1;

switch which_object{1}

case 'frame'
	frame_case
	
case 'mapping'
	%NA
	
case 'structure'
	structure_case
	
case 'attribute'
	attribute_case
	
case 'variable'
	variable_case
	
case 'make_all_variables'
	var_ind_out = get_all_var(variable(ind_var).short_name,variable(ind_var).frame,variable(ind_var).attribute,ind_var);
	ind_var = var_ind_out;
	clear out_data
	out_data = ind_var;
	
case 'belief'
	belief_case
	
case 'CHFR'
	ch_fr_case
	
case {'GBT','DRC'}
	gbt_drc_case
	
case 'GBTPDF'
	gbt_pdf_case
	
case {'CCR','DCR'}
	ccr_dcr_case
	
case 'CAUTIOUSCC'
	cautious_case
	
case 'VBS' 
	switch upper(text_line(1:4))
	case 'BSHN'
		flagstr{1} = BSHN;
	case 'BFLN'
		flagstr{2} = BFLN;
	case 'BELF'
		flagstr{3} = BELF;
	case 'PVAR'
		for i = 1:length(flagstr{3})
			ind_bell(i) = find_field('belief','short_name',ddblank(flagstr{3}{i}));
		end
		for i = 1:length(PVAR)
			ind_varr(i) = find_field('variable','short_name',ddblank(PVAR{i}));
		end
		ind_bell = unique(ind_bell);
		ind_varr = unique(ind_varr);

		parameter{1} = [belief(ind_bell).number];
		parameter{2} = [variable(ind_varr).number];	
		
		
		run_VBS('from_Batch_Mode',parameter)	
		
		belief(ind_bel).short_name = flagstr{1};
		if ~isempty(flagstr{2})
			belief(ind_bel).full_name = flagstr{2};
		else
			belief(ind_bel).full_name = flagstr{1};
		end
		belief(ind_bel).computed = 'Batch_Mode_VBS';
		num_belief = [belief(ind_bell).number];
		belief(ind_bel).origin = [num_belief' ones(length(num_belief),1)];
		useless = pin_manipulation('belief','all',0);	
	end
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
case 'PRINT'
	switch upper(text_line(1:4))
	case 'FILE'
		flagstr{1} = ddblank(FILE); % file name for storing printed text 
	case 'BELF'
		if strcmp(lower(ddblank(BELF)),'all')
			pack_index
			nbr_bel_pr = length(belief);
			for i = 1:nbr_bel_pr
				bel_indv(i) = i;
				nbr_bp(i) = length(belief(i).bp);
				for j = 1:nbr_bp(i)
					bp_indd{i}(j) = j;
				end
			end		
		else
			nbr_bel_pr = 1;
			bel_indv(1) = find_field('belief','short_name',ddblank(BELF));
			nbr_bp(1) = length(belief(bel_indv(1)).bp);
			for j = 1:nbr_bp(1)
				bp_indd{1}(j) = j;
			end
		end
	
		for i = 1:nbr_bel_pr
			bel_ind = bel_indv(i); 
			
			nbr_d = size(belief(bel_ind).dci_var.pin_d,1);
			nbr_c = size(belief(bel_ind).dci_var.pin_c,1);
			nbr_i = size(belief(bel_ind).dci_var.pin_i,1);
			
			% decidning type of variables involved
			type_display = 'mixed';
			if nbr_d > 0 & nbr_c == 0 & nbr_i == 0
				type_display = 'discr_only';
			end
		
			for j = 1:nbr_bp(i)
				bp_ind = bp_indd{i}(j);	
				if  nbr_c > 0 | nbr_i > 0				
					type_display = 'some_CI';
				end
				if is_ci_pdf(bel_ind,bp_ind)
					type_display = 'pdf_based';
				else			
					form_ind = find(strcmp({belief(bel_ind).bp(1).form(:).type},'m'));	
				end				
				switch type_display
				case 'discr_only'
					% for pure discrete
					nbr_bbm_displayed = min(30,length(belief(bel_ind).bp(bp_ind).form(form_ind).values));
					
					[var_name_list, element_list, element_numbers,label_details] = ...
					creating_elements(belief(bel_ind).domain_variable);
					
					[BetP_elem, Bel_elem, Pl_elem, bbm, foset,mass0] = res_disp_one(bel_ind, bp_ind, form_ind);
					
					flagstr{2} = BetP_elem;
					flagstr{3} = Bel_elem;
					flagstr{4} = Pl_elem;
					
					nbr_worlds = prod([belief(bel_ind).domain_cardinality]);
					[hd_sing,ik] = res_disp_six(bel_ind,bp_ind,form_ind, var_name_list,element_numbers,label_details,...
					mass0,bbm,   nbr_bbm_displayed,nbr_worlds,foset, -1,0,0,0); 
					% the 'save' is done by  res_disp_six because of the -1 after foset
				case 'some_CI'	
					% for mix discr CI
					fprintf(1,'\nBelief alloated to continuous or integers frames with possibly some discrete frames.\n',[]);
					fprintf(1,'belief short_name %s, full_name %s, potential %3i\n',...
					[belief(bel_ind).short_name, belief(bel_ind).full_name, bp_ind])
				case 'pdf_based'
					% for pdf based CI	
					fprintf(1,'\npdf based potential\n',[]);
					tx = ['belief short_name ',belief(bel_ind).short_name,', full_name ',...
					belief(bel_ind).full_name,', potential ',num2str(bp_ind)];
					fprintf(1,'%s\n',[tx]);
					
					ind_for = ismember({belief(bel_ind).bp(bp_ind).form(:).type}, {'m_pdf','BetP_pdf'});
					if length(ind_for)>1 % should not occur, but security
						ind_for(2:end) = [];
					end				
					tx = ['pdf meaning ',belief(bel_ind).bp(bp_ind).form(ind_for).type,', pdf is ', belief(bel_ind).bp(bp_ind).form(ind_for).representation];
					fprintf(1,'%s\n',tx);
					fprintf(1,'its parameters ''ab'' are %g, %g, mean = %g, std_dev = %g\n',...
					[belief(bel_ind).bp(bp_ind).form(ind_for).values]);
					
				otherwise
					% do nothing					
				end
			end
		end
	end
case 'end'
	% do nothing
end
