% gbt_pdf_case  for running the GBT based on pdf
% input is interval  or point

switch upper(text_line(1:4)) 
case 'BSHN'
	belief(ind_bel).short_name = BSHN;
	belief(ind_bel).full_name = BSHN;
case 'BFLN'
	belief(ind_bel).full_name = BFLN;
case 'CNDB'
	% store the belief object with cond bel (index)
	ind_cd_bel = find_field('belief','short_name',ddblank(CNDB));
	if ind_cd_bel <= 0 | length(ind_cd_bel) ~= 1
		disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
		disp('GBTPDF requested short name of belief is not OK. Soon I''ll crash.') 
	end
	flagstr{1} = ind_cd_bel;
case 'DATA'
	if length(DATA) == 1 
		% point data
		Xmin = DATA;
		Xmax = DATA;
	elseif length(DATA) == 2 
		% interval data
		Xmin = min(DATA);
		Xmax = max(DATA);
	else
		% error
		disp('error in GBTPDF  DATA request. Next what I found. I crash.');
		DATA
		BOUM
	end	
	proceed = 1;
	ind_cd_bel = flagstr{1};
	nbr_pot = length(belief(ind_cd_bel).bp);
	for i = 1:nbr_pot		
		nbr_forms = length(belief(ind_cd_bel).bp(i).form);
		typ_pdf{i} = [];
		ind_form_pdf(i) = 0;
		for j = 1:nbr_forms		
			if strcmp(belief(ind_cd_bel).bp(i).form(j).type,'m_pdf')
				type_pdf{i} = 'bbf';
				ind_form_pdf(i) = j;
			elseif strcmp(belief(ind_cd_bel).bp(i).form(j).type,'BetP_pdf')
				type_pdf{i} = 'Betf';
				ind_form_pdf(i) = j;
			end 
		end
		if isempty(type_pdf{i})
			hdw = warndlg(['No pdf available in potential ',num2str(i),'. I skip']);
			uiwait(hdw);
			proceed = 0; 
		else
			% for bba, any pdf OK, for Betf only gaussian and laplace
			if strcmp(type_pdf{i},'Betf')
				j = ind_form_pdf(i);
				if max(strcmp(belief(ind_cd_bel).bp(i).form(j).representation,{'gaussian','laplace'})) == 0
					hdw = warndlg(['In potential ',num2str(i),', pdf is not Gaussian or Laplace. I skip']);
					uiwait(hdw)
					proceed = 0;
				end								
			end		
		end
	end
	if proceed == 0
		disp('something went wrong in GBTPDF request')
	else
		run_gbt_pdf_CI
	end
end
