function out = handling_files(option)
% opening either binary data, or bath mode input data
% option = 'open' or 'save_obj' or 'save_EVN' 
% with the open, user select a file whih already has a flag like batch., EVN. obj.
% for the save it must be specified so I can put the right label

% out can contains whatever needed locally

% ccontent of one appliation folder
% binary data = a file xxx.obj.mat  of xxx.EVN.mat with all data
% batch mode = a file xxx.batch.txt

% each application has its own folder that contains the binary and batch data
% and all results that concern it.
% It helps when moving from one version to another, or when dumping an application

% pathfn does not include the file name

%
%   Version : Feb 25,04.
%   Copyright (c) 2004 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global root_file_name   file_name_begin   save_path    pathname2TBMLABvers 
global gui_position figure_data 
global memory_file_name
global node pin_node link pin_link histo pin_histo 
global open_binary_menu_used

% ask application name by asking to open a file or to create one
% open a file with its name, located in a folder application_data

% when you select open, you get the list of applictions in application_data

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
out = [];

gcf_mem = gcf;  % so I can go back where i came from

hd_fig = figure('name','File handling');
set(gcf,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'File handling';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

% get help
hd_help = forced_display_helps(0,40);

% change 40 look alos 27 for load binary, 28 29 for save

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% finding the path up to Application_data in 'User_Data'.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% the path up to Application_Qata.
save_path = fullfile(pathname2TBMLABvers,'User_Data','Application_Data','');
% is it used??? XXXXXXX

% necessary to have at least somting as I may fisrt do a save and cancel it, so I would have never been defined
memory_file_name.name = 'Unused_File';
memory_file_name.path = save_path;

switch option

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% OPEN-LOAD
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

case 'open'

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% THE instruction to open  the file (not the folder) with the data
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	root_file_name = fullfile(pathname2TBMLABvers,'User_Data','Application_Data','');
	cd(root_file_name); % By default I open the Application_data	
	
	fprintf(1,'Report on file manipulation: open a file in directory = %s\n\n',root_file_name); 
	
	if isunix
		[fn,pathfn] = uigetfile('*','Select application data.',400, 200);
	else
		[fn,pathfn] = uigetfile('*','Select application data.');
	end

	fprintf(1,'Report on file manipulation: open file = %s\n\n',pathfn); 
	
	if fn
		% pathfn does not include the file name
		% I preserve last one if cancel now
		memory_file_name.name = fn;
		memory_file_name.path = pathfn;
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% deciding if this file is cancel, bath, obj, EVN, or other
	
	if fn  == 0 % canccel or  error
		file_type = 'cancel';	
	elseif findstr('.mat',fn)   % binary files
		if findstr('.EVN',fn)
			file_type = 'EVN';
		elseif findstr('.obj',fn)
			file_type = 'object';
		else
			file_type = 'binary';
		end
	elseif findstr('.batch',fn)
		file_type = 'batch_mode';
	else
		file_type = 'ascii';		
	end	
	memory_file_name.type = file_type;
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	switch file_type	
	
	case 'batch_mode'	
		fid = fopen([pathfn,fn],'rt'); % open as text file
		if fid == -1 
			hdw = warndlg(['I cannot open file    ',fn,'    I skip.']);
			uiwait(hdw)
		else				
			text = ['Batch mode will execute file ',fn];
			choice = text_with_n_buttons(hd_fig, text, {'OK','Cancel'}, [0 0 0 0]);
			if choice == 1
				life_menu('Save')
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% executing batch mode 
				batch_mode(fid);
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% fclose(fid) done in batch_mode
			end
		end
	
	case 'object' % a binary file
		if strcmp(open_binary_menu_used,'yes')
			hdw = warndlg('You already used the open file for objects. Not allowed. I skip.');
			uiwait(hdw)
		else
			% pathfn does not include the file name
			fid = fopen([pathfn,fn]); % fn open as binary		
			if fid == -1 
				hdw = warndlg(['I cannot open file    ',fn,'    I skip.']);
				uiwait(hdw)
			else
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				load([pathfn,fn]) % when pathfn not there, it can't find fn
				% if .mat is not in fn, load assumes it is ASCII		
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				open_binary_menu_used = 'yes';
				life_menu('Save')			
				fclose(fid);
				get_all_pin_tables			
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				% verifying entered data are adequate
				ok_objects = verifying_object_data(1);
				if ok_objects == 0
					hdw = warndlg('There are errors in your data. See the Command Window.');
					uiwait(hdw)
				end
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			end
		end
	case 'EVN' % a binary file fro EVN
		% pathfn does not include the file name
		fid = fopen([pathfn,fn]); % open as binary
		if fid == -1 
			hdw = warndlg(['I cannot open file   ',fn,'    I skip.']);
			uiwait(hdw)
		else
			load([pathfn,fn])
			fclose(fid);
		end	
		out{1} = fid;
		
	case 'binary' % the .mat files which are not EVN or obj
		% when  I come here, I don't load binary data. Used when loaded data are to be used localy
		fid = fopen([pathfn,fn]); % open as binary
		if fid == -1 
			hdw = warndlg(['I cannot open file   ',fn,'    I skip.']);
			uiwait(hdw)
			% NO LOAD done here
			% fclose(fid) to be done after the load
		end	
		out{1} = fid;
		
	case 'ascii'  % the non .mat files which are not EVN or obj
		% UNTESTED
		% when  I ome here, I don't load ??? data. Used when loaded data are to be used localy
		% when  I come here, I don't load binary data. Used when loaded data are to be used localy
		fid = fopen([pathfn,fn],'rt'); % open as text
		if fid == -1 
			hdw = warndlg(['I cannot open file   ',fn,'    I skip.']);
			uiwait(hdw)
			% NO LOAD done here
			% fclose(fid) to be done after the load
		end	
		out{1} = fid;
		
	case 'cancel'
		% error or cancel in uigetfile, just proceed
	end


	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% SAVE
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case {'save_obj','save_EVN','save_report','save_useful_object'}
	% get file name	
	if ~exist('memory_file_name') 		
		memory_file_name.path = fullfile(pathname2TBMLABvers,'User_Data','Application_Data','');
		memory_file_name.name = 'Unused_File';
	else
		if isempty(memory_file_name)
			memory_file_name.path = fullfile(pathname2TBMLABvers,'User_Data','Application_Data','');
			memory_file_name.name = 'Unused_File';
		end
	end	

	fprintf(1,'Report on file manipulation: savev in directory = %s\n\n',memory_file_name.path); 
	
	cd(memory_file_name.path); % By default I open the Application_data, else the last one	
	switch option
	case 'save_obj'
		% building name of save data
		fn = create_file_name('.obj.mat');
		% get your file name for saving data
		if isunix
			[fn,pathfn] = uiputfile(fn,'Saving object data.',400,200);
		else
			[fn,pathfn] = uiputfile(fn,'Saving object data.');
		end
		if fn == 0 % error or cancel
			% error or cancel in uigetfile
			hdw = warndlg(['Cancel or error in object save request. I skip.']);
			uiwait(hdw)		
		else
			cd(pathfn)
			save(fn,'frame','structure','mapping','attribute','variable','belief');
			memory_file_name.path = pathfn;
			memory_file_name.name = fn;
		end
	case 'save_EVN'
		% building name of save data
		fn = create_file_name('.EVN.mat');
		% get your file name for saving data
		if isunix
			[fn,pathfn] = uiputfile(fn,'Saving EVN data.',400,200);
		else
			[fn,pathfn] = uiputfile(fn,'Saving EVN data.');
		end
		% user must decide if new name
		if fn == 0 % error or cancel
			% error or cancel in uigetfile
			hdw = warndlg(['Cancel or error in EVN save request. I skip.']);
			uiwait(hdw)		
		else
			cd(pathfn)
			save(fn, 'node','link','histo','pin_node','pin_link','pin_histo')
			memory_file_name.path = pathfn;
			memory_file_name.name = fn;
		end	 
	case 'save_report'  % no save done here
		% building name of save data
		fn = create_file_name('.report');
		% get your file name for saving data
		if isunix
			[fn,pathfn] = uiputfile(fn,'Saving Report data.',400,200);
		else
			[fn,pathfn] = uiputfile(fn,'Saving Report data.');
		end
		if fn == 0 % error or cancel
			% error or cancel in uigetfile
			hdw = warndlg(['Cancel or error in Report save request. I skip.']);
			uiwait(hdw)		
		else
			cd(pathfn)
			memory_file_name.path = pathfn;
			memory_file_name.name = fn;
		end	 
	case 'save_useful_object'  % no save done here
		% building name of save data
		fn = create_file_name('.pr_obj');
		% get your file name for saving data
		if isunix
			[fn,pathfn] = uiputfile(fn,'Saving Useful Object Data.',400,200);
		else
			[fn,pathfn] = uiputfile(fn,'Saving Useful Object Data.');
		end
		if fn == 0 % error or cancel
			% error or cancel in uigetfile
			hdw = warndlg(['Cancel or error in Report save request. I skip.']);
			uiwait(hdw)		
		else
			cd(pathfn)
			memory_file_name.path = pathfn;
			memory_file_name.name = fn;
		end	 
	end

	fprintf(1,'Report on file manipulation: save file = %s\n\n',pathfn); 
	
end

delete(hd_fig)
delete(hd_help)
figure_data(ind_fig) = [];
figure(gcf_mem);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function fn = create_file_name(option)
global memory_file_name
% building name of save data. 
% Get rid of everything behind first dot
% for objet, I add .obj.mat, matlab does not add .mat
% for EVN, I add .EVN.mat,  matlab does not add .mat
% if not dot, I add .obj.mat or .EVN.mat, matlab does not add .mat
% if .mat is not there, load assumes it is ASCII, hence I put it		

fn = memory_file_name.name;
dot_pos = findstr(fn,'.');
if ~isempty(dot_pos)
	ipos = dot_pos(1)-1;
	fn = [fn(1:ipos),option];
else
	fn = [fn,option];
end	
