function get_text_for_button_pointer
% find out over which button the pointer is located
% display the corresponding help

% hd_lg_tx_fig = handle of the figure where help text will be displayed
% pos_button_in_pixels = button locations in pixel
% global long_text_help    contains the helps texts for one panel of button
% global button_num_where_pointer   memorizes on which button I was previously and will be now

% texts are in get_help_text_for_set_buttons
%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global  button_num_where_pointer  long_text_help   position_figure_for_text  
global  pos_button_in_pixels    hd_lg_tx_fig  top_position_for_text  help_level

% this global is only for communicating with dialog_button through a callback fct
% used in select_buttons or select_buttons_no_wait and get_text_for_button_pointer
% the get produces the handle of the figure on which pointer is located

% I don't waist time if not the one I am interested in

gcf_mem = gcf;

x = get(0,'PointerLocation'); % get the x-y location of pointer in pixel

pointer_on_one_button = 0;

for i = 1:size(pos_button_in_pixels,2)
	if  x(1) >= pos_button_in_pixels(1,i) & x(1) <= pos_button_in_pixels(2,i) & ...
		x(2) >= pos_button_in_pixels(3,i) & x(2) <= pos_button_in_pixels(4,i)
		%
		% pointer located over this i button
		%
		pointer_on_one_button = 1;				
		set(findobj('Userdata','button_long_helps'),'visible','on')				
		if i ~= button_num_where_pointer
			% thus I hit a new button, thus I display another text
			kmax = str2num(long_text_help{i,1});
			button_num_where_pointer = i;	
			if ishandle(hd_lg_tx_fig)	
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
				%
				% dipslaying the help text for button i (1,2,... from top to bottom)
				%
				hd_help_text = display_scrolling_text(hd_lg_tx_fig,...
				[.005 .005 .99 .93],  {long_text_help{i,2:kmax}});
				%
				%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			else % a stupidity to be here
				% once the Root Window is closed by user (should not be done) it stays off for the whole session
				help_level = 1;
			end
		end	
	end
end
if pointer_on_one_button == 0 & strcmp(get(hd_lg_tx_fig,'visible'), 'on')
	% I am NOT on a button, figure invisible (so I can read the help under it
	set(hd_lg_tx_fig,'visible','off')
end

figure(gcf_mem);
