function show_demos
% display demo text in a window (option 1)  or print it (option 2) or both (option 3).

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global gui_position width_demo_text screen_size
global CallBackData  CallBackCell MenuData pathname2TBMLABvers


return % deactivated Demos only in user guide. Boring to have to retype text twice.

clear query def_ans

query = {'Which demos do you want?',...
'Display on Matlab Command Window Y/N',...
'Display on a Demo Window Y/N',...
'Print on file Y/N'};
def_ans = {'Select in attached menu','N','Y','N'};

MenuData = [];
MenuData(1).number = 1;
j=0;
j=j+1;MenuData(1).label{j} = 'Chest Clinic Problem'; % the label to be shown
MenuData(1).clb{j}   = 'clb_param(1,1);'; % the callback function like 'fct 4' (4 is option '4')
j=j+1;MenuData(1).label{j} = 'Flight Crew Problem'; 
MenuData(1).clb{j}   = 'clb_param(1,2);';

hd = figure;
set(gcf,'position',[50 250 500 500]);
[answer,choice] = dialog_queries(hd,'Demos Request',query,def_ans,[.05 .05],MenuData,2,[],[],[],[]);
delete(hd)

if choice == 2
	return
end

demo_number = find(strcmp(answer{1},MenuData(1).label));

if isempty(demo_number)
	hdw = warndlg('Select the demo with the pull down menu attached to the button. I cancel.');
	uiwait(hdw);
	return
end

text = demos(demo_number); % get the text

if strcmp(upper(answer{2}),'Y') % matlab command window, unwrapped
	fprintf(1,'\n\n%s\n\n','XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
	fprintf(1,'%s\n\n ','BEGIN OF DEMO TEXT');
	for i = 1:length(text)
		fprintf(1,'%s\n',  text{i});
	end
	fprintf(1,'\n%s\n\n','END OF DEMO TEXT');
	fprintf(1,'%s\n\n','XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
end

% Demo Window
if strcmp(upper(answer{3}),'Y')
	
	pos = gui_position(:,1); 
	pos(2) = pos(2) - 30; % so I can see it
	pos(3) = width_demo_text; % a little wider
	hd = figure;
	set(hd,'position',pos,'name','Demo Window. Independant from TBM. Close button active.',...
	'Resize','on','CloseRequestFcn','closereq');
	
	% I do it as in display_scrolling_text but here as I need the wrapped text t for print
	hand = uicontrol('Parent',hd,...
	'Position',[.005 .005 .99 .99],...
	'Style','listbox',...
	'Max',1000,'Min',0);
	t = protected_textwrap(hand,text);
	set(hand,'String',t); 
	
	hdw = warndlg(['The Demos text is on a scrolling window you can move and resize at will. ',...
	'Window width is an adaptable GUI parameter. ',...
	'The window is NOT close by TBM so you can keep it while excecuting its orders. ',...
	'To close the window, select it and select ist close button']);
	uiwait(hdw);
end 

% printer  maybe problem with UInix!!!!
if strcmp(upper(answer{4}),'Y')	
	add_saved_file = fullfile(pathname2TBMLABvers,'User_Data','TBM_demos_printed.txt');
	fid = fopen(add_saved_file,'wt');
	for i = 1:length(text)			
		fprintf(fid,'%s\n',text{i});
	end	
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp(' ')
	disp('Your text has been saved on a file called TBM_demos_printed.txt in folder TBMLAB/User_Data.')
	disp('You can read it with any (?) word processor.')
	disp(' ')	
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
end

% pour plutard XXXXX
