function clb_node(i,j)
% call back from draw_network attached to node
% created in picto_with_text_and_menu
% i = 1, j = the index of the node 
% i = 2, j = the option number for uicontextmenu
% entered whenever I hit the figure

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags flagstr need_uiresume node pin_node belief flags3 hd_smallUL_Button_EVN light_green

% at input
% flags(1) tells if I am coming from the uiwait or the waitforbuttonpress
% flags(1) = 1 : in case uiwait I need uiresume, 
% flags(1) = 0 : in case waitforbuttonpress, I may not have uiresume

% In the figure: 		'WindowButtonDownFcn',	'clb_node(0,0)'
% in the node (patch):	'ButtonDownFcn',		['clb_node(1,',num2str(i_obj),')'],
% in the node.uimenu:  	'Callback', 			'clb_node(2,5)'
% see preparing_networks_figure for the first, 
% and picto_with_text_and_menu for the other two's.

% the nodes uimenu produce the initial data in the nodes, not what comes after propagation
% these are stored in other belief objects

if i == 0;
	flags(1) = 0;
	flagstr = 'Wrong_place';
elseif i == 1 % node itself
	flags(1) = j; 
	flagstr = 'Move_node';
else 
	% flags built in picto_with_text_and_menu using j = 5*i_obj + 1 to 5
	%  flags(1) = i_obj = the object on which I am
	flags(1) = floor(j/5) ;
	i_obj = flags(1);
	flags(2) = j - 5*flags(1); % flags(2) = the choosen menu
	flagstr = 'Menu_node'; % handle here
	gcf_mem = gcf;
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% 	% help area to understand handles. To be kept for future understanding	
	% 	fprintf(1,'ind  label   node.hdm   \n ',[]);
	% 	for i = 1:length(node)
	% 		% node(i).label =  the lable of this node
	% 		fprintf(1,'%3i  %s \n', [i node(i).label])
	% 		[node(i).hd_menu  ]
	% 		% fprintf(1,'%3i %g %s\n',[i node(i).hd_menu node(i).label  ]); 
	% 		% what I had saved in node
	% 	end
	% 	fprintf(1,'\nSeleted object handle %g\n\n',[gco]); % the menu I select
	% 	hd_axes = get(gco,'parent');  % this is the axes handle in figure gcf
	% 	hd_axes_children = get(hd_axes,'children');	
	% 	
	% 	fprintf(1,'    ind     hd_ax_ch   hd_cntm  hd_cntxm_ch\n',[]);
	% 	for j = 1:length(hd_axes_children)
	% 		hd_cntx_menu = get(hd_axes_children(j),'uicontextmenu');
	% 		hd_cntx_menu_ch = get(hd_cntx_menu,'children');
	% 		[j hd_axes_children(j) hd_cntx_menu  hd_cntx_menu_ch']
	% 		% fprintf(1,'%3i %10.4f %10.4f %10.4f %10.4f\n',[j hd_axes_children(j) hd_cntx_menu  hd_cntx_menu_ch']);
	% 		% gco is hd_axes_children(j) which hd_cntx_menu is saved in node().hd_menu	
	% 	end
	% 	% end help area
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% 	% getting the index i_obj of the object selected = node(i_obj).
	% 	hd_axes = get(gco,'parent'); % the axes handle of gco
	% 	hd_axes_children = get(hd_axes,'children'); % the handle of the childre of this axes
	% 	i_obj = find([hd_axes_children]==gco) ; % the index of the children uicontrrol I select
	% 	hd_obj = get(hd_axes_children(i_obj),'uicontextmenu');
	% 	i_obj = find([node(:).hd_menu]==hd_obj);
	% 	% I have select menu flags(2) = 1 or 2 of node(i_obj)
	
	% 	case 1 % Show Bel,BetP,Pl   doable only on variable nodes, not on belief
	% to be added, selecting several variable to get the joint
	
	switch node(i_obj).nature
	
	case 'belief'% Editing mass doable only on belief object, not on variable
		% only masses, weights can be changed in this context, more important changes only in editor
		
		bel_ind = pin_manipulation('belief','num2ind',node(i_obj).obj_num);
		if length(belief(bel_ind).bp) == 1
			bp_ind = 1;
		else
			% I must find out which bp you want
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% listing the potentials: bel is fixed as input is bel for belief(index)
			% ONE potential per conditioning element
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			nbrbp = length(belief(bel_ind).bp);
			% building the full name for this belief potential with its possible forms
			for i = 1:nbrbp
				nbr_forms(i) = length(belief(bel_ind).bp(i).form);
				typ = ' ';
				for j = 1:nbr_forms(i)
					typ = [typ,' ',belief(bel_ind).bp(i).form(j).type];  
				end	
				belief(bel_ind).bp(i).number = i;	
				belief(bel_ind).bp(i).full_name = ['bp',num2str(i), typ];
			end
			[index_fig, hd_fig] = handling_all_figures('put_in_front',{'Alternate General Window'});
			bp_handle_fig  = hd_fig(1);
			namefig = ['Potential Control for belief ',num2str(belief(bel_ind).full_name)];
			% there is a clash as next uses also flags, hence memoruzing it 
			flags_mem = flags;
			[bp_ind] = select_bp(bel_ind);		
			flags = flags_mem;
			delete(bp_handle_fig)			
		end
		% full name is like 'bp9 m BetP q', 9 is the number of the potential, 
		% followed by the list of forms
		% this index of bp (9) appears once we have conditional, 
		% and 9 is the elements number in the conditioning_domain
		% with marginal only, always only 1 bp
		% when conditioning will show up, the n umber should be replaced by the condition XXX
		
		switch flags(2)
		case 1 % Edit Selected Masses. No C/I
			[index_fig, hd_fig] = handling_all_figures('put_in_front',{'Alternate General Window'});
			bp_handle_fig  = hd_fig(1);
			% XX to be modified one day XX
			
			% once you select this option, you MUST propagate again. 
			% In fact it assumes some foset/bbm has changed			
			[ind_for] = edit_one_bp(bel_ind,bp_ind);
			
			flags3 = 2; % to tell to calling function that propagation is to be redone			
		case 2 % Show Bel, BetP, Pl
			% fincding the form that is m
			form_ind = min (find(strcmp({belief(bel_ind).bp(bp_ind).form(:).type}, 'm')));
			if isempty(form_ind)
				% no m form I build it
				[computed_forms,uncomputed_forms, error_mode] = transform_bp(bel_ind,bp_ind,{'m'});
				form_ind = find(strcmp({belief(bel_ind).bp(bp_ind).form(:).type}, 'm'));
			end
			results_display(bel_ind,bp_ind,form_ind)		
		case 3 % Show list bbm
			showing_bp_selected(bel_ind,bp_ind,0);
		case 4 % Show Belief Editor
			flags3 = 1; % to forbid change
			run_belief_potential(bel_ind)
			flags3 = 0;
		end
	
	case 'variable'
		if ~isfield(node,'betp_localization')		
			text = 'You MUST first use the propagate menu. I skip.';
			choice = text_with_n_buttons(gcf, text, {'Skip'}, [0 0 0 0]);
% 			return			
		else
			bel_ind = node(i_obj).betp_localization(1);
			bp_ind = node(i_obj).betp_localization(2);
			form_ind_betp = node(i_obj).betp_localization(3);
			bel_num = node(i_obj).betp_localization(4);
			form_ind_m = find_in_str({belief(bel_ind).bp(bp_ind).form(:).type},'m');
			if isempty(form_ind_m)
				text = 'You MUST first use the propagate menu. I skip.';
				choice = text_with_n_buttons(gcf, text, {'Skip'}, [0 0 0 0]);
% 				return			
			else			
				switch flags(2)
				case 1
					results_display(bel_ind,bp_ind,form_ind_m);
					which_menu_EVN('Propagate');	
				case 2 % Show list bbm
					showing_bp_selected(bel_ind,bp_ind,0);
				case 3 % Show Belief Editor
					flags3 = 1; % not editable
					run_belief_potential(bel_ind)
					flags3 = 0;
				end
			end
		end
	end

	figure(gcf_mem)			
	if strcmp(get(hd_smallUL_Button_EVN(2),'String'),'Menus Off')
		switch computer
		case 'MAC2'
			hdw = warndlg(['Click on the red buton, it becomes green. ',...
			'Then You must redo the propagation if data have been modified.']);
		otherwise
			hdw = warndlg(['Right Click on the red buton, it becomes green. ',...
			'Then You must redo the propagation if data have been modified.']);
		end
		uiwait(hdw)
		life_menu('Propagate')
	else
		hdw = warndlg('You must redo the propagation if data have been modified.');
		uiwait(hdw)	
		life_menu('Propagate')
	end
end

if 	need_uiresume | flags3 == 2
	uiresume
end
