function move_node_fcn(plot_limits_initial,plot_limits_now,pos_axes,past_obj_to_move)
% the 'Move_node' case in the move node around case

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags flagstr node link

% we move a node

% we change it scolor in light blue if it was white
obj_to_move = flags(1);

% for dragging an icone from here to there
% the mouse is on a shape, dragging a fake rectangle and when button off
% end_pos is new position (where icone dropped)					
cur_pt = get(gcf,'CurrentPoint'); % button down position in figure units	

[end_pos] = dragrect  ([cur_pt(1,1) cur_pt(1,2) 10 10]);

% rescaling into original scale, data end_pos are in pixel based on screen as now
cfx = (plot_limits_now(2)-plot_limits_now(1))/(plot_limits_initial(2)-plot_limits_initial(1));
cfy = (plot_limits_now(4)-plot_limits_now(3))/(plot_limits_initial(4)-plot_limits_initial(3));
cur_pt = [plot_limits_now(1)+cur_pt(1,1)*cfx plot_limits_now(3)+cur_pt(1,2)*cfy];
end_pos(1) = plot_limits_now(1)+end_pos(1)*cfx;  
end_pos(2) = plot_limits_now(3)+end_pos(2)*cfy;  

% small moves are prohibited to avoid nodes shifting wnenever just selected
if sqrt((end_pos(1) - cur_pt(1,1))^2 + (end_pos(2) - cur_pt(1,2))^2) > 10
	% hence move large enough
	% the radius of the circle = 13 with Mac
	node(obj_to_move).center = [end_pos(1)-pos_axes(1) end_pos(2)-pos_axes(2)];
	
	% update node and color is white
	delete(node(obj_to_move).hd_picto);
	picto_with_text_and_menu(obj_to_move,'k','w');
	
	% update links fixed to that node
	for k = [node(obj_to_move).link]
		delete(link(k).hd_line);							
		link(k).hd_line = plot_line(k,'k');
	end

else 
	switch node(obj_to_move).nature
	case 'variable'
		color_bckgr_now = [.7 .7 .7];
	case 'belief'
		color_bckgr_now = [1 0.7 0.7];
	end
	set(node(obj_to_move).hd_picto(2),'FaceColor',color_bckgr_now);
	% I reset node color as it became selected but I did not move it
end	
