function hd_histo = plot_histo(ind_histo,hd_fig)
% just plotting one histo for betp
% completely parametrized by its center
% so when moved, all we do is change the centers, and rerun me

%
%   Version : Dec 7,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global node pin_node link pin_link  need_uiresume flags flagstr scaling_coef
global hd_smallUL_Button_EVN light_green light_red plot_limits_initial  plot_limits_now 
global histo pin_histo

% beware some of these parameters in draw_histo_betp
h_element = 15;
w_element = 15;
w_histo = 35;
skipv = 5; % skip between titel and histo
skipv_bar = 2; % a little vertical shift to put the bar in the middle of the text
skipv_hbox = 1; % a little vertical shift so upper line of percentiles boxes overlap bottom line of title
w_char = 5; % width for one character

h_fr_histo = histo(ind_histo).height_fr_histo;
w_element = histo(ind_histo).width_element;
i_node = histo(ind_histo).node_ind;
w_fr_histo = w_element + w_histo + 2;

xy = histo(ind_histo).center;
pos_frame = [xy(1)-w_fr_histo/2 xy(2)-h_fr_histo/2-1  w_fr_histo   h_fr_histo+1];
pos_title = [pos_frame(1) pos_frame(2)+pos_frame(4)-h_element   pos_frame(3)  h_element+4];

ik = 0;

ik = ik + 1; % external frame
hd_histo(ik) = uicontrol(hd_fig,...
'units','pixel',...
'style','frame',...
'userdata','betp_plot',...
'position',pos_frame);

% memorize to find out above which one is my pointer
histo(ind_histo).frame_pos = pos_frame;

ik = ik + 1; % title frame
hd_histo(ik) = uicontrol(hd_fig,...
'units','pixel',...
'style','frame',...
'userdata','betp_plot',...
'position',pos_title);	

ik = ik + 1; % title text
hd_histo(ik) = uicontrol(hd_fig,...
'units','pixel',...
'style','text',...
'backgroundColor',[.4 1 1],...
'string',histo(ind_histo).title_text,...
'userdata','betp_plot',...
'position',pos_title + [2  2 -4 -4]);	

pos_betp(1) = pos_frame(1) + w_element + 2;
pos_betp(4) = .5*h_element;
pos_frh = [pos_betp(1) pos_frame(2) w_histo/4 pos_title(2)-pos_frame(2)+skipv_hbox];
pos_frh2 = [pos_betp(1)+w_histo/2 pos_frame(2) w_histo/4 pos_title(2)-pos_frame(2)+skipv_hbox];		

ik = ik + 1; % frame for histo 0-25%
hd_histo(ik) = uicontrol(hd_fig,...
'units','pixel',...
'style','frame',...
'fontweight','light',...
'userdata','betp_plot',...
'position',pos_frh);	

ik = ik + 1; % frame for histo 50-75%
hd_histo(ik) = uicontrol(hd_fig,...
'units','pixel',...
'style','frame',...
'fontweight','light',...
'userdata','betp_plot',...
'position',pos_frh2);	

pos_elem = [pos_frame(1)+2  pos_title(2)-skipv  w_element  h_element];

for i_elem = 1:histo(ind_histo).cardinal
	
	pos_elem(2) = pos_elem(2) - h_element;
	pos_betp(2) = pos_elem(2) + h_element/2 - pos_betp(4)/2 + skipv_bar;
	pos_betp(3) = histo(ind_histo).betp(i_elem)*w_histo;
	
	ik = ik + 1; % values list
	hd_histo(ik) = uicontrol(hd_fig,...
	'units','pixel',...
	'style','text',...
	'string',histo(ind_histo).elements(i_elem,:),...
	'userdata','betp_plot',...
	'position',pos_elem);
	
	if pos_betp(3)
		ik = ik + 1; % BetP as a colored frame	
		hd_histo(ik) = uicontrol(hd_fig,...
		'style','frame',...
		'units','pixel',...
		'userdata','betp_plot',...
		'backgroundcolor',[1 .4 .8],...
		'position',pos_betp);	
	end	
end
