function hd_line = plot_line(i_obj,line_color)

% drawing a line between two nodes 
% tip = arrows, hidden later XXX

% tip is the kind of tip asked for, normaly just an arrow entering n2


%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global node link

n = link(i_obj).nodes;
index1 = find([node(:).number] == n(1));
index2 = find([node(:).number] == n(2));

x1 = node(index1).center(1) ;
y1 = node(index1).center(2) ;
x2 = node(index2).center(1) ;
y2 = node(index2).center(2) ;

limits = [  x1  x2  ;  y1  y2  ] ;
% limits = [  x1  x2  ;  y1  y2  ] is now the center of the 2 objects
% it will become the start and end of the line between the 2 objects

alpha = atan2( y2 - y1 , x2 - x1 ); % the angle of the line to plot from n(1) to n(2)
alpha_mem = alpha;

i_case = 0;
for index = [index1 index2]
	% for the two extremities
	i_case = i_case + 1;
	
	% atan2(dy,dx) in -pi +pi
	
	x0 = node(index).center(1);
	y0 = node(index).center(2);	
	% the enter of the now node
	
	switch node(index).shape
	
	case 'circle'
		radius = (node(index).localization(4) - node(index).localization(3))/2;
		limits(1,i_case) = limits(1,i_case) + cos(alpha)*radius;
		limits(2,i_case) = limits(2,i_case) + sin(alpha)*radius;
		if alpha > 0 & alpha < pi
			alpha = alpha - pi;
		elseif alpha < 0 & alpha > -pi
			alpha = alpha + pi;
		end
	
	case 'oval'
		radius = (node(index).localization(4) - node(index).localization(3))/2;
		x_min = node(index).localization(1) + radius;
		x_max = node(index).localization(2) - radius;
		y_min = node(index).localization(3);
		y_max = node(index).localization(4);
		
		
		if alpha > 0 & alpha < pi
			% case above in (0 - pi) 
			x = x0 + (y_max - y0) / tan(alpha);		
			if x >= x_min & x <= x_max
				% cross upper border
				limits(1,i_case) = x;
				limits(2,i_case) = y_max;
			elseif x >= x_max
				% too much at right
				limits(1,i_case) = x_max + cos(alpha)*radius;
				limits(2,i_case) = y0 + sin(alpha)*radius;	
			else
				% too much at left 
				limits(1,i_case) = x_min + cos(alpha)*radius;
				limits(2,i_case) = y0 + sin(alpha)*radius;	
			end
			alpha = alpha - pi; % switching alpha for second node
		elseif alpha < 0 & alpha > -pi
			% cased below in (pi 2pi)
			x = x0 + (y_min - y0) / tan(alpha);		
			if x >= x_min & x <= x_max
				% cross lower border
				limits(1,i_case) = x;
				limits(2,i_case) = y_min;
			elseif x >= x_max
				% too much at right
				limits(1,i_case) = x_max + cos(alpha)*radius;
				limits(2,i_case) = y0 + sin(alpha)*radius;	
			else
				% too much at left 
				limits(1,i_case) = x_min + cos(alpha)*radius;
				limits(2,i_case) = y0 + sin(alpha)*radius;		
			end
			alpha = alpha + pi;  % switching alpha for second node
		else 
			% the case alpha = 0	or    pi
			if i_case == 1
				if x1  < x2
					limits(1,i_case) = node(index).localization(2);
				else
					limits(1,i_case) = node(index).localization(1);
				end
			else
				if x1  < x2
					limits(1,i_case) = node(index).localization(1);
				else
					limits(1,i_case) = node(index).localization(2);
				end
			end
			limits(2,i_case) = y0;
		end % if alpha
	
		% drawing the arrow at second end
		
	case 'rectangle'
		x_min = node(index).localization(1);
		x_max = node(index).localization(2);
		y_min = node(index).localization(3);
		y_max = node(index).localization(4);
		
		if alpha > 0 & alpha < pi
			% case above in (0 - pi) 
			x = x0 + (y_max - y0) / tan(alpha);		
			if x >= x_min & x <= x_max
				% cross upper border
				limits(1,i_case) = x;
				limits(2,i_case) = y_max;
			elseif x >= x_max
				% too much at right
				limits(1,i_case) = x_max;
				limits(2,i_case) = y0;	
			else
				% too much at left 
				limits(1,i_case) = x_min;
				limits(2,i_case) = y0;	
			end
			alpha = alpha - pi; % switching alpha for second node
		elseif alpha < 0 & alpha > -pi
			% cased below in (pi 2pi)
			x = x0 + (y_min - y0) / tan(alpha);		
			if x >= x_min & x <= x_max
				% cross lower border
				limits(1,i_case) = x;
				limits(2,i_case) = y_min;
			elseif x >= x_max
				% too much at right
				limits(1,i_case) = x_max;
				limits(2,i_case) = y0;	
			else
				% too much at left 
				limits(1,i_case) = x_min;
				limits(2,i_case) = y0;		
			end
			alpha = alpha + pi;  % switching alpha for second node
		else 
			% the case alpha = 0	or    pi
			if i_case == 1
				if x1  < x2
					limits(1,i_case) = node(index).localization(2);
				else
					limits(1,i_case) = node(index).localization(1);
				end
			else
				if x1  < x2
					limits(1,i_case) = node(index).localization(1);
				else
					limits(1,i_case) = node(index).localization(2);
				end
			end
			limits(2,i_case) = y0;
		end % if alpha
	
		% drawing the arrow at second end
		
	case 'long_hexagon'

		y_min = node(index).localization(3);
		y_max = node(index).localization(4);	
		sh_rect = (y_max-y_min)/4; % the length of the base of the hexagonal point
		sh_rect2 = 2*sh_rect;
		x_min = node(index).localization(1) + sh_rect;
		x_max = node(index).localization(2) - sh_rect;
		
		dx =  (x_max - x_min + sh_rect2 ) / (2+abs(tan(alpha)));
		dy = dx * tan(alpha);
		dx = abs(dx) - (x_max - x_min)/2;
				
		if alpha > 0 & alpha < pi
			% case above in (0 - pi) 
			x = x0 + (y_max - y0) / tan(alpha);		
			
			if x >= x_min & x <= x_max
				% cross upper border
				limits(1,i_case) = x;
				limits(2,i_case) = y_max;
			elseif x >= x_max
				% too much at right
				limits(1,i_case) = x_max + dx;
				limits(2,i_case) = y0 + dy;	
			else
				% too much at left 
				limits(1,i_case) = x_min - dx;
				limits(2,i_case) = y0 - dy;	
			end
			alpha = alpha - pi; % switching alpha for second node
		elseif alpha < 0 & alpha > -pi			
			% case below in (pi 2pi)
			x = x0 + (y_min - y0) / tan(alpha);		
			if x >= x_min & x <= x_max
				% cross lower border
				limits(1,i_case) = x;
				limits(2,i_case) = y_min;
			elseif x >= x_max
				% too much at right
				limits(1,i_case) = x_max + dx;
				limits(2,i_case) = y0 + dy;	
			else
				% too much at left 
				limits(1,i_case) = x_min - dx;
				limits(2,i_case) = y0 - dy;		
			end
			alpha = alpha + pi;  % switching alpha for second node
		else 		
			% the case alpha = 0	or    pi
			if i_case == 1
				if x1  < x2
					limits(1,i_case) = node(index).localization(2);
				else
					limits(1,i_case) = node(index).localization(1);
				end
			else
				if x1  < x2
					limits(1,i_case) = node(index).localization(1);
				else
					limits(1,i_case) = node(index).localization(2);
				end
			end
			limits(2,i_case) = y0;
		end % if alpha		
		% drawing the arrow at second end 
	end
end
if link(i_obj).tip == 0
	hd_line = plot(limits(1,:), limits(2,:),'k','Userdata','EVN_plot') ;		
else % case with arrow
	hd_line(1) = plot(limits(1,:), limits(2,:),'k','Userdata','EVN_plot') ;		
 	hd_line(2) = curly_arrow(limits(1,2), limits(2,2),alpha_mem,'k');
end
