function [choice,sel_items_ind] = list_object_for_EVN(option,hd_fig)
% list in the figure for EVN the belief or variable object 
% choice = 1, OK, = 2 cancel operation
% sel_items_ind = list index of selected belief/variable

%
%   Version : Dec 13,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% option can be belief or variable
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

switch option

% we create an extra object just to get Build NEW ... in the list of selectable objects
case 'belief'
	object = belief;
	text = ['Select the belief objects, then Done. To load EVN, just select EVN and go to File menu.'];
	% we list the available obejcts 
	% % % % index_new = nx_pin(2);
	hd_bel = listing_existing(option, [.005 .005 .15 .99], hd_fig,[]);
	set(hd_bel(2),'enable','on')
	set(hd_bel(2),'max',1000,'value',[])
	choice = text_with_n_buttons(hd_fig,text, {'Done','EVN','Cancel'},[0 0]);
case 'variable'
	object = variable;
	text = ['Select the variable objects, then Done'];
	% we list the available obejcts 
	% % % % index_new = nx_pin(2);
	hd_bel = listing_existing(option, [.005 .005 .15 .99], hd_fig,[]);
	set(hd_bel(2),'enable','on')
	set(hd_bel(2),'max',1000,'value',[])
	choice = text_with_n_buttons(hd_fig,text, {'Done','Cancel'},[0 0]);
end


% I have the list of selected objects
if choice == 1
	sel_items_ind = pin_manipulation(option,'pos2ind',get(hd_bel(2),'value'));
else
	sel_items_ind = 0;
end

delete(hd_bel)
figure(hd_fig)
