function exit_choice = new_node_for_variables(list_var_ind)
% building one/several variable nodes, dropping at left. 

% No links as they are not yet in any belief object up to now
% I can display a belief only once all its variables are plotted, 
% hence, adding var = var not in the belief displayed
% list_var_ind = the index of the selected variable objects that must be plotted

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global root_file_name save_path file_name_begin
global node pin_node link pin_link  need_uiresume flags flagstr scaling_coef

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Note on families
%
% how works children parents data (where we store node numbers)
% for a belief node: 
%		children = list of node number that refer to a var in domain of bel
%		parents  = list of node number that refer to a var in condit of bel
% for a variable node: 
%		children = list of node number that refer to a bel where I belong to condit 
%		parents  = list of node number that refer to a bel where I belong to domain 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% a nice blue color for a selected node
sel_col = [0.5 1 1];

% position are the axes
pos_axes = get(gca,'position');
% position for dropping the belief node
pos = [50 .9*pos_axes(4)];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the variable node
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

exit_choice = 0;
if length(list_var_ind) == 0
	% how comes, you ask for nothing
	% 	choice = text_with_n_buttons(gcf,'List of requested variables is empty. I skip.',{'OK'}, [0,0]);
else

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% for every requested variable
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	new_pin = get_next_pin('node');
	
	kn = new_pin(2) - 1;
	nbr = new_pin(3) - 1;
	pin_pos = new_pin(1) - 1;
	
	for i = 1:length(list_var_ind)	% for every var
		
		if length(node)			
			% check if some varibales are not yet represented by an exisitng node
			% node_ind = ind of the variable node (if exist) which represents var num = list_var_num(i)
			node_ind = find(strcmp({node(:).nature},'variable') & ...
			ismember([node(:).obj_num],pin_manipulation('variable','ind2num',list_var_ind(i))));
			
			% 			if length(node_ind) > 1
			% 				choice = text_with_n_buttons(gcf,'Requested variable more than once. Correct your objects. I skip.',{'OK'}, [0,0]);
			% 				% 2+ nodes refer to the same variable, forbidden
			% 			end
			if length(node_ind) 
				new_var(i) = 0; % already plotted, so I don't add a new_var
			else
				new_var(i) = 1; % it is an unplotted var, I'll plot it
			end
		else
			new_var(i) = 1; % it is an unplotted var, I'll plot it
		end
	
% % % % % % 		if new_var(i) == 1 & list_var_ind(i) == length(variable)
% % % % % % 			% I select   get new var 
% % % % % % 			% go to create var cad propo and 4-panel
% % % % % % 			choice = text_with_n_buttons(gcf, 'Build new variable with Variable Editor or with Proposition Short Cut', ...
% % % % % % 			{'Var Ed','Propo','Cancel'}, [0,0]);
% % % % % % 			switch choice
% % % % % % 			case 1  % Var editor
% % % % % % 				% 
% % % % % % 			case 2 % propositions
% % % % % % 				%
% % % % % % 			case 3 % cancel
% % % % % % 				new_var(i) = 0; 
% % % % % % 			end
% % % % % % 		
% % % % % % 		end
	
		if new_var(i) == 1
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%
			% var exists but not yet plotted in network, create a var node for it
			%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
						
			kn = kn + 1;
			nbr = nbr + 1;
			pin_pos = pin_pos + 1;
			
			nbr_var_node = nbr; 
			ind_var_node = kn;
			
			var_ind = list_var_ind(i);
			
			expr = variable(var_ind).short_name;
			expr(findstr('_',expr)) = ' ';
			
			pos(2) = pos(2) -30;
			
			node(kn).number = nbr;
			node(kn).label = expr; 			
			node(kn).children = []; % number of (belief) nodes where condit refers to me 
			node(kn).parents = [];  % number of (belief) nodes where domain refers to me 
			node(kn).center = pos;
			node(kn).center_initial = pos;
			node(kn).nature = 'variable';
			node(kn).shape = 'oval';
			node(kn).obj_num = variable(var_ind).number; % the number of the variable I represent
			node(kn).link = [];	
			
			% update pin_node
			pin_node = [pin_node ; [pin_pos kn nbr]];
			
			% draw the new variable node
			picto_with_text_and_menu(kn,'k',sel_col);
			
		end % the variable node is found or built
	
	end	% for each variable		

end

exit_choice = max(new_var);

