function [hd_fig,hd_axes,hd_menu] = preparing_networks_figure(my_title)
% prepare the window where the networks can be diaplyed

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global node link pin_node pin_link
global hd_smallUL_Button_EVN light_green light_red
global pull_down_menu  screen_size
global Which_Courier   figure_data  help_label   help_level

% for each menu, when using back_to_menu, 
% pull_down_menu(i).label
% pull_down_menu(i).status = 1 for on or 0 for off

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% full screen size figure with name and menus
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

shift = 5;

switch computer
case 'MAC2'
	position_fig = [shift shift screen_size(3)-2*shift screen_size(4)-2*shift];
	position_axes = position_fig + [0 0 -10 -70]; 
case 'PCWIN'
	position_fig = [shift shift+45 screen_size(3)-2*shift screen_size(4)-2*shift-65];
	position_axes = position_fig + [0 -40 -10 +20]; 
otherwise
	position_fig = [shift shift+45 screen_size(3)-2*shift screen_size(4)-2*shift-65];
	position_axes = position_fig + [0 -40 -10 +20]; 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure(...
'Units','pixel',...
'name',my_title,...
'color',[.8 .8 .8],...
'WindowButtonDownFcn','clb_node(0,0)',...
'MenuBar','none',...
'userdata','figure_EVN');
set(gcf,'position',position_fig); 
% clb_node used to cycle while clicking outside node icons;

ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = my_title;
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = position_fig;

% % % % % 
% % % % % hd_fig = figure('Units','pixel',...
% % % % % 'Position',position_fig,...
% % % % % 'name',my_title,...
% % % % % 'color',[.8 .8 .8],...
% % % % % 'WindowButtonDownFcn','clb_node(0,0)',...
% % % % % 'MenuBar','none',...
% % % % % 'userdata','figure_EVN'); 
% % % % % % clb_node used to cycle while clicking outside node icons;

ik = 0;

% File options (load EVN, save EVN, save objets, clear EVN, quit EVN session 
ik=ik+1;hd_menu(ik) = uimenu('Label','File'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'File';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'root';

hd1 = hd_menu(ik);
ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Load EVN','CallBack','clb_tree(4,1);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Load EVN';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'File';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Save EVN','CallBack','clb_tree(4,2);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Save EVN';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'File';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Save Objects','CallBack','clb_tree(4,3);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Save Objects';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'File';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Print EVN','CallBack','clb_tree(3,6);uiresume','Userdata','ntw_menu');
set(hd_menu(ik),'Separator','on')
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Print EVN';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'File';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Clear EVN','CallBack','clb_tree(4,4);uiresume','Userdata','ntw_menu');
set(hd_menu(ik),'Separator','on')
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Clear EVN';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'File';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Quit EVN','CallBack','clb_tree(3,4);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Quit EVN';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'File';

% Bel_Var options
ik=ik+1;hd_menu(ik) = uimenu('Label','Objects'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Objects';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'root';

hd0 = hd_menu(ik);
ik=ik+1;hd_menu(ik) = uimenu(hd0,'Label','Get Belief','Userdata','ntw_menu','CallBack','clb_tree(1,1);uiresume');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Get Belief';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'Objects';

ik=ik+1;hd_menu(ik) = uimenu(hd0,'Label','Get Variable','Userdata','ntw_menu','CallBack','clb_tree(1,2);uiresume');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Get Variable';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'Objects';

ik=ik+1;hd_menu(ik) = uimenu(hd0,'Label','New Propositions','Userdata','ntw_menu','CallBack','clb_tree(1,3);uiresume');
set(hd_menu(ik),'Separator','on')
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'New Propositions';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'Objects';

ik=ik+1;hd_menu(ik) = uimenu(hd0,'Label','New Variables','Userdata','ntw_menu','CallBack','clb_tree(1,4);uiresume');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'New Variables';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'Objects';

ik=ik+1;hd_menu(ik) = uimenu(hd0,'Label','New Belief','Userdata','ntw_menu','CallBack','clb_tree(1,5);uiresume');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'New Belief';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'Objects';

% View options
ik=ik+1;hd_menu(ik) = uimenu('Label','View'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'View';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'root';

hd1 = hd_menu(ik);
ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Initial scale','CallBack','clb_tree(2,1);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Initial scale';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','EVN at center','CallBack','clb_tree(2,11);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'EVN at center';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Better Graph','CallBack','clb_tree(2,8);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Better Graph';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Full Network','CallBack','clb_tree(2,2);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Full Network';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Re Center','CallBack','clb_tree(2,3);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Re Center';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Zoom in','CallBack','clb_tree(2,4);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Zoom in';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Zoom out','CallBack','clb_tree(2,5);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Zoom out';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Move histo','CallBack','clb_tree(2,6);uiresume','Userdata','ntw_menu');
set(hd_menu(ik),'Separator','on')
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Move histo';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','MultiVar bel NA','CallBack','clb_tree(2,7);uiresume','Userdata','ntw_menu');
set(hd_menu(ik),'Separator','on')
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'MultiVar bel';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'View';

% control options
ik=ik+1;hd_menu(ik) = uimenu('Label','EVN Control'); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'EVN Control';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'root';

hd1 = hd_menu(ik);
ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Propagate','CallBack','clb_tree(3,1);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Propagate';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'EVN Control';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Display BetP','CallBack','clb_tree(3,2);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Display BetP';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'EVN Control';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Relocate BetP','CallBack','clb_tree(3,5);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Relocate BetP';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'EVN Control';

ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Display Network','CallBack','clb_tree(3,3);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Display Network';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'EVN Control';

% help options

ik=ik+1;hd_menu(ik) = uimenu('Label',help_label); 
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Help';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'root';

hd1 = hd_menu(ik);
ik=ik+1;hd_menu(ik) = uimenu(hd1,'Label','Show','CallBack','clb_tree(2,9);uiresume','Userdata','ntw_menu');
ind = length(pull_down_menu) + 1;
pull_down_menu(ind).label = 'Show';
pull_down_menu(ind).status = 1;
pull_down_menu(ind).hd = hd_menu(ik);
pull_down_menu(ind).fig_parent = 'EVN figure';
pull_down_menu(ind).father = 'Help';

% all menus are built

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building full size axes: 
% In order to avoid text to go over other axes, I must have only one axes, hen ce the menus.
% zoom will be based on the zoom functions
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_axes = axes('parent',hd_fig,...
'Box','on',...
'Units','pixel',...
'position',position_axes,...
'DataAspectRatioMode','manual',...
'DataAspectRatio',[1 1 1],...
'PlotBoxAspectRatioMode','manual',...
'PlotBoxAspectRatio',[1 1 1],...
'Xlim',[0 position_axes(3)],...
'Ylim',[0 position_axes(4)],...
'XlimMode','manual',...
'YlimMode','manual',...
'XTickMode','manual',...
'YTickMode','manual',...
'ZTickMode','manual',...
'XTick',[],...
'YTick',[],...
'ZTick',[],...
'XTickLabelMode','manual',...
'YTickLabelMode','manual',...
'ZTickLabelMode','manual',...
'XTickLabel',{},...
'YTickLabel',{},...
'ZTickLabel',{},...
'FontName',Which_Courier,...
'TickDirMode','manual',...
'TickDir','out',...
'TickLength',[0 0],...
'userdata','axes_EVN'...
);

hold on
grid off

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% at upper left I put a box with back to EVN menu, used to quit the loop on the nodes
% if green I am in menu, if red I am in figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% sequence green, selection menu on, selection menu off (and click on me to get them)

pos_axes = get(hd_axes,'position');

light_green = [.7 1 .7];
light_red   = [1 .5 .5]; 

switch computer
case 'MAC2'
	posbut1 = [5 pos_axes(2)+pos_axes(4)-20 75 20];
	posbut2 = [7 pos_axes(2)+pos_axes(4)-18 70 15];
case 'PCWIN'
	posbut1 = [5 pos_axes(2)+pos_axes(4)-50 75 20];
	posbut2 = [7 pos_axes(2)+pos_axes(4)-48 70 15];
otherwise
	posbut1 = [5 pos_axes(2)+pos_axes(4)-50 75 20];
	posbut2 = [7 pos_axes(2)+pos_axes(4)-48 70 15];
end

hd_smallUL_Button_EVN(1) = uicontrol(hd_fig,...
'Units','Pixel',...
'Position',posbut1,...
'Style','frame');

hd_smallUL_Button_EVN(2) = uicontrol(hd_fig,...
'Units','Pixel',...
'Position',posbut2,...
'BackgroundColor',light_green,...
'Style','text',...
'String','Menus On',...
'HorizontalAlignment','Center',...
'ButtonDownFcn','set(gco,''String'',''Menus On'',''Userdata'',''Menus On'',''BackgroundColor'',[.7 1 .7]);');

