function draw_histo_betp(hd_fig,hd_axes)
% creating the histo object used to display BetP for each variable of the EVN

%
%   Version : Jan 4,03
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

% we take as center the position of the node variable
% give to the histo object the initial position of the node
% uicontrol a box around this position with the histo
% this bow can be moved, in which case center position recomputed
% there is overlap if nodes too close
% no zoom needed, only shift of the whole set and of the histo.
% histo object built here, whereas plot done in plot_histo(ind_histo)

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute  pin_variable 
global pin_mapping pin_belief 
global node pin_node link pin_link  need_uiresume flags flagstr scaling_coef
global hd_smallUL_Button_EVN light_green light_red plot_limits_initial  plot_limits_now 
global histo pin_histo

% beware same parameters in plot_histo
h_element = 15;
skipv = 5; % skip between titel and histo
w_char = 5; % width for one character

xlim = get(hd_axes,'Xlim');
ylim = get(hd_axes,'Ylim');

% % % set(hd_axes,'visible','off')

set(hd_fig,'color',[1 1 1]);
for i_node = 1:length(node)
	if length(node(i_node).betp_localization)	
		crth = node(i_node).center;
 		crth = [scaling_coef*(crth(1)-xlim(1)) ...
		scaling_coef*(crth(2)-ylim(1))];
		% % % % % 		[xlim ylim scaling_coef node(i_node).center crth]
		new_histo = get_next_pin('histo');
		ind_histo = new_histo(2);		
		ind_var = pin_manipulation('variable','num2ind',node(i_node).obj_num);		
		ind_fra = pin_manipulation('frame','num2ind',variable(ind_var).frame);
		cardi = frame(ind_fra).cardinality;
		nbr_char = size(frame(ind_fra).elements,2);
		ix = node(i_node).betp_localization;
		histo(ind_histo).number = new_histo(3);
		histo(ind_histo).node_ind = i_node;
		histo(ind_histo).center = crth;	
		histo(ind_histo).title_text = variable(ind_var).short_name;
		histo(ind_histo).cardinal = cardi;
		histo(ind_histo).height_fr_histo = h_element*(cardi+1)+skipv;
		histo(ind_histo).width_element = min(max(15,nbr_char*w_char),w_char*7);
		histo(ind_histo).betp = belief(ix(1)).bp(ix(2)).form(ix(3)).values;		
		histo(ind_histo).elements = frame(ind_fra).elements;	
		
		useless = pin_manipulation('histo','all',[]);
		
		% we really plot histo here, everything is derived from center position
		hd_histo = plot_histo(ind_histo,hd_fig);
		histo(ind_histo).handle = hd_histo;
	end
end

