function tbm_tabulator(option,age,param)
% a tabulator for computing potentials (like Excel)

% option = 'Full_Screen', 'Half_Screen'
% age = 'New', 'Old'
% not yet used, but may become usefull later

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% object
% 
% obj(i).location = [4 7]			% its origin 
% obj(i).instruction = 'm(5,8)'		% the instruction
% obj(i).used_by = [4 7; 5 9; 6 6]	% the origins of those who use me
% obj(i).length = 8					% length data under me
% obj(i).form = 'q'					% form of data  ('' = not potential)
%
% stroring the handle for transfer thru function calls
% handle.hd_top_row = hd_top_row;
% handle.hd_left_col = hd_left_col;
% handle.hd_data = hd_data;
%
% history(ii).instruction = 'blabla'
% history(ii).index = [xi,xj]
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%
%   Version : May 4, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global button_size flag keyhit help_level
global nbr_bit_per_word
global pathname2TBMLABvers  screen_size
global Which_Courier

% % % % nbr_bit_per_word = 50;
% % % % button_size = [50 20];
% enter the sizes nr nc  XXXXXXXXXXXX

title = 'TBM Tabulator.';
text_comment = {'You select a cell, and type in it what you want to see below it, then hit return. Computation performed.',...
'Reference to an object by x = i,j , the coordinates of the top element of the object where the instruction is displayed. if x = j, i = 1.',...
'- label(n;a), bba(n), key(n;out), m(x) b(x) q(x) bel(x) pl(x) wc(x) wd(x) betp(x), n(x), -(x), disc(x;df;out)',...
'- ccr(x1;x2;...;xn;out), dcr(x1;x2;...;xn;out), gbt(x1;...;xn;x*;cond;out), drc(x1;...;xn;x*;out) ',...
'Select a cell, hit Return. At lower right, instruction used to build the object that contains the selected cell.',...
'Replay used for running instructions again after changing a value. Rep Fr means the data generated by bba are kept (frozen), Rep Nw, the bba instruction is exceuted.'};

nr = 20; nc = 18; 
nbr_char_data =7;
nbr_char_left = 5;
LLposition = [1 55];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% fontsize for Which_Courier
switch computer
case {'MAC2','MAC'}
	ftsz = 10;
	ftn = Which_Courier;
case 'PCWIN'
	ftsz = 9;
	ftn = Which_Courier;	
otherwise
	ftsz = 9;
	ftn = Which_Courier;	
end

scr_size = screen_size;
pos_fig = [10   70   scr_size(3)-20   scr_size(4)-120];

hd_fig = figure(...
'name','Tabulator Window',...
'DefaultuicontrolUnits','pixels',...
'DefaultuicontrolFontName',ftn,...
'DefaultuicontrolFontSize',ftsz,...
'Color','white',...
'DefaultuicontrolBackgroundColor','white',...
'KeyPressFcn','callback_key_hit;uiresume;');
set(gcf,'position',pos_fig);
pos_free = [0 0 pos_fig(3) pos_fig(4)];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The title
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

title = 'TBM Tabulator';
text_h = 20;
pos_title = [5 pos_fig(4)-1.5*text_h  pos_fig(3)-5   text_h];
hd_title = uicontrol(gcf,'position',pos_title,...
'style','text',...
'string',title,...
'horizontalalignment','center',...
'FontSize',18,...
'ForegroundColor','r');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The text box under the title
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_text = uicontrol(gcf,'position',pos_title+[10 -100 -20 0],'style','frame');
[outtext, pos_text_comment] = textwrap(hd_text(1) ,text_comment);
delete(hd_text);
pos_text = [5   pos_title(2)-pos_text_comment(4)-20    pos_fig(3)-5    pos_text_comment(4)+10];
hd_text = uicontrol(gcf,'position',pos_text,...
'style','text',...
'horizontalalignment','left',...
'string',outtext);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the help text
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_menu(1) = uimenu(gcf,'label','Tools');
hd_menu(2) = uimenu(hd_menu(1),'label','Help','callback','clbfmttab(21)');
hd_menu(3) = uimenu(hd_menu(1),'label','Save','callback','clbfmttab(22)');
hd_menu(4) = uimenu(hd_menu(1),'label','Quit','callback','clbfmttab(23)');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the only big panel: 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the dimensions of the boxes for the data (for nbr_char_data char)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_temp = uicontrol(gcf,...
'style','text','position',[2 2 500 5]); % any pos OK, just to run textwrap

fake_text(1:nbr_char_data) = 'w';
[outtext, pos_box] = textwrap(hd_temp,{fake_text});
pos_box(3) = ceil(pos_box(3));
pos_box(4) = ceil(pos_box(4));
% pos_box = size of the box with data
box_w = pos_box(3);
switch computer
case 'MAC2'
	box_h = fix(1.3*pos_box(4));
otherwise
	box_h = ceil(pos_box(4));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the width of the left most column, in pos_left(3) (for nbr_char_left char)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fake_text(1:nbr_char_left) = 'w';
[outtext, pos_left] = textwrap(hd_temp,{fake_text});
left_w = pos_left(3);
delete(hd_temp) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the positions
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% left column
pos_row(1) = LLposition(2) +(nr+2)*box_h + 2;
for i = 2:nr + 2
	pos_row(i) = pos_row(i-1) - box_h;
end

% UL corner
pos_col(1) = LLposition(1);
pos_col(2) = pos_col(1) + left_w + 2;
for j = 2:nc + 2
	pos_col(j) = pos_col(j-1) + box_w;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the upper left corner
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_corner(1) = uicontrol(gcf,'style','edit',...
'position',[pos_col(1) pos_row(2) left_w+1 box_h]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the top row
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for j = 1:nc
	hd_top_row(j) = uicontrol(gcf,'style','edit',...
	'position',[pos_col(j+1) pos_row(2) box_w+1 box_h]);
end	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the left column
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i = 1:nr
	hd_left_col(i) = uicontrol(gcf,'style','edit',...
	'position',[pos_col(1) pos_row(i+2) box_w+1 box_h+1]);
end	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the table itself (scroling table)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i = 1:nr
	for j = 1:nc
		hd_data(i,j) = uicontrol(gcf,'style','edit',...
		'position',[pos_col(j+1) pos_row(i+2) box_w+1 box_h+1],...
		'callback','uiresume;',...
		'backgroundcolor','w');
	end	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the heavy lines
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
switch  computer
case 'MAC2'
	hd_hl(1) =  uicontrol('style','text','position',[pos_col(1)-1 pos_row(nr+2) 1 pos_row(1)-pos_row(nr+2)+1],...
	'backgroundcolor','k');
	
	hd_hl(2) =  uicontrol('style','text','position',[pos_col(2)-1 pos_row(nr+2) 1 pos_row(1)-pos_row(nr+2)+1],...
	'backgroundcolor','k');
	
	hd_hl(3) =  uicontrol('style','text','position',[pos_col(1) pos_row(1) pos_col(nc+2)-pos_col(1)+1 1],...
	'backgroundcolor','k');
	
	hd_hl(4) =  uicontrol('style','text','position',[pos_col(1) pos_row(2)+1 pos_col(nc+2)-pos_col(1)+1 1],...
	'backgroundcolor','k');
otherwise
	for i = 1:nr
		set(hd_left_col(i),'backgroundcolor',[.7 .7 .7]);
	end	
	for i = 1:nc
		set(hd_top_row(i),'backgroundcolor',[.7 .7 .7]);
	end	
	set(hd_corner(1),'backgroundcolor',[.7 .7 .7]);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the buttons for scrolling the table up down, left right  + quit
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

switch computer
case 'MAC2'
	butcolor = [1 0.5 0.5]; % color of half tone buttons
case 'PCWIN'
	butcolor = [1 0.6 0.6];
otherwise
	butcolor = [1 0.6 0.6];
end

height_control = 60;
width_window = pos_fig(3) - 5;

% the external frame
hd_buttons(1) = uicontrol(gcf,...
'style','frame','position',[1 1  width_window-2  height_control-2] ,...
'backgroundcolor',[.7 .7 .7]);	

% the buttons left right up down
hd_buttons(2) = uicontrol(gcf,...
'style','pushbutton',...
'position',[20 (height_control-button_size(2))/2 button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(1);',...
'string','Left');	
hd_buttons(3) = uicontrol(gcf,...
'style','pushbutton',...
'position',[90 height_control/2+.2*button_size(2) button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(2);',...
'string','Up');	
hd_buttons(4) = uicontrol(gcf,...
'style','pushbutton',...
'position',[90 height_control/2-1.2*button_size(2) button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(3);',...
'string','Down');	
hd_buttons(5) = uicontrol(gcf,...
'style','pushbutton',...
'position',[160 (height_control-button_size(2))/2 button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(4);',...
'string','Right');	

% the buttons with clean home 
hd_buttons(6) = uicontrol(gcf,...
'style','pushbutton',...
'position',[240 height_control/2-button_size(2)-4 button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(6);',...
'string','Clear');	
hd_buttons(7) = uicontrol(gcf,...
'style','pushbutton',...
'position',[240 height_control/2+4 button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(5);',...
'string','Home');	

% the buttons with replay
hd_buttons(8) = uicontrol(gcf,...
'style','pushbutton',...
'position',[310  height_control/2-button_size(2)-4 button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(8);',...
'string','Rep Nw');	

hd_buttons(9) = uicontrol(gcf,...
'style','pushbutton',...
'position',[310 height_control/2+4 button_size(1) button_size(2)],...
'backgroundcolor',butcolor,...
'CallBack','clbfmttab(7);',...
'string','Rep Fr');	

% the right window  text 
hd_buttons(10) = uicontrol(gcf,...
'style','edit',...
'position',[500 4  width_window-503  height_control-8],...
'HorizontalAlignment','Left',...
'backgroundcolor',[1 1 1],...
'string','');	

% stroring the handle for transfer thru function calls
handle.hd_top_row = hd_top_row;
handle.hd_left_col = hd_left_col;
handle.hd_data = hd_data;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%  End of figure building , data entry starts here %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x{1,1} = []; % needed as refresh_data uses size(x) to see if it must display something
fri = 1;
frj = 1;
refresh_data(fri,frj,x,nr,nc,handle);
i_obj = 0;
ind_hist = 0;
obj(1).location = [0 0]; % just to have an object
history(1).instruction = '';

replay_type = 0;
% replay_type = 0 no replay mode, 
%             = 1 replay with random data frozen (those generated by bba), 
%             = 2 replay and bba generated data change if encountered by replay

replay_start = []; % the instruction in history(). where data have been modified
must_be_replayed = 0;

% replay buttons not enabled 
set(hd_buttons(8),'enable','off');
set(hd_buttons(9),'enable','off');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the loop
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
while go_on 
	flag = 0;
	
	if replay_type == 0
		uiwait(gcf) % do something
		% uiresulme either as I hit a button or as I use CR (after introdcuing instruction)		
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% the bottom button and the menu options
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	if flag
		% select a button
		switch flag 
		case 1 % left
			frj = max([frj - 10,1]);
			refresh_data(fri,frj,x,nr,nc,handle);
		case 2 % up
			fri = max([fri - 10,1]);
			refresh_data(fri,frj,x,nr,nc,handle);
		case 3 % down
			% % % % % % 			[nrx,ncx] = size(x);
			% % % % % % 			if nrx < fri + nr + 10
			% % % % % % 				for ikk = nrx + 1:fri + nr + 10
			% % % % % % 					for jkk = 1:ncx
			% % % % % % 						x{ikk,jkk} = [];
			% % % % % % 					end
			% % % % % % 				end
			% % % % % % 			end
			fri = fri + 10;
			refresh_data(fri,frj,x,nr,nc,handle);
		case 4 % right
			% % % % % % 			[nrx,ncx] = size(x);
			% % % % % % 			if ncx < frj + nc + 10
			% % % % % % 				for jkk = ncx + 1:frj + nc + 10
			% % % % % % 					for ikk = 1:nrx
			% % % % % % 						x{ikk,jkk} = [];
			% % % % % % 					end
			% % % % % % 				end
			% % % % % % 			end
			frj = frj + 10;
			refresh_data(fri,frj,x,nr,nc,handle);
		case 5 % home
			fri = 1;
			frj = 1;
			refresh_data(1,1,x,nr,nc,handle);			
		case 6 % clear
			ButtonName = questdlg('Confirm clear data.','TBM Tabulator Querry','Clear','Cancel','Clear');
			if strcmp(ButtonName,'Clear')
				% % % % % % 				for i = 1:nr
				% % % % % % 					for j = 1:nc
				% % % % % % 						x{i,j} = [];
				% % % % % % 					end
				% % % % % % 				end
				clear x history obj
				x{1,1} = [];
				fri = 1;
				frj = 1;
				i_obj = 0;
				ind_hist = 0;
				obj(1).location = [0 0]; % just to have an object
				history(1).instruction = '';
				refresh_data(fri,frj,x,nr,nc,handle);
			end
		
		case 7 % replay bba frozen (kept as now), key data may have changed
			% bba and key instruction not excecuted
			replay_type = 1;
			next_history = 0; % we replay EVERYTHING  % min(replay_start);
			
		case 8 % replay new, we replay EVERYTHING, so all bba changed
			% key instruction not excecuted, bba excecuted
			replay_type= 2;
			next_history = 0;
			
		case 21 % display help from menu
			gcf_mem = gcf;
			help_level_mem = help_level;
			help_level = 1;
			help_text_handles = display_helps(1,50,ftn);
			% text 48 in init_stored_texts 
			delete(help_text_handles)
			help_level = help_level_mem;
			figure(gcf_mem);
			
		case 22 % save data for excel from menu
			[nrx ncx] = size(x);
			for i=1:nrx 
				for j = 1:ncx				
					if size(x{i,j}) ~= [0 0]
						data = str2num(x{i,j});
						if ~isempty(data)
							xx(i,j) = data;
						end
					end				
				end
			end
			cd([pathname2TBMLABvers filesep 'User_data' filesep 'Other_Data']);
			save tbm_tabulator_data xx -ASCII -TABS
			
		case 23 % quit
			switch computer
			case {'MAC2','PCWIN'}
				ButtonName = questdlg('Confirm quit.','TBM Tabulator Querry','Quit','Cancel','Quit');
			otherwise
				ButtonName = questdlg('Confirm quit. !!! On MacOSX-Unix, it takes 20 seconds. Wait till the TBMLAB menus answer to your seletcion',...
				'TBM Tabulator Querry','Quit','Cancel','Quit');
			end
			if strcmp(ButtonName,'Quit')
				tic
				delete(hd_fig)
				toc
				go_on = 0;
			end		
		end % switch flag 
	
	else
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% the instructions on the data in table
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		
		new_inst = 1;
		if replay_type == 0			
			% you enter a function, ended with return
			% which cell are you on
			% finding selected data x{xi,xj} located in cell = hd_data(ti,tj)
			[ti,tj] = find(hd_data == gco);
			
			% if [ti,tj] = [] [], it means: I am NOT on a cell
			xi = ti + fri - 1;
			xj = tj + frj - 1;
			% get a text input area
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% I look if this cell is not in an object, 
			% if yes (index > 0) I display its genertating inst in the conversation box (LR)			
			index = cell_in_which_object(x,xi,xj); %x(xi,xj) belongs to object x(index,xj)			
			if index 
				inst_cell = x{index,xj};
				new_inst = 0;
				set(hd_buttons(10),'string','')						
				set(hd_buttons(10),'string',inst_cell);		
				ndata = get(hd_data(ti,tj),'string');
				
				if ~strcmp(ndata,x{xi,xj}) % data has changed
					must_be_replayed = 1;
					x{xi,xj} = ndata;
					set(hd_buttons(8),'enable','on')
					set(hd_buttons(9),'enable','on')
					% update data in x
					ii = 0; 
					for ii = 1:length(history)
						if history(ii).index == [index,xj]
							replay_start = [replay_start ii];
						end
					end	
				end
				% replay_start is where I will have to start replay if asked for (flag 7)
			else % I am above an empty cell
				inst_cell = '';
				new_inst = 1;
				% % % % % 				str = get(hd_data(ti,tj),'string');			
			end
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			
		end % if replay_type == 0
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		if new_inst		
			new = [];
			new_symb = [];
			param = [];
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			if replay_type == 0
				inst = ddblank(get(hd_data(ti,tj),'string'));
				[op param] = parse_inst(inst);
				skip_inst = 0;
			else
				next_history = next_history + 1;
				if next_history <= length(history)
					inst = history(next_history).instruction;
					xi = history(next_history).index(1);
					xj = history(next_history).index(2);
					[op param] = parse_inst(inst);
					skip_inst = 0;
				else
					% I am thru of replay
					% I refresh
					refresh_data(1,1,x,nr,nc,handle)
					replay_type = 0;
					replay_start = [];
					must_be_replayed = 0;
					set(hd_buttons(8),'enable','off');
					set(hd_buttons(9),'enable','off');
					skip_inst = 1;
					inst = '';					
				end
			end % if replay_type == 0
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			while strcmp(op,'wrong')
				set(hd_buttons(10),'string','')			
				set(hd_buttons(10),'string',inst)
				txt = 'Wrong instruction. Correct it in lower right window. Select Done when instruction corrected';
				hdw = warndlg(txt);
				uiwait(hdw)
				
				hd_buttons_extra(1) = uicontrol(gcf,...
				'style','pushbutton',...
				'position',[440  height_control/2+4 button_size(1) button_size(2)],...
				'HorizontalAlignment','Center',...
				'backgroundcolor',butcolor,...
				'CallBack','clbfmttab(9);',...
				'string','Done');	
				
				hd_buttons_extra(2) = uicontrol(gcf,...
				'style','pushbutton',...
				'position',[440  height_control/2-button_size(2)-4 button_size(1) button_size(2)],...
				'HorizontalAlignment','Center',...
				'backgroundcolor',butcolor,...
				'CallBack','clbfmttab(10);',...
				'string','Cancel');
				
				flag = 0;			
				go_on_flag = 1;				
				while go_on_flag
					uiwait(gcf)						
					switch flag 
					case 9
						choice = 1;
						go_on_flag = 0;
					case 10
						choice = 2;
						go_on_flag = 0;
					end
				end
				% questdlg is not OK, you must first select its buttons				
				% choice = text_with_n_buttons(gcf, txt, {'Done','Cancel'}, [0 0 0 0])
				if choice == 2 % cancel
					skip_inst = 1;
					op = '';
				else % I have corrected instruction
					inst = ddblank(get(hd_buttons(10),'string'));
					[op param] = parse_inst(inst);
				end
				delete(hd_buttons_extra)
				set(hd_buttons(10),'string','')					
			end % while strcmp(op,'wrong')
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%%%%%%%%%%%          a new instruction          %%%%%%%%%%%%%%%%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
			% we are at level of a new instruction
			if skip_inst == 0 % because wrong
				if replay_type == 0;
					ind_hist = ind_hist + 1;
					history(ind_hist).instruction = inst;
					history(ind_hist).index = [xi xj];
					
					set(hd_data(ti,tj),'string','')
					set(hd_data(ti,tj),'string',inst)
					x{xi,xj} = inst;					
				end
			
				switch op
				
				case 'label' % card, label
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% label
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					cardi = param{length(param)};
					for i = 1:length(param)-1
						new_symb{i} = param{i};
					end
					x = set_data_symb(new_symb,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,pow2(cardi),'');
					end
				
				case 'bba' % card
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% random bba
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					if replay_type == 0 | replay_type == 2 						
						cardi = param{1};
						m = fix(1000*sort([rand(pow2(cardi)-1,1);1]))/1000;
						new = [m(1); diff(m)];
						x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
						if replay_type == 0;
							[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,pow2(cardi),'m');
						end
					end
				case 'key' % card;out
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% enter data with keyboard
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					if replay_type == 0;
						cardi = param{1};
						new = zeros(pow2(cardi),1);
						x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,pow2(cardi),param{2});
						tim = ti;tjm = tj;
						xim = xi;xjm = xj;
						
						% enter data with keyboard, till ok return in blank cell
						set(hd_buttons(10),'string','BEWARE: exit = type ok in blank cell, hit return. BEWARE: n<=4, be sure to have enough room on display.')
						in_num = 1;
						
						while in_num			
							uiwait(gcf) 			
							[ti,tj] = find(hd_data == gco);
							xi = fri + ti - 1;
							xj = frj + tj - 1;
							indatanow = get(hd_data(ti,tj),'string');
							
							if ~isempty(findstr(indatanow,'ok'))
								% I typed ok
								set(hd_data(ti,tj),'string','');
								in_num = 0; % it is finished								
							else
								if tj == tjm & ti>= tim & ti <= tim + length(new)
									% so I am in he key object area
									if isempty(str2num(indatanow))
										% it is not a number
										set(hd_data(ti,tj),'string','');
									end
									% I keep it if number in obj area
									% needed to clean the frame and proceed as it should, amazing!!!
									set(hd_data(ti,tj),'string','');
									set(hd_data(ti,tj),'string',indatanow);
									x{xi,xj} = indatanow;
								else
									% I am not in object area
									set(hd_data(ti,tj),'string','');
								end
							end % if ~isempty(findstr(indatanow,'ok'))
						end	% while in_num
						set(hd_buttons(10),'string','');						
					end
				
				case {'m','b','bel','pl','q','wc','wd','betp'} % x
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% unary fct
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					i = locate_obj(param{1},obj);
					if strcmp(op,'wc')
						op = 'w';
					end
					if i
						get_data(i,x,obj);
						new = fmt(get_data(i,x,obj),obj(i).form,op);
						x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
						if replay_type == 0;
							[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),op);
							obj(i).used_by = [obj(i).used_by; xi,xj ];
						end
					end
				
				case 'n' % x
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% normalization
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					i = locate_obj(param{1},obj);
					in_form = obj(i).form;	
					new = fmt(fmt(get_data(i,x,obj),in_form,'m','n'),'m',in_form);
					x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),in_form);
						obj(i).used_by = [obj(i).used_by; xi,xj ];
					end
				
				case '-' % x
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% negation
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					i = locate_obj(param{1},obj);
					in_form = obj(i).form;
					new = fmt(flipud(fmt(get_data(i,x,obj),in_form,'m')),'m',in_form);
					x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),in_form);
						obj(i).used_by = [obj(i).used_by; xi,xj ];
					end
				
				case 'ccr' % x1;x2;...;xn;out
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% conj combi rule
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					nbr = length(param) - 1;
					i = locate_obj(param{1},obj);
					in_data = fmt(get_data(i,x,obj),obj(i).form,'q');
					obj(i).used_by = [obj(i).used_by; xi,xj ];
					for i = 2:nbr
						ik = locate_obj(param{i},obj);
						in_data = in_data .* fmt(get_data(ik,x,obj),obj(ik).form,'q');
						obj(ik).used_by = [obj(ik).used_by; xi,xj ];
					end
					new = fmt(in_data,'q',param{nbr+1});			
					x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),param{nbr+1});
					end
				
				case 'dcr' %x1;x2;...;xn;outform
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% disj combi rule
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					nbr = length(param) - 1;
					i = locate_obj(param{1},obj);
					in_data = fmt(get_data(i,x,obj),obj(i).form,'b');
					obj(i).used_by = [obj(i).used_by; xi,xj ];
					for i = 2:nbr
						ik = locate_obj(param{i},obj);
						in_data = in_data .* fmt(get_data(ik,x,obj),obj(ik).form,'b');
						obj(ik).used_by = [obj(ik).used_by; xi,xj ];
					end
					new = fmt(in_data,'b',param{nbr+1});				
					x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),param{nbr+1});
					end
				
				case 'gbt' % x1;x2;...;xn;x_prior;conditioning_event;outform
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% gbt with prior
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					nbr = length(param)-3;
					for ik = 1:nbr
						i = locate_obj(param{ik},obj);
						pl(:,ik) = fmt(get_data(i,x,obj),obj(i).form,'pl');
						obj(i).used_by = [obj(i).used_by; xi,xj ];
					end
					nbr_x = size(pl,1);
					if length(param{nbr+1}) % the prior on H
						i = locate_obj(param{nbr+1},obj);
						q_prior = fmt(get_data(i,x,obj),obj(i).form,'q');
						obj(i).used_by = [obj(i).used_by; xi,xj ];
					else
						q_prior = [ones(pow2(nbr),1)];
					end
					% conditioning event position
					loci = param{nbr+2}(1) ;
					locj = param{nbr+2}(2) ;
					loco = [obj(:).location];
					n = length(loco);
					poss_j = find(loco([2:2:n]) == locj);
					if length(poss_j) == 1				
						cond_ev = loci - obj(poss_j).location(1);
					else	
						for ik = 2:length(poss_j)
							if loci >= obj(poss_j(ik-1)).location(1) & loci <obj(poss_j(ik)).location(1)
								cond_ev = loci - obj(poss_j(ik-1)).location(1) + 1;
							end					
						end
					end
					ww = ones(pow2(nbr),1);
					ww(pow2(nbr) - pow2(0:nbr-1)) = pl(cond_ev,:);
					new = fmt(fmt(ww,'wc','q').*q_prior,'q',param{nbr+3});
					x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),param{nbr+3});
						i_obj = i_obj + 1;
					end
					pl = [];
					
				case 'drc' % x1;x2;...;xn;x*;out
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% drc with prior
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					nbr = length(param)-2;
					for ik = 1:nbr
						i = locate_obj(param{ik},obj);
						b(:,ik) = fmt(get_data(i,x,obj),obj(i).form,'b');
						obj(i).used_by = [obj(i).used_by; xi,xj ];
					end
					nbr_x = size(b,1);
					if length(param{nbr+1}) % the prior on H
						i = locate_obj(param{nbr+1},obj);
						m_prior = fmt(get_data(i,x,obj),obj(i).form,'m');
					else
						m_prior = [zeros(pow2(nbr)-1,1);1];
					end
					if length(m_prior) ~= pow2(nbr)
						% not ok
						disp('You are incoherent, length prior is not adequate, I''ll use avacuous one')
						m_prior = [zeros(pow2(nbr)-1,1);1];
					end
					b_res = zeros(nbr_x,1);
					for ik = 1:length(m_prior)
						if m_prior(ik)					
							biton = long_num2onbit(ik-1,nbr);
							b_res = b_res + m_prior(ik)*prod(b(:,[biton]),2);
						end
					end
					out_form = param{nbr+2};
					new = fmt(b_res,'b',out_form);
					x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),out_form);
					end
					b = [];
					
				case 'disc'
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					% discounting
					%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
					i = locate_obj(param{1},obj);
					in_form = obj(i).form;
					in_data = fmt(get_data(i,x,obj),in_form,'m');
					in_data = in_data * (1-param{2});
					in_data(length(in_data)) = in_data(length(in_data)) + param{2};
					new = fmt(in_data,'m',param{3});
					x = set_data(new,ti,tj,handle,x,xi,xj,replay_type);
					if replay_type == 0;
						[obj,i_obj] = make_obj(obj,i_obj,[xi,xj],inst,length(new),in_form);
						obj(i).used_by = [obj(i).used_by; xi,xj ];
					end
				end % switch op
			end % if skip_inst == 0
		end % if new_inst
	end % if flag  % select a button
end % while go_on 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function refresh_data(fri,frj,x,nr,nc,handle)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% displaying requested data in the data table after scrolling 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% the top line
jj = frj - 1;
for j = 1:nc
	jj = jj + 1;
	set(handle.hd_top_row(j),'string',num2str(jj),'HorizontalAlignment','Center');
end

% the left column
ii = fri - 1;
for i = 1:nr
	ii = ii + 1;
	set(handle.hd_left_col(i),'string',num2str(ii),'HorizontalAlignment','Center');
end

% clear all cells
for i = 1:nr
	for j = 1:nc
		set(handle.hd_data(i,j),'string','');
	end
end

% put new data in displayed cells
[nrx,ncx] = size(x);
ir = 0;
for i = fri:min(nrx,fri + nr - 1);
	ir = ir + 1;
	ic = 0;
	for j = frj:min(ncx,frj + nc - 1)
		ic = ic + 1;
		set(handle.hd_data(ir,ic),'string',x{i,j});
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function label = build_subsets(cardi,base)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% building the lables of the subset
% base = a cahracter, and I use it and the next ascii
% label instr was label(3,a)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

label{1} = '';
next = base;
fr = 2; to = 2;
for i = 1:cardi
	ii = 0;
	for j = fr:to
		ii = ii + 1;
		label{j} = [label{ii},next];
	end
	fr = to + 1;
	to = to + pow2(i);		
	next = char(double(next)+1);
end
label{1} = '{}';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [op,param] = parse_inst(inst)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% instruction parser
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% textbelow = {'op(x): x = r,c means row-column coordinates where object starts. x=r means x=1,c.',...
% 'op(x1;x2;out): xi as above. out is form for results.',...
% 'gbt(x1;...;xn;xr;out): xi condit. pot., xr = cell conditioning event. out = form.',...
% 'drc(x1;...;xn;out). Out = b. disc(x;.7;out): potential in x discounted by .7. label(#,a), bba(#)'};

misspel = 0;
% inst = ddblank(inst); done before
ind1 = findstr(inst,'(');
ind2 = findstr(inst,')');
indv = findstr(inst,',');
indw = findstr(inst,';');

param = [];

try
	if isempty(ind1) | isempty(ind2) 
		misspel = 1;
	else
		if ~isempty(indv)
			if	indv(1) < ind1 | indv(length(indv)) > ind2 
				misspel = 1;
			end
		end
	end

	if misspel == 0
		op = lower(inst(1:ind1-1));
		switch op
		case 'label' % card, label1
			cardi = str2num(inst(ind1+1:indw(1)-1));
			param = build_subsets(cardi,inst(indw(1)+1:ind2-1));
			if length(param) == 0 | ~isnumeric(cardi)
				misspel = 1;
			end
			param{length(param)+1} = cardi;
		case 'key' % card, out
			param{1} = str2num(inst(ind1+1:indw(1)-1));
			param{2} = inst(indw(1)+1:ind2-1);	
			if  ~isnumeric(param{1}) | ~ismember(lower(param{2}),{'m','b','q','bel','pl','wc','wd','betp'})
				misspel = 1;
			end
		case 'bba'
			param{1} = str2num(inst(ind1+1:ind2-1));
			if  ~isnumeric(param{1}) 
				misspel = 1;
			end		
		case {'m','b','q','bel','pl','wc','wd','betp','n','-'} % x
			x = str2num(inst(ind1+1:ind2-1));
			if length(x) == 1
				x = [1 x];
			end
			if length(x) ~= 2
				misspel = 1;
			end	
			param{1} = x;
		case 'disc'  % x;d;out
			x1 = str2num(inst(ind1+1:indw(1)-1));
			if length(x1) == 1
				x1 = [1 x1];
			end
			if length(x1) ~= 2
				misspel = 1;
			end			
			param{1} = x1;
			param{2} = str2num(inst(indw(1)+1:indw(2)-1));	
			param{3} = inst(indw(2)+1:ind2-1);
			if isempty(param{2}) | ~ismember(lower(param{3}),{'m','b','q','bel','pl','wc','wd','betp'})
				misspel = 1;
			end	
		case {'ccr','dcr','gbt','drc'} 
			% ccr dcr x1;x2;...;xn;out   xn = prior on condit domain, if vacuous ;
			% gbt = x1;x2;...;xn;x_prior;cond_event;out   x_prior may be empty, vacuaous bf
			% drc = x1;x2;...;xn;x_prior;out              x_prior may be empty, vacuaous bf
			fr = ind1+1;
			for i = 1:length(indw)
				to = indw(i);
				x = str2num(inst(fr:to-1));
				if length(x) == 1
					x = [1 x];
				end
				param{i} = x;
				fr = to+1;
			end
			param{length(param)+1} = inst(fr:ind2-1);
			
			switch op
			case {'ccr','dcr'}
				for i = 1:length(param)-1
					if length(param{i}) ~= 2
						misspel = 1;
					end	
				end
				if ~ismember(lower(param{length(param)}),{'m','b','q','bel','pl','wc','wd','betp'})
					misspel = 1;
				end				
			case 'gbt'
				for i = [1:length(param)-3   length(param)-1]
					if length(param{i}) ~= 2
						misspel = 1;
					end	
				end
				if ~ismember(lower(param{length(param)}),{'m','b','q','bel','pl','wc','wd','betp'})
					misspel = 1;
				end	
			case 'drc'
				for i = 1:length(param)-2  
					if length(param{i}) ~= 2
						misspel = 1;
					end	
				end
				if ~ismember(lower(param{length(param)}),{'m','b','q','bel','pl','wc','wd','betp'})
					misspel = 1;
				end	
			end
		end		
	end
catch
	misspel = 1;
end

if misspel 
	op = 'wrong';
	param = [];
end					

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function out = get_data(ik,x,obj)
% read in data from the stored data in x from obj(ik)   x not= t

xi = obj(ik).location(1);
xj = obj(ik).location(2);
ii = xi;
for i = 1:obj(ik).length
	ii = ii + 1;
	out(i,1) = str2num(x{ii,xj});
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function x = set_data(new,ti,tj,handle,x,xi,xj,replay_type)
% write data new in the tabulator at ti,tj and update the x matrix
% new is numeric

% saving data in x for future scrolling
ii = 0;
for i = xi+1:xi+length(new)	
	ii = ii + 1;
	if new(ii)
		x{i,xj} = sprintf('%6.4f',[new(ii)]);  
	else
		x{i,xj} = '0';
	end
end
if replay_type == 0
	nr = size(handle.hd_data,1);
	% you  have the inst on your screen as this is only way to enter it
	ii = xi;
	for i = ti+1:min(nr,ti+length(new))
		ii = ii + 1;
		set(handle.hd_data(i,tj),'string',x{ii,xj});
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function x = set_data_symb(new,ti,tj,handle,x,xi,xj,replay_type)
% write data new in the tabulator at ti,tj and update the x matrix
% new is symbolic

% saving data in x for future scrolling
ii = 0;
for i = xi+1:xi+length(new)	
	ii = ii + 1;
	x{i,xj} = new{ii};
end

if replay_type == 0
	nr = size(handle.hd_data,1);
	% you  have the inst on your screen as this is the only way to enter it
	ii = xi;
	for i = ti+1:min(nr,ti+length(new))
		ii = ii + 1;
		set(handle.hd_data(i,tj),'string',x{ii,xj});
	end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function index = locate_obj(param,obj)
% index = 0 if not OK
mat = [obj(:).location];
n = length(mat);
index = intersect(find([mat(1:2:n)] == param(1)),...
find([mat(2:2:n)] == param(2)));
if length(index) ~= 1
	index = 0;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function index = cell_in_which_object(x,xi,xj)

% pointer on hd_data(ti,tj)   which is x(xi,xj)
% I climb in xj toi find the instruction
% So I know which object this cell refers to
% definition of instr: it has ( and )

[nrx,ncx] = size(x);
if xi > nrx | xj > ncx
	index = 0; % I am not on a cell with data
else
	% index = xi with the instruiction, or 0 if no instruction
	ii = xi+1;
	go_on = 1;
	while go_on
		ii = ii - 1;
		if ii > 0		
			if ~isempty(findstr(x{ii,xj},'(')) &  ~isempty(findstr(x{ii,xj},')'))
				% it is an instruction
				index = ii;
				go_on = 0;
			end
		else
			index = 0;
			go_on = 0;
		end
	end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [obj,i_obj] = make_obj(obj,i_obj,pos,inst,ln,frm)

% build the object obj for a new one

i_obj = i_obj + 1;
obj(i_obj).location = pos;
obj(i_obj).instruction = inst;
obj(i_obj).length = ln;
obj(i_obj).form = frm;
obj(i_obj).used_by = []; 	
