function build_tabulator_tutorial(nr,nc)

%
%   Version : Septr 4, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global button_size flag keyhit help_level
global nbr_bit_per_word
global pathname2TBMLABvers screen_size
global Which_Courier

global handle_tbm_tabulator  x_tbm_tabulator obj i_obj ind_hist history


title = 'TBM Tabulator.';
scr_size = screen_size;

nbr_char_data = 6;
nbr_char_left = 4;
LLposition = [1 1];


switch computer 
case 'MAC2'
	pos_fig = [scr_size(3)/2-25  70   scr_size(3)/2+20  scr_size(4)-120];
	ftsz = 10;
	ftn = Which_Courier;
case 'PCWIN'
	pos_fig = [scr_size(3)/2-48  70   scr_size(3)/2+42  scr_size(4)-120];
	ftsz = 9;
	ftn = Which_Courier;	
otherwise
	pos_fig = [scr_size(3)/2-25  70   scr_size(3)/2+36  scr_size(4)-120];
	ftsz = 9;
	ftn = Which_Courier;	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure(...
'name','Tabulator Window',...
'DefaultuicontrolUnits','pixels',...
'DefaultuicontrolFontName',ftn,...
'DefaultuicontrolFontSize',ftsz,...
'Color','white',...
'DefaultuicontrolBackgroundColor','white',...
'KeyPressFcn','callback_key_hit;uiresume;');
set(gcf,'position',pos_fig);
pos_free = [0 0 pos_fig(3) pos_fig(4)];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The title
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

title = 'TBM Tabulator';
text_h = 20;
pos_title = [5 pos_fig(4)-1.5*text_h  pos_fig(3)-5   text_h];

hd_title = uicontrol(gcf,...
'position',pos_title,...
'style','text',...
'string',title,...
'horizontalalignment','center',...
'FontSize',18,...
'ForegroundColor','r');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the dimensions of the boxes for the data (for nbr_char_data char)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_temp = uicontrol(gcf,...
'style','text',...
'position',[2 2 500 5]); % any pos OK, just to run textwrap

fake_text(1:nbr_char_data) = 'w';
[outtext, pos_box] = textwrap(hd_temp,{fake_text});
pos_box(3) = ceil(pos_box(3));
pos_box(4) = ceil(pos_box(4));
% pos_box = size of the box with data
box_w = pos_box(3);
switch computer
case 'MAC2'
	box_h = fix(1.3*pos_box(4));
otherwise
	box_h = ceil(pos_box(4));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the width of the left most column, in pos_left(3) (for nbr_char_left char)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fake_text(1:nbr_char_left) = 'w';
[outtext, pos_left] = textwrap(hd_temp,{fake_text});
left_w = pos_left(3);
delete(hd_temp) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the positions
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% left column
pos_row(1) = LLposition(2) +(nr+2)*box_h + 2;
for i = 2:nr + 2
	pos_row(i) = pos_row(i-1) - box_h;
end

% UL corner
pos_col(1) = LLposition(1);
pos_col(2) = pos_col(1) + left_w + 2;
for j = 2:nc + 2
	pos_col(j) = pos_col(j-1) + box_w;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the upper left corner
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_corner(1) = uicontrol(gcf,'style','edit',...
'position',[pos_col(1) pos_row(2) left_w+1 box_h]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the top row
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for j = 1:nc
	hd_top_row(j) = uicontrol(gcf,'style','edit',...
	'position',[pos_col(j+1) pos_row(2) box_w+1 box_h]);
end	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the left column
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i = 1:nr
	hd_left_col(i) = uicontrol(gcf,'style','edit',...
	'position',[pos_col(1) pos_row(i+2) box_w+1 box_h+1]);
end	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the table itself (scroling table)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i = 1:nr
	for j = 1:nc
		hd_data(i,j) = uicontrol(gcf,'style','edit',...
		'position',[pos_col(j+1) pos_row(i+2) box_w+1 box_h+1],...
		'callback','uiresume;',...
		'backgroundcolor','w');
	end	
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% the heavy lines
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

switch  computer
case 'MAC2'
	hd_hl(1) =  uicontrol('style','text','position',[pos_col(1)-1 pos_row(nr+2) 1 pos_row(1)-pos_row(nr+2)+1],...
	'backgroundcolor','k');
	
	hd_hl(2) =  uicontrol('style','text','position',[pos_col(2)-1 pos_row(nr+2) 1 pos_row(1)-pos_row(nr+2)+1],...
	'backgroundcolor','k');
	
	hd_hl(3) =  uicontrol('style','text','position',[pos_col(1) pos_row(1) pos_col(nc+2)-pos_col(1)+1 1],...
	'backgroundcolor','k');
	
	hd_hl(4) =  uicontrol('style','text','position',[pos_col(1) pos_row(2)+1 pos_col(nc+2)-pos_col(1)+1 1],...
	'backgroundcolor','k');
otherwise
	hd_hl= [];
	for i = 1:nr
		set(hd_left_col(i),'backgroundcolor',[.7 .7 .7]);
	end	
	for i = 1:nc
		set(hd_top_row(i),'backgroundcolor',[.7 .7 .7]);
	end	
	set(hd_corner(1),'backgroundcolor',[.7 .7 .7]);
end

% stroring the handle for transfers thru function calls
handle_tbm_tabulator.hd_fig = hd_fig;
handle_tbm_tabulator.hd_title = hd_title;
handle_tbm_tabulator.hd_top_row = hd_top_row;
handle_tbm_tabulator.hd_left_col = hd_left_col;
handle_tbm_tabulator.hd_data = hd_data;
handle_tbm_tabulator.hd_corner = hd_corner;
handle_tbm_tabulator.hd_hl = hd_hl;

x_tbm_tabulator{1,1} = []; 
fri = 1; frj = 1;
% needed as refresh_data uses size(x) to see if it must display something
refresh_data(fri,frj,x_tbm_tabulator,nr,nc,handle_tbm_tabulator);
i_obj = 0;	
obj(1).location = [0 0]; % just to have an object
x_tbm_tabulator{1,1} = []; % so I can put someting in it in calling program
		
