function [hd_fig_tutor,hd_axes,skip,ft_name,ftsz,pos_fig] =  build_tutorial_window
% creating the window for the text of the tutorial
% figure 
% axes 		for handling text (so i can use Latrex) 
% some buttons

%
%   Version : Sept 5, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags flag_str flag
global handle_tbm_tabulator x_tbm_tabulator obj i_obj  ind_hist history
global pathname2TBMLABvers  screen_size
global gui_position  figure_data   help_level help_label

nbr_digit = 3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% opening a window for the texts
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dim_scr = screen_size;
% dim_scr(3) = dim_scr(3)/2 - 40;
switch computer
case 'MAC2'
	ft_name = 'Times';
	skip = .028; % sapce between 2 lines of text
	ftsz = 12;
	pos_fig = [8 70 dim_scr(3)/2-47 dim_scr(4)-120];
case 'PCWIN'
	ft_name = 'Times New Roman';
	% 	dim_scr(2) = 80;
	% 	dim_scr(4) = dim_scr(4) - dim_scr(2);
	skip = .028;
	ftsz = 10;
	pos_fig = [8 70 dim_scr(3)/2-65 dim_scr(4)-120];
otherwise
	ft_name = 'Helvetica';
	% 	dim_scr(2) = 80;
	% 	dim_scr(4) = dim_scr(4) - dim_scr(2);
	skip = .028;
	ftsz = 10;
	pos_fig = [8 70 dim_scr(3)/2-40 dim_scr(4)-120];
end

% the  figure
hd_fig_tutor = figure('Color',[1 1 1],...
'WindowButtonDownFcn','uiresume;',...
'NumberTitle','off',...
'MenuBar','non');

set(gcf,'position',pos_fig);
set(gcf,'Units','Normalized');

% area for displayed text
hd_axes = axes('position',[0 0 1 1],...
'Units','Normalized',...
'TickDir','out','Color',[1 1 1]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% putting scrolling buttons and a quit button
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

inter_vert = .01;
button_width = .08;
button_height = .03;
dist_fr = .007;

left_pos(1) = 1-dist_fr - 3*button_width - 2*inter_vert;
left_pos(2) = left_pos(1) + button_width + inter_vert;
left_pos(3) = left_pos(2) + button_width + inter_vert;
down_pos(1) = dist_fr;
down_pos(2) = down_pos(1) + (2/3)*button_height;  
down_pos(3) = down_pos(1) + (4/3)*button_height;  

total_height = down_pos(3) + button_height + dist_fr;

hd_button_up = uicontrol(hd_fig_tutor,...
'string','Up',...
'style','pushbutton',...
'backgroundcolor','r',...
'Units','Normalized',...
'position',[left_pos(2) down_pos(3) button_width button_height],...
'horizontalAlignment','center',...
'callback','clb_text_display(1)'  );

hd_button_up = uicontrol(hd_fig_tutor,...
'string','Down',...
'style','pushbutton',...
'backgroundcolor','r',...
'Units','Normalized',...
'position',[left_pos(2) down_pos(1) button_width button_height],...
'horizontalAlignment','center',...
'callback','clb_text_display(2)');

hd_button_up = uicontrol(hd_fig_tutor,...
'string','Left',...
'style','pushbutton',...
'backgroundcolor','r',...
'Units','Normalized',...
'position',[left_pos(1) down_pos(2) button_width button_height],...
'horizontalAlignment','center',...
'callback','clb_text_display(3)');

hd_button_up = uicontrol(hd_fig_tutor,...
'string','Right',...
'style','pushbutton',...
'backgroundcolor','r',...
'Units','Normalized',...
'position',[left_pos(3) down_pos(2) button_width button_height],...
'horizontalAlignment','center',...
'callback','clb_text_display(4)');

hd_button_next = uicontrol(hd_fig_tutor,...
'string','Next',...
'style','pushbutton',...
'backgroundcolor','r',...
'Units','Normalized',...
'position',[dist_fr+.4  dist_fr   button_width button_height],...
'horizontalAlignment','center',...
'callback','clb_text_display(5)');   

hd_button_quit = uicontrol(hd_fig_tutor,...
'string','Quit',...
'style','pushbutton',...
'backgroundcolor','r',...
'Units','Normalized',...
'position',[dist_fr dist_fr button_width button_height],...
'horizontalAlignment','center',...
'callback','clb_text_display(6)');
