function run_tutorials(which_tutor)
% running tutorials on the TBM

%
%   Version : June 26, 2003.
%   Copyright (c) 2003 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global flags flag_str 
global handle_tbm_tabulator x_tbm_tabulator obj i_obj  ind_hist history
global pathname2TBMLABvers  screen_size
global gui_position  figure_data   help_level help_label

nr = 30; nc = 11; 
nbr_digit = 3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% opening a window for the texts at left
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[hd_fig_tutor,hd_axes,skip,ft_name,ftsz,pos_fig] =  build_tutorial_window;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% opening the tabulator at right
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

build_tabulator_tutorial(nr,nc)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% I read the whole tutorial, and create every text object, and made them visible off
% I display from_to by changing the Ylim and putting visible on for those in display area
% the first time a section is asked for, the tabul are excecuted
% when I satr the tutorial, the first setion is displayed just to keep user busy while remainder is compiled
% when the whole compilation is done, this text disappers and the real seesion starts
% If there had been instruction in the first section, they are only excecuted on the second time setion 1 is displayed

% I need instructions as
% ?begin ?end ?clear ?section ?eval (starting with ? is forbidden for blabla) and blabla
% I must put ' or [' before and ' or '] after, so we can even use  get(hd_data(23,7),'string'), beware ''
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% select the file with the tutorial 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

root_file_name = [fullfile(pathname2TBMLABvers,'Gui_Lib','Menu_Tutorials','Tutorial_Texts'),filesep];
% cd(root_file_name);
fid = fopen([root_file_name,which_tutor],'rt');
if fid == -1 % case I cancel
	hdw = warndlg('Sorry. I cannot open this tutorial file. I skip')
	uiwait(hdw)
	out = 'no_data';
	return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% read all data and parse text 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% skipping irrelevance in front
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
go_on = 1;
while go_on
	text_line = fgetl(fid); % Read one line from file, discard newline character
	if length(text_line)
		if strcmp(text_line(length(text_line)),'\')
			text_line(length(text_line)) = [];
		end
	end
	if ~isempty(findstr('?begin',text_line))
		go_on = 0;
	end
end
% now I know where real text starts. First line will be the title

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% handling the title, it MUST be the line just after ?begin. Put as window name
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
text_line = fgetl(fid); % Read one line from file, discard newline character
if length(text_line)
	if strcmp(text_line(length(text_line)),'\')
		text_line(length(text_line)) = [];
	end
end
set(hd_fig_tutor,'name',text_line)
% title displayed

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
k_line = 0; % the index for the blabla line
sect_number = 0; % the index of the sections

start_section = []; % k_line where sections start
line_eval = []; % k_line where a tabul is to be evaluated
line_put = []; % % k_line where a put is to be executed
k_tabul = 0; % counter of tabul
k_put = 0; % counter of put
to_modify = []; % index of lines with   (data to be read in tabulator and put here))

label{1} = []; % the text for the label (as in Latex)

ind_next_instruction = 0; % the counter for what_to_do

sect1_not_shown = 1; % for shwong the first section, to keep user busy while compiling

x = .01; y = 1; % the position of the blabla (shift from left, and top starts at 1.

lastclear = 1; % last section number with a clear (and there is a fake clear at section 1)

figure(hd_fig_tutor); % I get my text figure
go_on = 1;
while go_on
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% Read - clean one line from file,
	text_line = fgetl(fid); 
	if length(text_line)
		if strcmp(text_line(length(text_line)),'\')
			text_line(length(text_line)) = [];
		end
	else
		text_line = ' ';
	end	

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if strcmp(text_line(1),'?')
		% special request (starts with ?)
		text_line = ddblank(text_line);	
		% reading the instructions
		%
		enter_instructions
		%
		% data in 
		% what_to_do(ind_next_instruction).type = 'clear';
		% what_to_do(ind_next_instruction).inst = '';
		% what_to_do(ind_next_instruction).section = sect_number;
		% what_to_do(ind_next_instruction).evaluated = 0; 0 = no, 1 = yes
		% what_to_do(ind_next_instruction).last_clear = lastclear;  section number with lastclear
		
	else
		% a blabla line	(not starting with ?)
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		% fixing latex instructions
		% I change \$ into XdollarX then * into space, then XdollarX into $
		% I change \sum into {\fontsize{16}\Sigma}
		% I change \prod into {\fontsize{16}\Pi}		
		text_line = strrep(text_line,'\$','XdollarX');
		text_line = strrep(text_line,'$','');
		text_line = strrep(text_line,'XdollarX','\$');
		text_line = strrep(text_line,'\sum','\Sigma');
		text_line = strrep(text_line,'\prod','\Pi');	
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% fixing the nbr of lines
		hhd = uicontrol('units','normalized',...
		'style','text',...
		'position',[x 0.10 .9 .89],...
		'visible','off');
		% I put text on 90% of width so when I get special latex iknstruction I hace some flexibility at right
		% the problme with latex line is that text wrap might split in n 2 lines: forbidden
		tl{1} = text_line;		
		[out_text posit] = textwrap(hhd,tl);
		delete(hhd);
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% writing the line of text		
		for i = 1:length(out_text)
			k_line = k_line + 1;
			if findstr(text_line,'')
				to_modify = [to_modify   k_line];
			end			
			y = y - skip;
			
			% show first section to keep user busy
			if sect_number == 2 & sect1_not_shown == 1					
				from = start_section(1);
				ylim = position_line(from) - 1 + .03 ;
				set(hd_axes,'Ylim',[ylim ylim+1]);
				sect1_not_shown = 0; % stop showing later on
				% we are facing section 2, so data available
				for k = 1:length(hd_text) -1 % all text sect 1 on
					set(hd_text(k),'visible','on')
				end
			end
		
			% storing balbla as text visible off
			hd_text(k_line) = text('parent', hd_axes,...
			'position',[x y],...
			'String',out_text{i},...
			'fontsize',ftsz,...
			'FontName',ft_name,...
			'Color','k',...
			'HorizontalAlignment','left',...
			'visible','off');		
			pos = get(hd_text(k_line),'extent');
			
			% the real position in axes of balbla(k_line)
			position_line(k_line) = pos(2);
			
			% for empty line skip only by half
			if strcmp(text_line,' ')
				y = y + skip/2;
			end 	
		
		end	% for i = 1:length(out_text)
	end % if strcmp(text_line(1),'?')... else ...
end % while gon

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% creating menu with TOC section
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ind_fig = length(figure_data)+1;
k=0;
k=k+1;make_fig_menu(ind_fig,k,'File',0,'','on');
k=k+1;make_fig_menu(ind_fig,k,'Quit',1,'general_clb(6)','on');
k=k+1;make_fig_menu(ind_fig,k,'Sections',0,'','on');
for i_sect = 1:length(section_mem)
	k=k+1;make_fig_menu(ind_fig,k,section_mem(i_sect).name,3,['general_clb(',num2str(10+i_sect),')'],'on');
end
menu_manager('create',ind_fig)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% displaying text, executiong instructions and using buttons/menu of tutorial window
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

go_on = 1;
i_sect = 1; % one starts by displaying the first section
while go_on	
	i_sect = min(length(start_section)-1,max(i_sect,1));
	% I had add an extra start_section to get the end of text
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% displaying asked section
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	for k = 1:length(hd_text) % all text off
		set(hd_text(k),'visible','off');
	end	
	from = start_section(i_sect);
	to   = start_section(i_sect+1) - 1;	
	ylim = position_line(from) - 1 + .03 ;
	set(hd_axes,'Ylim',[ylim ylim+1]);	
	for k = from:to
		set(hd_text(k),'visible','on');
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% executing the tabul, put, clear, replay (not used in fact) instructions
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	list_inst = intersect(find([what_to_do(:).section] <= i_sect),...
	find([what_to_do(:).evaluated] == 0)  );
	% those to be executed NOW as OK for section and not yet evaluated
	% those up to here (<= isect), not yet executed (evaluated == 0)
	
	for ind_inst = list_inst % for each of those to be executed now
		to_eval = what_to_do(ind_inst).inst; % instruction number within put or tabul 		
		what_to_do(ind_inst).evaluated = 1;
		
		execute_instructions
		
	end

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	% section displayed, eval done, I wait for button next
	figure(hd_fig_tutor)
	flags = 0;
	
	uiwait(hd_fig_tutor)
	
	switch flags
	case 1 % up
		% set(gca,''Ylim'',[get(gca,''Ylim'')-.4]);
		i_sect = i_sect - 1;
		if i_sect > 0
			val_new_bottom = position_line(start_section(i_sect+1)-1);
			below = find(position_line<val_new_bottom);			
			% val_new_bottom is the value of new bottom line
			set(hd_text(below),'visible','off')
		else
			i_sect = 1;
		end
	case 2 % down
		% set(gca,''Ylim'',[get(gca,''Ylim'')+.4]);
		i_sect = i_sect + 1;
	case 3 % left
		set(gca,'Xlim',[get(gca,'Xlim')-.4]);
	case 4 % right
		set(gca,'Xlim',[get(gca,'Xlim')+.4]);
	case 5 % next
		i_sect = i_sect + 1;
	case 6 % quit
		go_on = 0;
		delete(handle_tbm_tabulator.hd_fig);
		delete(hd_fig_tutor);
		figure_data(ind_fig) = [];
		clear global handle_tbm_tabulator x_tbm_tabulator obj i_obj ind_hist  history
	end

	if flags > 10 % I use the menu with the section TOC
		% I clear the tabulator
		delete(handle_tbm_tabulator.hd_fig)				
		% I clear the tabulator, 
		% I clear x_tbm_tabulator
		% I clear hsitory : what I did since last clear
		% I clear obj = detail on each object (like a bba)
		
		% reinitialize varibales
		obj = [];
		i_obj = 0;
		obj(1).location = [0 0]; % just to have an object with a field	
		
		history = [];
		ind_hist = 0;		
		history(1).instruction = [];
		
		x_tbm_tabulator = [];
		x_tbm_tabulator{1,1} = [];
		
		% redraw the figure
		handle_tbm_tabulator = [];  
		build_tabulator_tutorial(nr,nc)
		
		% I select menu section
		i_sect = flags - 10;
		
		% data in 
		% what_to_do(ind_next_instruction).type = 'clear';
		% what_to_do(ind_next_instruction).inst = 25; % the index of the instructions I am concerned with
		% what_to_do(ind_next_instruction).section = sect_number;
		% what_to_do(ind_next_instruction).evaluated = 0;
		% what_to_do(ind_next_instruction).last_clear = lastclear;		
		ind_inst = [];
		i_sect_t = i_sect + 1;
		while isempty(ind_inst) & i_sect_t > 1
			i_sect_t = i_sect_t-1;
			ind_inst = min(find([what_to_do(:).section] == i_sect_t ));			
		end
		% the first instruction to execute in this section
		% but I must rerun whatever was done since lest clear 
		if isempty(ind_inst)
			ind_sect_last_clear = 1;
		else
			ind_sect_last_clear = what_to_do(ind_inst).last_clear; 
			% ind_last_clear = the index of the last section with clear (or 0 if no clear yet)				
		end
	
		ibegin = min(find([what_to_do(:).section] == ind_sect_last_clear));
		if isempty(ibegin)
			ibegin = 0;
		end	
	
		% ibegin + 1 as the ibegin is the clear instruction
		for i = ibegin+1:length(what_to_do)
			% all instructions since last clear up to end will be rerun			
			what_to_do(i).evaluated = 0;
		end	
		for i = 1:ibegin
			% all instructions up to last clear will not be rerun			
			what_to_do(i).evaluated = 1;
		end	
	
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%
		% executing the tabul, put, clear, replay (not used in fact) instructions
		%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		list_inst = intersect(find([what_to_do(:).section] <= i_sect),...
		find([what_to_do(:).evaluated] == 0)  );
		% those to be executed NOW as OK for section and not yet evaluated
		% those up to here (<= isect), not yet executed (evaluated == 0)
		if ~isempty(list_inst)
			for ind_inst = list_inst % for each of those to be executed now
				to_eval = what_to_do(ind_inst).inst; % instruction number within put or tabul 		
				what_to_do(ind_inst).evaluated = 1;
				
				execute_instructions
				
			end
		end
	end	% if flags > 10 
end % while go_on

