function [BetP_elem, Bel_elem, Pl_elem, bbm, foset,mass0] = res_disp_one(bel_ind, bp_ind, form_ind)
% module 1 of results_display
% construct Bel,BetP,Pl on elements, get normalized bbm, fosets

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global belief frame variable nbr_bit_per_word


bbm = belief(bel_ind).bp(bp_ind).form(form_ind).values;
nbr_worlds = prod([belief(bel_ind).domain_cardinality]);
[nw rm] = words_for_set(nbr_worlds);

switch belief(bel_ind).bp(bp_ind).form(form_ind).representation

case 'ordered' % as card small we get Bel,Pl,BetP at once, NOT stored
	% Nomalization of bbm
	% ordered NOT allowed if you have more thatn 50 elements, what would be absurd in any case
	mass0 = bbm(1);
	norm_factor = 1 - mass0;
	bbm(1) = 0;	
	bbm = bbm/norm_factor;	
	foset = [0:pow2(nbr_worlds)-1]';	
	Bel = fmt(bbm,'m','bel');
	Pl = fmt(bbm,'m','pl');
	BetP_elem = betp(bbm);
	Bel_elem = Bel(pow2([0:nbr_worlds-1])+1);
	Pl_elem = Pl(pow2([0:nbr_worlds-1])+1);
	
case 'selected'
	foset = belief(bel_ind).bp(bp_ind).form(form_ind).focal_sets;
	
	% going thru FMT was not a good idea, suslly all we do it getting MANY 0 masses
	% one FMT = n.2^n/2 additions and 2^n output vector, for betp 2^n add as that many masses
	% For BetP with selected m add 
	% so FMT is not a good idea as we never compute bel on 2^n
	
	
	% 	if nbr_worlds <= 18 % we go thru the ordered appraoch
	% 		okreturn = build_ordered_from_sel(bel_ind,bp_ind);		
	% 		if okreturn == 0
	% 			% bad request, cannot be performed, should never occured here
	% 		else
	% 	
	%  			% we change index of form to skip on the ordered one just created
	%  			% and get oredred masses					
	% 			form_ind = length(belief(bel_ind).bp(bp_ind).form(:));
	% 			bbm = belief(bel_ind).bp(bp_ind).form(form_ind).values ;
	% 			foset = [0:pow2(nbr_worlds)-1]';
	% 			
	% 			% Nomalization of bbm
	% 			mass0 = bbm(1);
	% 			norm_factor = 1 - mass0;
	% 			bbm(1) = 0;	
	% 			bbm = bbm/norm_factor;
	% 			
	% 			Bel = fmt(bbm,'m','bel');
	% 			Pl = fmt(bbm,'m','pl');
	% 			
	% 			BetP_elem = betp(bbm);
	% 			Bel_elem = Bel(pow2([0:nbr_worlds-1])+1);
	% 			Pl_elem = Pl(pow2([0:nbr_worlds-1])+1);
	% 			
	% 			sel_ord = 2; % memory that working with ordered
	% 		end
	% 	else
	%     %
	%   end
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%
	% compute bel,BetP,pl on singletons 
	%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
	% universe is a set where every bit is 1
	universe(1:nw)=pow2(nbr_bit_per_word)-1;
	universe(nw+1)=pow2(rm)-1;
	
	% we make sure foset have 0 in unused bits
	for i = 1:length(bbm)
		foset(i,:) = bitand(foset(i,:),universe);
	end

	% finding the mass to the empty set
	ind_es = locating_a_set(zeros(1,nw+1) ,foset);
	% beware unsused bits are also 0 in the long number
	
	% norm_factor is 1 - mass(empty_set)
	switch length(ind_es)
	case 0
		mass0 = 0;
		norm_factor = 1;
	case 1
		mass0 = bbm(ind_es);
		norm_factor = 1 - mass0;
		bbm(ind_es) = 0;
		bbm = bbm/norm_factor;			
	otherwise
		ok = 0;
		% beware of never having twice the same focal sets !!!
	end 

	Bel_elem = zeros(nbr_worlds,1) ;
	Pl_elem = zeros(nbr_worlds,1) ;
	BetP_elem = zeros(nbr_worlds,1) ;
	for i = 1:length(bbm)
		bit_on = long_num2onbit([foset(i,:)], nbr_worlds);
		if length(bit_on)
			Pl_elem(bit_on) = Pl_elem(bit_on) + bbm(i);
			BetP_elem(bit_on) = BetP_elem(bit_on) + bbm(i)/length(bit_on);
			if length(bit_on) == 1
				Bel_elem(bit_on) = bbm(i);
			end
		end
	end	
end
