function handle_text = display_scrolling_text(handle, position, text)
% displaying a pop up window within uicontrol
% done with a listbox with only ONE text wrapped
% text = {text_1, text_2, text_3};
% where text_i = 'the text to display', one paragraph for each text_i

% you must create a listbox in order to get the width for textwrap
% then wrapped the text
% then set string in listbox

% position is the position in the figure, normalized
% handle is the one of the figure where it goes

% when you click on OK, you erase the text and leave

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%
pos = position;
pos(3) = .90*position(3);
% this is suppose to make it so that the text does not try to invade 
% the vertical scrolling bar
% and is thus not squeezed

handle_text = uicontrol('Parent',handle,...
'Position',pos,...
'Style','listbox',...
'Max',1000,'Min',0,...
'Value',[]);

[t,useless] = protected_textwrap(handle_text,text);
delete(handle_text);
handle_text = [];

handle_text = uicontrol('Parent',handle,...
'Position',position,...
'Style','listbox',...
'Max',1000,'Min',0,...
'Value',[],...
'String',t);  

% no way to do it with style = text, no scroll.
% same handle twice as first only to fix the height of wrapped text
