function [wrapped_text, position]  = protected_textwrap(handle,text) 

% same function os wrapped text BUT verify that input data are as requested

% textwrap is not  that clever and it must get 
% {'rr'}, 
% {'rr','tt'} ,
% a{1}='rr', a{2}='t', input is a

% input 
% handle    : handle of the ui_object to which the text is going to be fitted
% text		: array of cells, each containing a text, but I am protected against error

% accepted here for text
%		text = 'ttt',   				I build {'ttt'}
%		text={'ttt','r'}, 				OK
%		text{1}='ttt', text{2}='r', 	OK
% 		text = {{'ttt'}} 				I build {'ttt'}

% an error is using
% text = {{'ttt','yyy'}}, only the ttt text is considered

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%



if ischar(text) % text is 'rrr'
	final_text{1} = text;
else
	% we have cells
	for iq = 1:length(text)  % for ecah text{iq}, i want only 'ttt'
		% making it sure format of text is OK
		temp_text = text{iq};
		while iscell(temp_text) % it should be a string 'ttt'
			temp_text  = temp_text{1}; % going from cell toward string
		end
		final_text{iq} = temp_text;
	end
end
[wrapped_text, position]  = textwrap(handle,final_text);
