function [pin] = get_ind_object(object,one)
% open a figure UR, list exisiting object, let you select one or many
% give back list of pin of seleted ones
% close the figure
% pin is [p i n ; p i n ; p i n ; ...]
% output pin = [] = I cancelled
%
%   Version : Nov, 15,03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global frame structure mapping attribute variable belief
global pin_frame pin_structure pin_attribute pin_variable 
global pin_mapping pin_belief
global gui_position  figure_data  flags flag_str help_level help_label

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get the figure
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_fig = figure(...
'name','Query window');
set(gcf,'position',gui_position(:,5));
ind_fig = length(figure_data) + 1;
figure_data(ind_fig).name = 'Querry window';
figure_data(ind_fig).handle = hd_fig;
figure_data(ind_fig).position = gui_position(:,5);

hd_help = forced_display_help(0,58);

% listing all objects
hd_list = listing_existing(object, gui_position(:,7), hd_fig);
switch one
case 'one'
	select_list(hd_list,'on','one');
plural = '.';	
case 'many'
	select_list(hd_list,'on','many');	
	plural = 's.';
end

% box with button
text = ['Selet ',one,' ',object,plural];
choice = text_with_n_buttons(hd_fig,text,{'Done','Cancel'}, [1]);
if choice == 1
p = get(hd_list(2),'value');
pin(:,1) = p';
pin(:,3) = pin_manipulation(object,'pos2num',p)';
pin(:,2) = pin_manipulation(object,'pos2ind',p)';
else
	pin = [];
end

delete(hd_fig)
delete(hd_help)
figure_data(ind_fig) = [];



