function callback_help_menu(option,help_numbers,hd_fig)
% the callback for the menu help attached to every window except Root Window
% option 
% 	1 turn  Window Help On + show text, for normal use
%	2 turn  Window Help Off
%	3 turn    Button Helps On
% 	4 turn    Button Helps Off	
% 	5 = turn Window Help On + show text, for the case window hidden by other windows
% don't use 3 if you use dailog_panel as cconflict for PC

% callback_help_menu_bp is what replace me for 1,2,5
% I am called only by   window_name_help


%
%   Version : Mar. 16, 03.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

global hd_help_object hd_help_menu name_calling_window menu_type
global help_level 

ind = size(hd_help_menu,1);

switch option

case {1,5} % turn Window Help On + show text
	% the view option  (1 for normal use, 5 for the case window hidden by other windows
	gcfm = gcf;
	if hd_help_object(ind) == -1  % = first time I enter here in this window context
		help_level_mem = help_level;
		help_level = 1; % I must put help level = 1 in order help to be displayed
		hd_help_object(ind) = display_helps(0,[help_numbers]);
		% display_helps put the Root Window in front with a help text
		help_level = help_level_mem;			
	else
		set(hd_help_object(ind),'visible','on');
	end
	
	% I make view off and hide on	
	i = find(strcmp({menu_type{ind,:}},'Window Helps On'));
	if ~isempty(i)
		set(hd_help_menu(ind,i),'enable','off'); % Window Helps On 
		set(hd_help_menu(ind,i+1),'enable','on');  % Window Helps Off
	end
	
	figure(gcfm); % text visible, I go back where I came from
	if strcmp(name_calling_window(ind), 'Full Screen General Window') | option == 5
		figure(get(hd_help_object(ind),'parent')) 
		% to be sure it is in front when hidden by gcfm
		% thus when gcfm = 'Full Screen General Window'
		set(hd_help_menu(ind,2),'enable','on');
		% I keep menu view on so I can get to it using menu eventhough hidden by other window
	end

case 2 % turn Window Help Off
	if ishandle(hd_help_object(ind))
		set(hd_help_object(ind),'visible','off') % text is not visible
	end

	hd_menu= hd_help_menu(ind,:);
	
	i = find(strcmp({menu_type{ind,:}},'Window Helps Off'));
	if ~isempty(i)
		set(hd_help_menu(ind,i-1),'enable','on'); % view on
		set(hd_help_menu(ind,i),'enable','off'); % hide off
	end

	% if there is another Root Window I put it in front
	% their possible names are Alternate Root Window and Alternate Root Window 2	
	hd_child = get(0,'children');
	for i = 1:length(hd_child)
		child_name = get(hd_child(i),'name');
		if strcmp(child_name,'Alternate Root Window 2')
			figure(hd_child(i));
		elseif strcmp(child_name,'Alternate Root Window')
			figure(hd_child(i));
		end	
	end	

case 3 % turn   Button Helps On
	% 	help_level_mem = help_level; 
	% 	help_level = 2; % max
	
	% as per now, I forgot to use the option where help does not open buttons help when none
	
	i = find(strcmp({menu_type{ind,:}},'Button Helps On'));
	if ~isempty(i)
		set(hd_help_menu(ind,i),'enable','off'); 	% for  Button Helps On
		set(hd_help_menu(ind,i+1),'enable','on');		% for  Button Helps Off
	end
	% putting menu on/off
	% 	for i = 1:size(hd_help_menu,1)
	% 		set(hd_help_menu(i,7-help_level_mem),'enable','on')
	% 		set(hd_help_menu(i,5),'enable','off')
	% 	end	
	% finding all the panels and their button handles
	
	hd_frames_mem  = intersect (findobj('style','frame'), get(gcf,'children'));
	hd_buttons_all = intersect (findobj('style','pushbutton'), get(gcf,'children'));
	% a pushbutton is always in a frame, 
	% several pushbutton per frame, and maybe several frames
	% finding which buttons belong to which panels
	j_mem = 0;
	for j = 1:length(hd_frames_mem)		
		if ~isempty(get(hd_frames_mem(j),'tag'))
			j_mem = j_mem + 1;
			index_set_but(j_mem) = str2num(get(hd_frames_mem(j),'tag'));
			hd_frames(j_mem) = hd_frames_mem(j);
			hd_buttons{j_mem} = [];
		end
	end	

	for i = 1:length(hd_buttons_all)		
		x = get(hd_buttons_all(i),'position');
		for j = 1:length(hd_frames)
			y = get(hd_frames(j),'position');
			if x(1) >= y(1) & x(1)+x(3) <= y(1)+y(3) & x(2) >= y(2) & x(2)+x(4) <= y(2)+y(4)
				% button in this panel
				hd_buttons{j} = [hd_buttons{j} hd_buttons_all(i)];
			end
		end
	end

	gcf_mem = gcf;
	
	
	
	
	wake_up_button_help(gcf,hd_buttons,index_set_but)
	
	
	
	
	figure(gcf_mem)	
	
case 4 % turn   Button Helps Off

	i = find(strcmp({menu_type{ind,:}},'Button Helps Off'));
	if ~isempty(i)
		set(hd_help_menu(ind,i-1),'enable','on'); 	% for  Button Helps On
		set(hd_help_menu(ind,i),'enable','off');	% for  Button Helps Off
	end

	set(gcf,'WindowButtonMotionFcn','')	
	delete(findobj('Userdata','button_long_helps'));
end
