function [out_choice,rect_pos] = select_rectangle
% select a rectangular subpart of seleted figure 

hdw = warndlg('Select rectangle: first upper left, then lower right');
uiwait(hdw)

n_crosses = 2;

go_on = 1;
while go_on
	fig_pos = get(gcf,'position');
	
	
	fig_pos = get(gca,'position');
	Xlim = get(gca,'Xlim');
	Ylim = get(gca,'Ylim');
	
	if n_crosses == 2
		% cross hair to enter one or two coordinates (upper left and lower right)
		[x,y] = ginput(n_crosses);  % data as Xlim Ylim units
		% position of the rectangle in gcf units for rrbox
		
		xx = fig_pos(1) + ((x' - Xlim(1))/(Xlim(2)-Xlim(1)))*fig_pos(3);
		y = flipud(y);
		yy = fig_pos(2) + ((y' - Ylim(1))/(Ylim(2)-Ylim(1)))*fig_pos(4);		
		rect_pos = [xx(1)  yy(1)   xx(2)-xx(1)   yy(2)-yy(1)];
	end

	% is rectangle OK?
	hd_rect = line([x(1) x(1) x(2) x(2) x(1)],[y(1) y(2) y(2) y(1) y(1)]);	
	text = 'Is this rectangle OK? You can re-do it.';
	button = {'OK','ReDo','Cancel'};
	choice = text_with_n_buttons(gcf, text, button, [0 0 0 0]);
	delete(hd_rect)
	
	switch choice
	case 1
		go_on = 0;
		out_choice = 'ok';
	case 2
		% redo = do nothing here
	case 3
		go_on = 0;
		out_choice = 'cancel';
	end	

end	
