function tbmlab(crash_option_in)
% the tbm_machine root

% Everything starts here
% You just call tbmlab in the MatLab Command Window and proceed.
% Normalu you don't put any parameter to tbmlab.
% tbmlab(0) : only to get a nice and full trace of the reason for a crash when it occurs


% What I do:
% close all previous windows,
% call 
% 	- init_global_variables that clears previous left over global 
%	_ global variables initialisation
% 	- setting_gui_default_values initiates the gui default values
% 	- init_stored_texts loads all the help texts
% 	- gui_position where location of gui objects are stored
% 	- run_initiating_all_objects where things really start

%
%   Version : Oct 25,02.
%   Copyright (c) 2002 by Philippe Smets, Brussels, Belgium.
% 	Author: Philippe Smets
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% closing all past windows that might have survived
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all force

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% creating paths if not already done
% If not done, all I have is a path to tbmlab
% if done there are MAQNY paths and I just check that GUI_Lib exists
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fp = which('tbmlab');
pathname2TBMLABversNow = strrep(fp,[filesep,'tbmlab.m'],'');
cd(pathname2TBMLABversNow);
p = lower(path); % I get all path
k = findstr(p,['gui_lib']);

if isempty(k)
	disp('Be patient: I build the paths')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp(' ')
	disp('The paths indicating to MatLab the positions of the functions were not yet built. I build them. Be patient.')
	dirInit = [pathname2TBMLABversNow,filesep,'Function_Lib',filesep,'Fcn_Utilities',filesep,'Path_Handling'];
	path(dirInit,p);
	feval('set_all_paths')
	disp('All paths built. They are NOT saved. Saving them is a good idea.')
	disp('I quit this run. Rerun tbmlab')
	disp(' ')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
	return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initiated the global variables
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

init_global_variables % beware we clear all global here
global pathname2TBMLABvers  screen_size gui_settings   my_font
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get screen size
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wanted_screen_size

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get fanbcy title
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hd_title = tbmlab_title;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% finding the path to TBMLAB_Folder, by default in toolbox, but may be any where
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

build_pathname

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% handling debug modes
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% dbclear all  % so no left over debug stops
% dbstop if error 
% so when error, we are on commnad window with K>> 
% user MUST type dbstack to know where error occured
% and then return to get back to catch part of program that close all windows

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initiated the global variables
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global crash_option % must be behind init_global_variables, otherwise delete

if nargin == 0
	crash_option = 1; % I use it in every menu and overall
elseif crash_option_in == 0
	crash_option = 0; 
	% when 0, we don't use try catch, so we get nice error trace
else 
	crash_option = 1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initiating the GUI default parameters
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

setting_gui_default_values

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% checking preqrequisite for TBMLAB
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

out = checking_prerequisite;
if out == 1
	return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% get last preferences parameters if exits
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

run_preferences('initialization')

disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
disp('XXXXXXXX   For developper: Default GUI    XXXXX')
disp(' ')

for i = 1:length(gui_settings.pn_mem)
	fprintf(1,'Field   %s = ', gui_settings.pn_mem{i})
	if isnumeric(get(0,gui_settings.pn_mem{i}))
		fprintf(1,'%g ',get(0,gui_settings.pn_mem{i}))
		fprintf(1,', memory value ',[])
		fprintf(1,'%g ',gui_settings.pv0_mem{1,i})
		fprintf(1,'\n',[])
	else
		fprintf(1,'%s ',get(0,gui_settings.pn_mem{i}))
		fprintf(1,', memory value = %s \n',gui_settings.pv0_mem{1,i})
	end
end
fprintf(1,'font name for title = %s\n',my_font.title.name)
fprintf(1,'font size for title = %g\n',my_font.title.size)
disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting all the help texts
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

init_stored_texts % output in global stored_text{.}{.}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% getting the gui positions
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

gui_position_setting

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% closing the title
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

uiwait(hd_title)
delete(hd_title)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% initiating objects: from frame to 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if crash_option == 1
	try		
		% amazing it does not work, I don't go in dbmode when error even here
		% 	fprintf(1,'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n',[]);
		% 	fprintf(1,'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n',[]);
		% 	fprintf(1,'XXXXXXXX          What to do if CRASH          XXXXXXXXX\n',[]);
		% 	fprintf(1,'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n',[]);
		% 	fprintf(1,'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n',[]);
		% 	fprintf(1,'\nOn Matlab Command Window, you will see K>> Type dbstack and you will get the trace of the error\n',[]);
		% 	fprintf(1,'Then you type return (the 6 letters), and you are back to Matlab (if not, repeat it).\n\n',[]);
		% 
		run_initiating_TBM 
		clear global		
	catch
		dbstack
		% it must be also defined for every menu
		crash_closing('TBMLAB')
		clear global
		close all force		
	end	
else 
	run_initiating_TBM % this is where I am really during the whole process
	clear global	
end
close all force % I need it as the uiresume used after quitting reopen a figure
